#!/usr/bin/perl -w

package backup;

my $tmp_dir="/var/tmp/backup.$$";
my @files=();
if( -d "/var/spool/asterisk/ivr") {
  push @files,"/var/spool/asterisk/ivr";
}

sub error($$) {
  my ( $msg, $num ) = @_;
  print "Content-type: text/html\n";
  print "\n";
  print "\n";
  print "<html><head><title>Error creating backup</title></head>\n";
  print "<body><h1>".$msg."</h1>\n";
  print "<p>Return code ".$num."</body>\n";

  unlink "$tmp_dir/ivr.tgz";
  unlink "$tmp_dir/log.txt";
  rmdir $tmp_dir;

  exit 0;
}

mkdir $tmp_dir;

print "X-Keepalive: ping $$\n";
$res=system("/bin/tar czf $tmp_dir/ivr.tgz ".(join " ",@files)."  2>>$tmp_dir/log.txt");
error("Failed to save ivr files",$res) if( $res );

unlink "/var/www/html/backup/ivr.tgz";
rename "$tmp_dir/ivr.tgz", "/var/www/html/backup/ivr.tgz";

print "Content-type: text/plain\n";
print "\nOK\n";

unlink "$tmp_dir/ivr.tgz";
unlink "$tmp_dir/log.txt";
rmdir $tmp_dir;

exit 0;
