#!/usr/bin/perl -w

use strict;
use Net::LDAP;

print "Content-type: text/html\n\n";

my $request = $ENV{REQUEST_URI} || "";

if( $request =~ /^\/cgi-bin\/ldap.pl\?dn=(.*),srv=(.*),usr=(.*),pwd=(.*),ftr=(.*)/ ) {
	my $domain = $1;
	my $server = $2;
	my $user = $3;
	my $pass = $4;
	my $filter = $5;
	my $error;

	my $ldap = Net::LDAP->new($server) or print "FAIL|No route to host!||\n";
	my $ldapmsg = $ldap->bind($user, password => $pass); 
	if( $ldapmsg->is_error() ) {
		print "FAIL|Authentication failed!||\n"; 
		exit;
	}
	my $query = $ldap->search(base => $domain, filter => $filter); 
	if( $query->code() ) {
	        (my $error = $query->error()) =~ s/[^\w!?:"'-_.,]/ /g;
		print "FAIL|Search failed!<br>LDAP reports: $error||\n";
		exit;
	}
	my $count = $query->count();
	my $entry;
	my $result;
	for (my $i = 0; $i < $query->count; $i++) {
		$entry = $query->entry($i);
		$result .= "OK|".$entry->get_value('cn')."|". $entry->get_value('telephonenumber')."|".$entry->get_value('mail')."\n";
	}
	
	if( defined $result ) {
		print "$result\n";
        } else {
		print "FAIL|No results!||\n";
	}

	$ldap->unbind();
}

