#!/usr/bin/perl -w

use strict;
use Time::Local;
use Cwd;

my $tempfile = "/var/tmp/mon$$.lst";
open TEMP,">",$tempfile or exit -1;
my $zip = 0;
if( $ENV{REQUEST_URI} =~ /\.zip/ ) {
  $zip = 1;
}

if( $zip == 1 ) {
	print "Content-Type: application/zip\r\n";
} else {
	print "Content-Type: application/x-gzip\r\n";
}
print "Accept-Ranges: none\r\n\r\n";

chdir "/var/spool/asterisk" or exit -1;

my @today = localtime(time);
my @yeste = localtime(time-86400);
my @week1 = localtime(time-(86400*7));
my @week2 = localtime(time-(86400*14));
my @week3 = localtime(time-(86400*21));
my @week4 = localtime(time-(86400*28));

my $today = timelocal(0,0,0,@today[3..5]);
my $yeste = timelocal(0,0,0,@yeste[3..5]);
my $week1 = timelocal(0,0,0,@week1[3..5]);
my $week2 = timelocal(0,0,0,@week2[3..5]);
my $week3 = timelocal(0,0,0,@week3[3..5]);
my $week4 = timelocal(0,0,0,@week4[3..5]);

my $start = 0;	# Deafult to all files
my $end = time;

if( $ENV{REQUEST_URI} =~ /\/tt\// ) { $start = $today; }
if( $ENV{REQUEST_URI} =~ /\/ty\// ) { $start = $yeste; $end = $today; }
if( $ENV{REQUEST_URI} =~ /\/t1\// ) { $start = $week1; $end = $today; }
if( $ENV{REQUEST_URI} =~ /\/t2\// ) { $start = $week2; $end = $week1; }
if( $ENV{REQUEST_URI} =~ /\/t3\// ) { $start = $week3; $end = $week2; }
if( $ENV{REQUEST_URI} =~ /\/t4\// ) { $start = $week4; $end = $week3; }

foreach my $f ( glob "monitor/*.wav" ) {
	next if( $f =~ /.*-(in|out).wav$/ );
	(my $fdate = $f) =~ s/^[^-]+-(\d+)-[^-]*-[^-]*.*$/$1/;
	next if( $fdate !~ /^\d+$/ );
	if( $end > $fdate && $fdate >= $start ) { print TEMP $f."\n"; }
}
close TEMP;

if( $zip == 1 ) {
	# print "nice -n 19 /usr/bin/zip - -i -@ <".$tempfile."\n";
	# system("cat ".$tempfile);
	system("nice -n 19 /usr/bin/zip -4 - -i -@ <".$tempfile." 2>/dev/null");
} else {
	system("nice -n 19 /bin/tar -c -f - -T ".$tempfile." 2>/dev/null | nice -n 19 gzip -4 2>/dev/null");
}
unlink $tempfile;
exit 0;

