#!/bin/sh
# Do Not use this script *EVER* on a box which has INTERFACE address assigned by DHCP
# Bad Things WILL happen.
INTERFACE=eth0
TMPFILE=/tmp/sanity$$
echo timeout 2\; >${TMPFILE}.conf
DHCLIENT="echo sudo /sbin/dhclient"
$DHCLIENT -q -r -sf /bin/true -pf /tmp/dhclient.pid $INTERFACE
EXCLUDE=""
HOSTS=""
NAMESERVERS=""
SCRIPT=/var/www/html/config/scripts/dhclient-script
cat >$TMPFILE
cat /dev/null >$TMPFILE
echo "Content-Type: text/plain
"
echo "
"
# A sucessful dhcp lease acquisition will always result in a server 
# identifier, a failed one never will, so loop until we fail
RES="server_identifier"
echo -n 'dhcp_servers=[ '
$DHCLIENT -q -r -sf /bin/true -pf /tmp/dhclient.pid $INTERFACE
while echo $RES | grep -q server_identifier
do
	$DHCLIENT -q -1 -cf ${TMPFILE}.conf -sf $SCRIPT -pf /tmp/dhclient.pid \
		-R subnet-mask,domain-name,domain-name-servers,tftp-server-name\
		 $INTERFACE >$TMPFILE 2>&1
	$DHCLIENT -q -r -sf /bin/true -pf /tmp/dhclient.pid $INTERFACE
# Pull in local variables from dhclient-script
	cat ${TMPFILE} | grep '^LOCAL_' >${TMPFILE}.local
	. ${TMPFILE}.local
	rm -f ${TMPFILE}.local
# Now add a reject statement to our temp dhclient.conf to ensure we ignore
#  this server next time through the loop
	echo reject $LOCAL_SERVER_IDENTIFIER\; >>${TMPFILE}.conf
#Get nameservers and TFTP server option from this server
	NAMESERVERS="$NAMESERVERS $LOCAL_NAME_SERVERS"
	HOSTS="$HOSTS $LOCAL_CONFIG_HOST"
# Null these out for next time around
	LOCAL_NAME_SERVERS=""
	LOCAL_CONFIG_HOST=""
	LOCAL_SERVER_IDENTIFIER=""
# Get the non-local variables (wb js) into a RES variable and output
	RES=`cat $TMPFILE | grep -v '^LOCAL_'`
	if [ "X$RES" != "X" ]; then
	 	echo -n $RES,
	fi
done
# End of DHCP servers
echo '];'

# Now what do all of the DNS servers think of the names we have received
#  from all the DHCP servers?
echo -n dns_result=\[
        for DNS_SERVER in $NAMESERVERS
        do
		SEEN=""
		for HOST in $HOSTS
		do
			if ! echo $SEEN | grep -q $HOST; then
                	echo -n \{server:\"$DNS_SERVER\", query:\"$HOST\",\ 
                	echo -n result:\"
                	echo -n `host -4 -W 2 $HOST $DNS_SERVER | grep "has address"| sed -e 's/.*has address //'`\"},
			fi
			SEEN="$SEEN $HOST"
		done
        done
echo \]\;

rm -f ${TMPFILE} ${TMPFILE}.conf
