<rb:script src="/config/asterisk.js"/>
<rb:script>
function do_phone_config(row) {
  var pblock = rb.xml.root.findId(row.phone_type);
  if( pblock == null || pblock.length < 1 )
    return -1;

  mac = row.mac;
  phone_name = row.name.toLowerCase().replace(/[^a-z0-9\-]/g,'-');
  base_login = identify_login(row.mac,row.port);
  base_mailbox = identify_mailbox(row.mac,row.port);
  base_password = row.pass;
  if( base_password == null || base_password.length < 1 )
    base_password=phone_setpass(row.mac,row.port);

  var ltext = pblock[0].execute().bodytext();

  rb.page.setMimeType("text/xml");
  rb.page.sendHTTPheaders();
  rb.page.writeraw(ltext);

  return 0;
}

</rb:script>

<rb:block rb:id="Cisco7941">
<device>
  <deviceProtocol>SIP</deviceProtocol>
  <sshUserId>root</sshUserId>
  <sshPassword><?= DB.get_attrib("phone_admin_password","admin") ?></sshPassword>
  <devicePool>
     <dateTimeSetting>
        <dateTemplate>D-M-YA</dateTemplate>
        <timeZone>GMT Standard/Daylight Time</timeZone>
        <ntps>
          <ntp>
            <name><?= DB.get_attrib("hostname") ?></name>
            <ntpMode>Unicast</ntpMode>
          </ntp>
        </ntps>
     </dateTimeSetting>
     <callManagerGroup>
        <members>
           <member priority="0">
              <callManager>
                 <ports>
                    <ethernetPhonePort>2000</ethernetPhonePort>
                    <sipPort>5060</sipPort>
                    <securedSipPort>5061</securedSipPort>
                 </ports>
                 <processNodeName><?= DB.get_attrib("hostname") ?></processNodeName>
              </callManager>
           </member>
        </members>
     </callManagerGroup>
  </devicePool>
  <sipProfile>
     <sipProxies>
        <registerWithProxy>true</registerWithProxy>
     </sipProxies>
     <sipCallFeatures>
        <cnfJoinEnabled>true</cnfJoinEnabled>
        <callForwardURI>x--serviceuri-cfwdall</callForwardURI>
        <callPickupURI>x-cisco-serviceuri-pickup</callPickupURI>
        <callPickupListURI>x-cisco-serviceuri-opickup</callPickupListURI>
        <callPickupGroupURI>x-cisco-serviceuri-gpickup</callPickupGroupURI>
        <meetMeServiceURI>x-cisco-serviceuri-meetme</meetMeServiceURI>
        <abbreviatedDialURI>x-cisco-serviceuri-abbrdial</abbreviatedDialURI>
        <rfc2543Hold>false</rfc2543Hold>
        <callHoldRingback>2</callHoldRingback>
        <localCfwdEnable>true</localCfwdEnable>
        <semiAttendedTransfer>true</semiAttendedTransfer>
        <anonymousCallBlock>2</anonymousCallBlock>
        <callerIdBlocking>2</callerIdBlocking>
        <dndControl>0</dndControl>
        <remoteCcEnable>true</remoteCcEnable>
     </sipCallFeatures>
     <sipStack>
        <sipInviteRetx>6</sipInviteRetx>
        <sipRetx>10</sipRetx>
        <timerInviteExpires>180</timerInviteExpires>
        <timerRegisterExpires>3600</timerRegisterExpires>
        <timerRegisterDelta>5</timerRegisterDelta>
        <timerKeepAliveExpires>120</timerKeepAliveExpires>
        <timerSubscribeExpires>120</timerSubscribeExpires>
        <timerSubscribeDelta>5</timerSubscribeDelta>
        <timerT1>500</timerT1>
        <timerT2>4000</timerT2>
        <maxRedirects>70</maxRedirects>
        <remotePartyID>false</remotePartyID>
        <userInfo>None</userInfo>
     </sipStack>
     <autoAnswerTimer>1</autoAnswerTimer>
     <autoAnswerAltBehavior>false</autoAnswerAltBehavior>
     <autoAnswerOverride>true</autoAnswerOverride>
     <transferOnhookEnabled>false</transferOnhookEnabled>
     <enableVad>false</enableVad>
     <preferredCodec>g711a</preferredCodec>
     <dtmfAvtPayload>101</dtmfAvtPayload>
     <dtmfDbLevel>3</dtmfDbLevel>
     <dtmfOutofBand>avt</dtmfOutofBand>
     <alwaysUsePrimeLine>false</alwaysUsePrimeLine>
     <alwaysUsePrimeLineVoiceMail>false</alwaysUsePrimeLineVoiceMail>
     <kpml>3</kpml>
     <natEnabled>0</natEnabled>
     <natAddress></natAddress>
     <phoneLabel><?= base_login.slice(0,12) ?></phoneLabel>
     <stutterMsgWaiting>0</stutterMsgWaiting>
     <callStats>false</callStats>
     <silentPeriodBetweenCallWaitingBursts>10</silentPeriodBetweenCallWaitingBursts>
     <disableLocalSpeedDialConfig>false</disableLocalSpeedDialConfig>
     <startMediaPort>10000</startMediaPort>
     <stopMediaPort>20000</stopMediaPort>
     <sipLines>
        <line button="1">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[0] != null && base_mailbox[0].name != null ) ? base_mailbox[0].name : "Line 1" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login ?></name>
           <displayName><?= ( base_mailbox[0] != null && base_mailbox[0].name != null ) ? base_mailbox[0].name : "Line 1" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
        <line button="2">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[1] != null && base_mailbox[1].name != null ) ? base_mailbox[1].name : "Line 2" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login+"_2" ?></name>
           <displayName><?= ( base_mailbox[1] != null && base_mailbox[1].name != null ) ? base_mailbox[1].name : "Line 2" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login+"_2" ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login+"_2" ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
     </sipLines>
     <voipControlPort>5060</voipControlPort>
     <dscpForAudio>184</dscpForAudio>
     <ringSettingBusyStationPolicy>0</ringSettingBusyStationPolicy>
     <dialTemplate>dialPlan.xml</dialTemplate>
  </sipProfile>
  <commonProfile>
     <phonePassword>0000</phonePassword>
     <backgroundImageAccess>true</backgroundImageAccess>
     <callLogBlfEnabled>1</callLogBlfEnabled>
  </commonProfile>
  <loadInformation>cisco/7941/SIP41.8-0-2SR1S</loadInformation>
  <vendorConfig>
     <disableSpeaker>false</disableSpeaker>
     <disableSpeakerAndHeadset>false</disableSpeakerAndHeadset>
     <pcPort>1</pcPort>
     <settingsAccess>1</settingsAccess>
     <garp>0</garp>
     <voiceVlanAccess>0</voiceVlanAccess>
     <videoCapability>0</videoCapability>
     <autoSelectLineEnable>0</autoSelectLineEnable>
     <webAccess></webAccess>
     <spanToPCPort>1</spanToPCPort>
     <loggingDisplay>1</loggingDisplay>
     <loadServer><?= DB.get_attrib("hostname") ?></loadServer>
  </vendorConfig>
  <versionStamp><?= Math.floor(new Number(new Date()) /1000) ?>-a3cbf294-7526-4c29-8791-c4fce4ce4c37</versionStamp>
  <networkLocale>United_States</networkLocale>
  <networkLocaleInfo>
     <name>United_States</name>
     <version>5.0(2)</version>
  </networkLocaleInfo>
  <deviceSecurityMode>0</deviceSecurityMode>
  <dscpForSCCPPhoneConfig>96</dscpForSCCPPhoneConfig>
  <dscpForSCCPPhoneServices>0</dscpForSCCPPhoneServices>
  <dscpForCm2Dvce>96</dscpForCm2Dvce>
  <transportLayerProtocol>4</transportLayerProtocol>
  <capfAuthMode>0</capfAuthMode>
  <capfList>
     <capf>
        <phonePort>3804</phonePort>
     </capf>
  </capfList>
  <certHash></certHash>
  <encrConfig>false</encrConfig>
  <authenticationURL></authenticationURL>
  <directoryURL>http://<?= DB.get_attrib("hostname") ?>/config/cisco.whtm/d.xml</directoryURL>
  <idleURL></idleURL>
  <informationURL></informationURL>
  <messagesURL></messagesURL>
  <proxyServerURL></proxyServerURL>
  <servicesURL>http://<?= DB.get_attrib("hostname") ?>/config/cisco.whtm/d.xml</servicesURL> 
</device> 
</rb:block>

<rb:block rb:id="Cisco7961">
<device>
  <deviceProtocol>SIP</deviceProtocol>
  <sshUserId>root</sshUserId>
  <sshPassword><?= DB.get_attrib("phone_admin_password","admin") ?></sshPassword>
  <devicePool>
     <dateTimeSetting>
        <dateTemplate>D-M-YA</dateTemplate>
        <timeZone>GMT Standard/Daylight Time</timeZone>
        <ntps>
          <ntp>
            <name><?= DB.get_attrib("hostname") ?></name>
            <ntpMode>Unicast</ntpMode>
          </ntp>
        </ntps>
     </dateTimeSetting>
     <callManagerGroup>
        <members>
           <member priority="0">
              <callManager>
                 <ports>
                    <ethernetPhonePort>2000</ethernetPhonePort>
                    <sipPort>5060</sipPort>
                    <securedSipPort>5061</securedSipPort>
                 </ports>
                 <processNodeName><?= DB.get_attrib("hostname") ?></processNodeName>
              </callManager>
           </member>
        </members>
     </callManagerGroup>
  </devicePool>
  <sipProfile>
     <sipProxies>
        <registerWithProxy>true</registerWithProxy>
     </sipProxies>
     <sipCallFeatures>
        <cnfJoinEnabled>true</cnfJoinEnabled>
        <callForwardURI>x--serviceuri-cfwdall</callForwardURI>
        <callPickupURI>x-cisco-serviceuri-pickup</callPickupURI>
        <callPickupListURI>x-cisco-serviceuri-opickup</callPickupListURI>
        <callPickupGroupURI>x-cisco-serviceuri-gpickup</callPickupGroupURI>
        <meetMeServiceURI>x-cisco-serviceuri-meetme</meetMeServiceURI>
        <abbreviatedDialURI>x-cisco-serviceuri-abbrdial</abbreviatedDialURI>
        <rfc2543Hold>false</rfc2543Hold>
        <callHoldRingback>2</callHoldRingback>
        <localCfwdEnable>true</localCfwdEnable>
        <semiAttendedTransfer>true</semiAttendedTransfer>
        <anonymousCallBlock>2</anonymousCallBlock>
        <callerIdBlocking>2</callerIdBlocking>
        <dndControl>0</dndControl>
        <remoteCcEnable>true</remoteCcEnable>
     </sipCallFeatures>
     <sipStack>
        <sipInviteRetx>6</sipInviteRetx>
        <sipRetx>10</sipRetx>
        <timerInviteExpires>180</timerInviteExpires>
        <timerRegisterExpires>3600</timerRegisterExpires>
        <timerRegisterDelta>5</timerRegisterDelta>
        <timerKeepAliveExpires>120</timerKeepAliveExpires>
        <timerSubscribeExpires>120</timerSubscribeExpires>
        <timerSubscribeDelta>5</timerSubscribeDelta>
        <timerT1>500</timerT1>
        <timerT2>4000</timerT2>
        <maxRedirects>70</maxRedirects>
        <remotePartyID>false</remotePartyID>
        <userInfo>None</userInfo>
     </sipStack>
     <autoAnswerTimer>1</autoAnswerTimer>
     <autoAnswerAltBehavior>false</autoAnswerAltBehavior>
     <autoAnswerOverride>true</autoAnswerOverride>
     <transferOnhookEnabled>false</transferOnhookEnabled>
     <enableVad>false</enableVad>
     <preferredCodec>g711a</preferredCodec>
     <dtmfAvtPayload>101</dtmfAvtPayload>
     <dtmfDbLevel>3</dtmfDbLevel>
     <dtmfOutofBand>avt</dtmfOutofBand>
     <alwaysUsePrimeLine>false</alwaysUsePrimeLine>
     <alwaysUsePrimeLineVoiceMail>false</alwaysUsePrimeLineVoiceMail>
     <kpml>3</kpml>
     <natEnabled>0</natEnabled>
     <natAddress></natAddress>
     <phoneLabel><?= base_login.slice(0,12) ?></phoneLabel>
     <stutterMsgWaiting>0</stutterMsgWaiting>
     <callStats>false</callStats>
     <silentPeriodBetweenCallWaitingBursts>10</silentPeriodBetweenCallWaitingBursts>
     <disableLocalSpeedDialConfig>false</disableLocalSpeedDialConfig>
     <startMediaPort>10000</startMediaPort>
     <stopMediaPort>20000</stopMediaPort>
     <sipLines>
        <line button="1">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[0] != null && base_mailbox[0].name != null ) ? base_mailbox[0].name : "Line 1" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login ?></name>
           <displayName><?= ( base_mailbox[0] != null && base_mailbox[0].name != null ) ? base_mailbox[0].name : "Line 1" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
        <line button="2">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[1] != null && base_mailbox[1].name != null ) ? base_mailbox[1].name : "Line 2" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login+"_2" ?></name>
           <displayName><?= ( base_mailbox[1] != null && base_mailbox[1].name != null ) ? base_mailbox[1].name : "Line 2" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login+"_2" ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login+"_2" ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
        <line button="3">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[2] != null && base_mailbox[2].name != null ) ? base_mailbox[2].name : "Line 3" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login+"_3" ?></name>
           <displayName><?= ( base_mailbox[2] != null && base_mailbox[2].name != null ) ? base_mailbox[2].name : "Line 3" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login+"_3" ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login+"_3" ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
        <line button="4">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[3] != null && base_mailbox[3].name != null ) ? base_mailbox[3].name : "Line 4" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login+"_4" ?></name>
           <displayName><?= ( base_mailbox[3] != null && base_mailbox[3].name != null ) ? base_mailbox[3].name : "Line 4" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login+"_4" ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login+"_4" ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
        <line button="5">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[4] != null && base_mailbox[4].name != null ) ? base_mailbox[4].name : "Line 5" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login+"_5" ?></name>
           <displayName><?= ( base_mailbox[4] != null && base_mailbox[4].name != null ) ? base_mailbox[4].name : "Line 5" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login+"_5" ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login+"_5" ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
        <line button="6">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[5] != null && base_mailbox[5].name != null ) ? base_mailbox[5].name : "Line 6" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login+"_6" ?></name>
           <displayName><?= ( base_mailbox[5] != null && base_mailbox[5].name != null ) ? base_mailbox[5].name : "Line 6" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login+"_6" ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login+"_6" ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
     </sipLines>
     <voipControlPort>5060</voipControlPort>
     <dscpForAudio>184</dscpForAudio>
     <ringSettingBusyStationPolicy>0</ringSettingBusyStationPolicy>
     <dialTemplate>dialPlan.xml</dialTemplate>
  </sipProfile>
  <commonProfile>
     <phonePassword>0000</phonePassword>
     <backgroundImageAccess>true</backgroundImageAccess>
     <callLogBlfEnabled>1</callLogBlfEnabled>
  </commonProfile>
  <loadInformation>cisco/7961/SIP41.8-0-2SR1S</loadInformation>
  <vendorConfig>
     <disableSpeaker>false</disableSpeaker>
     <disableSpeakerAndHeadset>false</disableSpeakerAndHeadset>
     <pcPort>1</pcPort>
     <settingsAccess>1</settingsAccess>
     <garp>0</garp>
     <voiceVlanAccess>0</voiceVlanAccess>
     <videoCapability>0</videoCapability>
     <autoSelectLineEnable>0</autoSelectLineEnable>
     <webAccess></webAccess>
     <spanToPCPort>1</spanToPCPort>
     <loggingDisplay>1</loggingDisplay>
     <loadServer><?= DB.get_attrib("hostname") ?></loadServer>
  </vendorConfig>
  <versionStamp><?= Math.floor(new Number(new Date()) /1000) ?>-a3cbf294-7526-4c29-8791-c4fce4ce4c37</versionStamp>
  <networkLocale>United_States</networkLocale>
  <networkLocaleInfo>
     <name>United_States</name>
     <version>5.0(2)</version>
  </networkLocaleInfo>
  <deviceSecurityMode>0</deviceSecurityMode>
  <dscpForSCCPPhoneConfig>96</dscpForSCCPPhoneConfig>
  <dscpForSCCPPhoneServices>0</dscpForSCCPPhoneServices>
  <dscpForCm2Dvce>96</dscpForCm2Dvce>
  <transportLayerProtocol>4</transportLayerProtocol>
  <capfAuthMode>0</capfAuthMode>
  <capfList>
     <capf>
        <phonePort>3804</phonePort>
     </capf>
  </capfList>
  <certHash></certHash>
  <encrConfig>false</encrConfig>
  <authenticationURL></authenticationURL>
  <directoryURL>http://<?= DB.get_attrib("hostname") ?>/config/cisco.whtm/d.xml</directoryURL>
  <idleURL></idleURL>
  <informationURL></informationURL>
  <messagesURL></messagesURL>
  <proxyServerURL></proxyServerURL>
  <servicesURL>http://<?= DB.get_attrib("hostname") ?>/config/cisco.whtm/d.xml</servicesURL> 
</device> 
</rb:block>

<rb:block rb:id="Cisco7941-821">
<device>
  <deviceProtocol>SIP</deviceProtocol>
  <sshUserId>root</sshUserId>
  <sshPassword><?= DB.get_attrib("phone_admin_password","admin") ?></sshPassword>
  <devicePool>
     <dateTimeSetting>
        <dateTemplate>D-M-YA</dateTemplate>
        <timeZone>GMT Standard/Daylight Time</timeZone>
        <ntps>
          <ntp>
            <name><?= DB.get_attrib("hostname") ?></name>
            <ntpMode>Unicast</ntpMode>
          </ntp>
        </ntps>
     </dateTimeSetting>
     <callManagerGroup>
        <members>
           <member priority="0">
              <callManager>
                 <ports>
                    <ethernetPhonePort>2000</ethernetPhonePort>
                    <sipPort>5060</sipPort>
                    <securedSipPort>5061</securedSipPort>
                 </ports>
                 <processNodeName><?= DB.get_attrib("hostname") ?></processNodeName>
              </callManager>
           </member>
        </members>
     </callManagerGroup>
  </devicePool>
  <sipProfile>
     <sipProxies>
        <registerWithProxy>true</registerWithProxy>
     </sipProxies>
     <sipCallFeatures>
        <cnfJoinEnabled>true</cnfJoinEnabled>
        <callForwardURI>x--serviceuri-cfwdall</callForwardURI>
        <callPickupURI>x-cisco-serviceuri-pickup</callPickupURI>
        <callPickupListURI>x-cisco-serviceuri-opickup</callPickupListURI>
        <callPickupGroupURI>x-cisco-serviceuri-gpickup</callPickupGroupURI>
        <meetMeServiceURI>x-cisco-serviceuri-meetme</meetMeServiceURI>
        <abbreviatedDialURI>x-cisco-serviceuri-abbrdial</abbreviatedDialURI>
        <rfc2543Hold>false</rfc2543Hold>
        <callHoldRingback>2</callHoldRingback>
        <localCfwdEnable>true</localCfwdEnable>
        <semiAttendedTransfer>true</semiAttendedTransfer>
        <anonymousCallBlock>2</anonymousCallBlock>
        <callerIdBlocking>2</callerIdBlocking>
        <dndControl>0</dndControl>
        <remoteCcEnable>true</remoteCcEnable>
     </sipCallFeatures>
     <sipStack>
        <sipInviteRetx>6</sipInviteRetx>
        <sipRetx>10</sipRetx>
        <timerInviteExpires>180</timerInviteExpires>
        <timerRegisterExpires>3600</timerRegisterExpires>
        <timerRegisterDelta>5</timerRegisterDelta>
        <timerKeepAliveExpires>120</timerKeepAliveExpires>
        <timerSubscribeExpires>120</timerSubscribeExpires>
        <timerSubscribeDelta>5</timerSubscribeDelta>
        <timerT1>500</timerT1>
        <timerT2>4000</timerT2>
        <maxRedirects>70</maxRedirects>
        <remotePartyID>false</remotePartyID>
        <userInfo>None</userInfo>
     </sipStack>
     <autoAnswerTimer>1</autoAnswerTimer>
     <autoAnswerAltBehavior>false</autoAnswerAltBehavior>
     <autoAnswerOverride>true</autoAnswerOverride>
     <transferOnhookEnabled>false</transferOnhookEnabled>
     <enableVad>false</enableVad>
     <preferredCodec>g711a</preferredCodec>
     <dtmfAvtPayload>101</dtmfAvtPayload>
     <dtmfDbLevel>3</dtmfDbLevel>
     <dtmfOutofBand>avt</dtmfOutofBand>
     <alwaysUsePrimeLine>false</alwaysUsePrimeLine>
     <alwaysUsePrimeLineVoiceMail>false</alwaysUsePrimeLineVoiceMail>
     <kpml>3</kpml>
     <natEnabled>0</natEnabled>
     <natAddress></natAddress>
     <phoneLabel><?= base_login.slice(0,12) ?></phoneLabel>
     <stutterMsgWaiting>0</stutterMsgWaiting>
     <callStats>false</callStats>
     <silentPeriodBetweenCallWaitingBursts>10</silentPeriodBetweenCallWaitingBursts>
     <disableLocalSpeedDialConfig>false</disableLocalSpeedDialConfig>
     <startMediaPort>10000</startMediaPort>
     <stopMediaPort>20000</stopMediaPort>
     <sipLines>
        <line button="1">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[0] != null && base_mailbox[0].name != null ) ? base_mailbox[0].name : "Line 1" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login ?></name>
           <displayName><?= ( base_mailbox[0] != null && base_mailbox[0].name != null ) ? base_mailbox[0].name : "Line 1" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
        <line button="2">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[1] != null && base_mailbox[1].name != null ) ? base_mailbox[1].name : "Line 2" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login+"_2" ?></name>
           <displayName><?= ( base_mailbox[1] != null && base_mailbox[1].name != null ) ? base_mailbox[1].name : "Line 2" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login+"_2" ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login+"_2" ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
     </sipLines>
     <voipControlPort>5060</voipControlPort>
     <dscpForAudio>184</dscpForAudio>
     <ringSettingBusyStationPolicy>0</ringSettingBusyStationPolicy>
     <dialTemplate>dialPlan.xml</dialTemplate>
  </sipProfile>
  <commonProfile>
     <phonePassword>0000</phonePassword>
     <backgroundImageAccess>true</backgroundImageAccess>
     <callLogBlfEnabled>1</callLogBlfEnabled>
  </commonProfile>
  <loadInformation>cisco/7941/SIP41.8-2-1S</loadInformation>
  <vendorConfig>
     <disableSpeaker>false</disableSpeaker>
     <disableSpeakerAndHeadset>false</disableSpeakerAndHeadset>
     <pcPort>1</pcPort>
     <settingsAccess>1</settingsAccess>
     <garp>0</garp>
     <voiceVlanAccess>0</voiceVlanAccess>
     <videoCapability>0</videoCapability>
     <autoSelectLineEnable>0</autoSelectLineEnable>
     <webAccess></webAccess>
     <spanToPCPort>1</spanToPCPort>
     <loggingDisplay>1</loggingDisplay>
     <loadServer><?= DB.get_attrib("hostname") ?></loadServer>
  </vendorConfig>
  <versionStamp><?= Math.floor(new Number(new Date()) /1000) ?>-a3cbf294-7526-4c29-8791-c4fce4ce4c37</versionStamp>
  <networkLocale>United_States</networkLocale>
  <networkLocaleInfo>
     <name>United_States</name>
     <version>5.0(2)</version>
  </networkLocaleInfo>
  <deviceSecurityMode>0</deviceSecurityMode>
  <dscpForSCCPPhoneConfig>96</dscpForSCCPPhoneConfig>
  <dscpForSCCPPhoneServices>0</dscpForSCCPPhoneServices>
  <dscpForCm2Dvce>96</dscpForCm2Dvce>
  <transportLayerProtocol>4</transportLayerProtocol>
  <capfAuthMode>0</capfAuthMode>
  <capfList>
     <capf>
        <phonePort>3804</phonePort>
     </capf>
  </capfList>
  <certHash></certHash>
  <encrConfig>false</encrConfig>
  <authenticationURL></authenticationURL>
  <directoryURL>http://<?= DB.get_attrib("hostname") ?>/config/cisco.whtm/d.xml</directoryURL>
  <idleURL></idleURL>
  <informationURL></informationURL>
  <messagesURL></messagesURL>
  <proxyServerURL></proxyServerURL>
  <servicesURL>http://<?= DB.get_attrib("hostname") ?>/config/cisco.whtm/d.xml</servicesURL> 
</device> 
</rb:block>

<rb:block rb:id="Cisco7961-821">
<device>
  <deviceProtocol>SIP</deviceProtocol>
  <sshUserId>root</sshUserId>
  <sshPassword><?= DB.get_attrib("phone_admin_password","admin") ?></sshPassword>
  <devicePool>
     <dateTimeSetting>
        <dateTemplate>D-M-YA</dateTemplate>
        <timeZone>GMT Standard/Daylight Time</timeZone>
        <ntps>
          <ntp>
            <name><?= DB.get_attrib("hostname") ?></name>
            <ntpMode>Unicast</ntpMode>
          </ntp>
        </ntps>
     </dateTimeSetting>
     <callManagerGroup>
        <members>
           <member priority="0">
              <callManager>
                 <ports>
                    <ethernetPhonePort>2000</ethernetPhonePort>
                    <sipPort>5060</sipPort>
                    <securedSipPort>5061</securedSipPort>
                 </ports>
                 <processNodeName><?= DB.get_attrib("hostname") ?></processNodeName>
              </callManager>
           </member>
        </members>
     </callManagerGroup>
  </devicePool>
  <sipProfile>
     <sipProxies>
        <registerWithProxy>true</registerWithProxy>
     </sipProxies>
     <sipCallFeatures>
        <cnfJoinEnabled>true</cnfJoinEnabled>
        <callForwardURI>x--serviceuri-cfwdall</callForwardURI>
        <callPickupURI>x-cisco-serviceuri-pickup</callPickupURI>
        <callPickupListURI>x-cisco-serviceuri-opickup</callPickupListURI>
        <callPickupGroupURI>x-cisco-serviceuri-gpickup</callPickupGroupURI>
        <meetMeServiceURI>x-cisco-serviceuri-meetme</meetMeServiceURI>
        <abbreviatedDialURI>x-cisco-serviceuri-abbrdial</abbreviatedDialURI>
        <rfc2543Hold>false</rfc2543Hold>
        <callHoldRingback>2</callHoldRingback>
        <localCfwdEnable>true</localCfwdEnable>
        <semiAttendedTransfer>true</semiAttendedTransfer>
        <anonymousCallBlock>2</anonymousCallBlock>
        <callerIdBlocking>2</callerIdBlocking>
        <dndControl>0</dndControl>
        <remoteCcEnable>true</remoteCcEnable>
     </sipCallFeatures>
     <sipStack>
        <sipInviteRetx>6</sipInviteRetx>
        <sipRetx>10</sipRetx>
        <timerInviteExpires>180</timerInviteExpires>
        <timerRegisterExpires>3600</timerRegisterExpires>
        <timerRegisterDelta>5</timerRegisterDelta>
        <timerKeepAliveExpires>120</timerKeepAliveExpires>
        <timerSubscribeExpires>120</timerSubscribeExpires>
        <timerSubscribeDelta>5</timerSubscribeDelta>
        <timerT1>500</timerT1>
        <timerT2>4000</timerT2>
        <maxRedirects>70</maxRedirects>
        <remotePartyID>false</remotePartyID>
        <userInfo>None</userInfo>
     </sipStack>
     <autoAnswerTimer>1</autoAnswerTimer>
     <autoAnswerAltBehavior>false</autoAnswerAltBehavior>
     <autoAnswerOverride>true</autoAnswerOverride>
     <transferOnhookEnabled>false</transferOnhookEnabled>
     <enableVad>false</enableVad>
     <preferredCodec>g711a</preferredCodec>
     <dtmfAvtPayload>101</dtmfAvtPayload>
     <dtmfDbLevel>3</dtmfDbLevel>
     <dtmfOutofBand>avt</dtmfOutofBand>
     <alwaysUsePrimeLine>false</alwaysUsePrimeLine>
     <alwaysUsePrimeLineVoiceMail>false</alwaysUsePrimeLineVoiceMail>
     <kpml>3</kpml>
     <natEnabled>0</natEnabled>
     <natAddress></natAddress>
     <phoneLabel><?= base_login.slice(0,12) ?></phoneLabel>
     <stutterMsgWaiting>0</stutterMsgWaiting>
     <callStats>false</callStats>
     <silentPeriodBetweenCallWaitingBursts>10</silentPeriodBetweenCallWaitingBursts>
     <disableLocalSpeedDialConfig>false</disableLocalSpeedDialConfig>
     <startMediaPort>10000</startMediaPort>
     <stopMediaPort>20000</stopMediaPort>
     <sipLines>
        <line button="1">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[0] != null && base_mailbox[0].name != null ) ? base_mailbox[0].name : "Line 1" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login ?></name>
           <displayName><?= ( base_mailbox[0] != null && base_mailbox[0].name != null ) ? base_mailbox[0].name : "Line 1" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
        <line button="2">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[1] != null && base_mailbox[1].name != null ) ? base_mailbox[1].name : "Line 2" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login+"_2" ?></name>
           <displayName><?= ( base_mailbox[1] != null && base_mailbox[1].name != null ) ? base_mailbox[1].name : "Line 2" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login+"_2" ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login+"_2" ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
        <line button="3">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[2] != null && base_mailbox[2].name != null ) ? base_mailbox[2].name : "Line 3" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login+"_3" ?></name>
           <displayName><?= ( base_mailbox[2] != null && base_mailbox[2].name != null ) ? base_mailbox[2].name : "Line 3" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login+"_3" ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login+"_3" ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
        <line button="4">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[3] != null && base_mailbox[3].name != null ) ? base_mailbox[3].name : "Line 4" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login+"_4" ?></name>
           <displayName><?= ( base_mailbox[3] != null && base_mailbox[3].name != null ) ? base_mailbox[3].name : "Line 4" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login+"_4" ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login+"_4" ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
        <line button="5">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[4] != null && base_mailbox[4].name != null ) ? base_mailbox[4].name : "Line 5" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login+"_5" ?></name>
           <displayName><?= ( base_mailbox[4] != null && base_mailbox[4].name != null ) ? base_mailbox[4].name : "Line 5" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login+"_5" ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login+"_5" ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
        <line button="6">
           <featureID>9</featureID>
           <featureLabel><?= ( base_mailbox[5] != null && base_mailbox[5].name != null ) ? base_mailbox[5].name : "Line 6" ?></featureLabel>
	   <proxy><?= DB.get_attrib("my_ip") ?></proxy>
           <port>5060</port>
           <name><?= base_login+"_6" ?></name>
           <displayName><?= ( base_mailbox[5] != null && base_mailbox[5].name != null ) ? base_mailbox[5].name : "Line 6" ?></displayName>
           <autoAnswer>
              <autoAnswerEnabled>0</autoAnswerEnabled>
           </autoAnswer>
           <callWaiting>3</callWaiting>
           <authName><?= base_login+"_6" ?></authName>
           <authPassword><?= base_password+base_login ?></authPassword>
           <sharedLine>false</sharedLine>
           <messageWaitingLampPolicy>1</messageWaitingLampPolicy>
           <messagesNumber>asterisk</messagesNumber>
           <ringSettingIdle>4</ringSettingIdle>
           <ringSettingActive>5</ringSettingActive>
           <contact><?= base_login+"_6" ?></contact>
           <forwardCallInfoDisplay>
              <callerName>true</callerName>
              <callerNumber>false</callerNumber>
              <redirectedNumber>false</redirectedNumber>
              <dialedNumber>true</dialedNumber>
           </forwardCallInfoDisplay>
        </line>
     </sipLines>
     <voipControlPort>5060</voipControlPort>
     <dscpForAudio>184</dscpForAudio>
     <ringSettingBusyStationPolicy>0</ringSettingBusyStationPolicy>
     <dialTemplate>dialPlan.xml</dialTemplate>
  </sipProfile>
  <commonProfile>
     <phonePassword>0000</phonePassword>
     <backgroundImageAccess>true</backgroundImageAccess>
     <callLogBlfEnabled>1</callLogBlfEnabled>
  </commonProfile>
  <loadInformation>cisco/7961/SIP41.8-2-1S</loadInformation>
  <vendorConfig>
     <disableSpeaker>false</disableSpeaker>
     <disableSpeakerAndHeadset>false</disableSpeakerAndHeadset>
     <pcPort>1</pcPort>
     <settingsAccess>1</settingsAccess>
     <garp>0</garp>
     <voiceVlanAccess>0</voiceVlanAccess>
     <videoCapability>0</videoCapability>
     <autoSelectLineEnable>0</autoSelectLineEnable>
     <webAccess></webAccess>
     <spanToPCPort>1</spanToPCPort>
     <loggingDisplay>1</loggingDisplay>
     <loadServer><?= DB.get_attrib("hostname") ?></loadServer>
  </vendorConfig>
  <versionStamp><?= Math.floor(new Number(new Date()) /1000) ?>-a3cbf294-7526-4c29-8791-c4fce4ce4c37</versionStamp>
  <networkLocale>United_States</networkLocale>
  <networkLocaleInfo>
     <name>United_States</name>
     <version>5.0(2)</version>
  </networkLocaleInfo>
  <deviceSecurityMode>0</deviceSecurityMode>
  <dscpForSCCPPhoneConfig>96</dscpForSCCPPhoneConfig>
  <dscpForSCCPPhoneServices>0</dscpForSCCPPhoneServices>
  <dscpForCm2Dvce>96</dscpForCm2Dvce>
  <transportLayerProtocol>4</transportLayerProtocol>
  <capfAuthMode>0</capfAuthMode>
  <capfList>
     <capf>
        <phonePort>3804</phonePort>
     </capf>
  </capfList>
  <certHash></certHash>
  <encrConfig>false</encrConfig>
  <authenticationURL></authenticationURL>
  <directoryURL>http://<?= DB.get_attrib("hostname") ?>/config/cisco.whtm/d.xml</directoryURL>
  <idleURL></idleURL>
  <informationURL></informationURL>
  <messagesURL></messagesURL>
  <proxyServerURL></proxyServerURL>
  <servicesURL>http://<?= DB.get_attrib("hostname") ?>/config/cisco.whtm/d.xml</servicesURL> 
</device> 
</rb:block>
