#!/usr/bin/perl -w
#
# (c) 2005-2008 IP Cortex Ltd.
# All rights reserved.  Unauthorised copying is not permitted.
# 

use DBI;
use DBD::Pg;
use File::Copy;
use strict;

our $base="/var/www/html/config/configs";
our $diff;
our $res;

  my $db="asterisk";
  my $user="asterisk";
  my $pass="asterisk";

  our $dbh = DBI->connect( "dbi:Pg:dbname=$db;host=127.0.0.1", "$user", "$pass" ) or die "Cannot connect to database!";

  my $isdn_type="hfc";
  my $dhcp_srv="off";
  my $ip="";
  my $gw="";
  my $mask="";
  my $sqlcmd = "SELECT * FROM settings;";
  my $sth = $dbh->prepare($sqlcmd) or die "Cannot prepare $sqlcmd!";;
  $sth->execute() or die "Cannot execute $sqlcmd!";
  while( my $row = $sth->fetchrow_hashref() ) {
    if( $row->{attrib} eq "isdn_type" ) {
      $isdn_type = $row->{value};
    }
    if( $row->{attrib} eq "dhcp_srv" ) {
      $dhcp_srv = $row->{value};
    }
    if( $row->{attrib} eq "my_ip" ) {
      $ip = $row->{value};
    }
    if( $row->{attrib} eq "my_gw" ) {
      $gw = $row->{value};
    }
    if( $row->{attrib} eq "my_mask" ) {
      $mask = $row->{value};
    }
  }
  $dbh->disconnect();

#
# Use 'wget' to fetch a page from the local webserver
# This causes the config files to be regenerated.
#
#$res=`/usr/bin/wget -O - http://127.0.0.1/config/conf_files.whtm 2>/dev/null`;
$res=`/var/whitebeam/bin/wbsh config/conf_files.whtm 2>/dev/null`;

if( $res !~ /^OK/ ) {
  print $res."\n";
  die "Error running config page!\n";
}

#
# Has iax.conf changed?
#
$diff=`diff -Nu /etc/asterisk/iax.conf $base/iax.conf`;
if( length($diff) > 0 ) {
  print "Updating iax.conf with the following changes:\n";
  print "=============================================\n";
  print "$diff\n";
}

#
# Has sip.conf changed?
#
$diff=`diff -Nu /etc/asterisk/sip.conf $base/sip.conf`;
if( length($diff) > 0 ) {
  print "Updating sip.conf with the following changes:\n";
  print "=============================================\n";
  print "$diff\n";
}

#
# Has extensions.conf changed?
#
$diff=`diff -Nu /etc/asterisk/extensions.conf $base/extensions.conf`;
if( length($diff) > 0 ) {
  print "Updating extensions.conf with the following changes:\n";
  print "====================================================\n";
  print "$diff\n";
}

#
# Has extensions-ivr.conf changed?
#
$diff=`diff -Nu /etc/asterisk/extensions-ivr.conf $base/extensions-ivr.conf`;
if( length($diff) > 0 ) {
  print "Updating extensions-ivr.conf with the following changes:\n";
  print "========================================================\n";
  print "$diff\n";
}

#
# Has extensions-xlat.conf changed?
#
$diff=`diff -Nu /etc/asterisk/extensions-xlat.conf $base/extensions-xlat.conf`;
if( length($diff) > 0 ) {
  print  "Updating extensions-xlat.conf with the following changes:\n";
  print  "=========================================================\n";
  print  "$diff\n";
}

#
# Has queues.conf changed?
#
$diff=`diff -Nu /etc/asterisk/queues.conf $base/queues.conf`;
if( length($diff) > 0 ) {
  print "Updating queues.conf with the following changes:\n";
  print "================================================\n";
  print "$diff\n";
}

#
# Has astmanproxy.users changed?
#
$diff=`diff -Nu /etc/asterisk/astmanproxy.users $base/astmanproxy.users`;
if( length($diff) > 0 ) {
  print "Updating astmanproxy.users with the following changes:\n";
  print "======================================================\n";
  print "$diff\n";
}

#
# Has voicemail.conf changed?
#
$diff=`diff -Nu /etc/asterisk/voicemail.conf $base/voicemail.conf`;
if( length($diff) > 0 ) {
  print "Updating voicemail.conf with the following changes:\n";
  print "===================================================\n";
  print "$diff\n";
}

#
# SYSTEM FILES!!!
#

#
# /etc/hosts
#
$diff=`diff -Nu /etc/hosts $base/etc_hosts 2>/dev/null`;
if( -f "$base/etc_hosts" && length($diff) > 0 ) {
  print  "Updating /etc/hosts with the following changes:\n";
  print  "===============================================\n";
  print  "$diff\n";
  print  "Updating hostname with the following changes:\n";
  print  "=============================================\n";
  print  `diff -Nu /etc/hostname $base/etc_hostname`."\n";
  print  "Updating grub/menu.lst with the following changes:\n";
  print  "==================================================\n";
  my $mlen = 0;
  my %map=(255=>8, 254=>7, 252=>6, 248=>5, 240=>4, 224=>3, 192=>2, 128=>1, 0=>0);
  for( my $i=0; $i<4; $i++ ) {
    $mlen += $map{(split /\./,$mask)[$i]}
  }
  system('perl -p -e"s/^(\s*kernel\s+.*ip=)\S+(.*)\$/\${1}'.${ip}.'\/'.${mlen}.'\${2}/; s/^(\s*kernel\s+.*gw=)\S+(.*)\$/\${1}'.${gw}.'\$2/; " /boot/grub/menu.lst');
}

#
# /etc/network/interfaces
#
$diff=`diff -Nu /etc/network/interfaces $base/etc_network_interfaces 2>/dev/null`;
if( -f "$base/etc_network_interfaces" && length($diff) > 0 ) {
  print "Updating /etc/network/interfaces with the following changes:\n";
  print "============================================================\n";
  print "$diff\n";
}

#
# /etc/default/dhcp
#
$diff=`diff -Nu /etc/default/dhcp $base/etc_default_dhcp 2>/dev/null`;
if( -f "$base/etc_default_dhcp" && length($diff) > 0 ) {
  print "Updating /etc/default/dhcp with the following changes:\n";
  print "======================================================\n";
  print "$diff\n";
}

#
# /etc/resolv.conf
#
$diff=`diff -Nu /etc/resolv.conf $base/etc_resolv.conf 2>/dev/null`;
if( -f "$base/etc_resolv.conf" && length($diff) > 0 ) {
  print "Updating /etc/resolv.conf with the following changes:\n";
  print "=====================================================\n";
  print "$diff\n";
}

#
# /etc/ntp.conf
#
$diff=`diff -Nu /etc/ntp.conf $base/etc_ntp.conf 2>/dev/null`;
if( -f "$base/etc_ntp.conf" && length($diff) > 0 ) {
  print "Updating /etc/ntp.conf with the following changes:\n";
  print "==================================================\n";
  print "$diff\n";
}

#
# /etc/aliases
#
$diff=`diff -Nu /etc/aliases $base/etc_aliases 2>/dev/null`;
if( -f "$base/etc_aliases" && length($diff) > 0 ) {
  print "Updating /etc/aliases with the following changes:\n";
  print "=================================================\n";
  print "$diff\n";
}

#
# op_buttons.cfg
#
$diff=`diff -Nu /usr/local/fop/op_buttons.cfg $base/fop.conf 2>/dev/null`;
if( -f "$base/fop.conf" && length($diff) > 0 ) {
  print "Updating /usr/local/fop/op_buttons.cfg with the following changes:\n";
  print "==================================================================\n";
  print "$diff\n";
}

#
# /configs/keys/*
#
foreach my $i (glob $base."/keys/*.pub") {
  (my $target = $i) =~ s/^.*\/([^\/]+\.pub)$/\/var\/lib\/asterisk\/keys\/$1/;
  my $source = $i;
  $diff=`diff -Nu $target $source 2>/dev/null`;
  if( -f $source && length($diff) > 0 ) {
    print "Updating $target with the following changes:\n";
    print "=====================================".("=" x length($target))."\n";
    print "$diff\n";
  }
}

#
# /tftpboot/*
#
foreach my $i (glob $base."/tftp_*") {
  (my $target = $i) =~ s/^.*tftp_(.+)$/\/tftpboot\/$1/;
  my $source = $i;
  $diff=`diff -Nu $target $source 2>/dev/null`;
  if( -f $source && length($diff) > 0 ) {
    print "Updating $target with the following changes:\n";
    print "=====================================".("=" x length($target))."\n";
    print "$diff\n";
  }
}

#
# /etc/bind/named.conf && /etc/bind/zonefile
#
$diff=`diff -Nu /etc/bind/zonefile $base/named_zone 2>/dev/null`;
if( length($diff) > 0 ) {
  print  "Updating /etc/bind/named.conf with the following changes:\n";
  print  "=========================================================\n";
  print  `diff -Nu /etc/bind/named.conf $base/named_conf 2>/dev/null`."\n";

  print  "Updating /etc/bind/zonefile with the following changes:\n";
  print  "=======================================================\n";
  print  "$diff\n";
}

#
# /etc/dhcpd.conf
#
$diff=`diff -Nu /etc/dhcpd.conf $base/dhcpd_conf 2>/dev/null`;
if( length($diff) > 0 ) {
  print  "Updating /etc/dhcpd.conf with the following changes:\n";
  print  "====================================================\n";
  print  `diff -Nu /etc/dhcpd.conf $base/dhcpd_conf 2>/dev/null`."\n";
}

#
# sendmail smarthost
#
if( -f "$base/sendmail_ds.txt" && -M "$base/sendmail_ds.txt" < -M "/etc/mail/sendmail.cf" ) {
  print "Updating /etc/mail/sendmail.cf\n";
  print "==============================\n";
}

#
# zapata.conf
#
if( -f "$base/zapata.conf" ) {
$diff=`diff -Nu /etc/asterisk/zapata.conf $base/zapata.conf 2>/dev/null`;
  if( length($diff) > 0 ) {
    print  "Updating /etc/asterisk/zapata.conf with the following changes:\n";
    print  "==============================================================\n";
    print  $diff."\n";
  }
}

if( defined(glob "/etc/rc*.d/S*dhcp") && $dhcp_srv ne "on" ) {
  print "DHCPD needs disabling\n";
  print "=====================\n";
}
if( !defined(glob "/etc/rc*.d/S*dhcp") && $dhcp_srv eq "on" ) {
  print "DHCPD needs enabling\n";
  print "====================\n";
}
