// <!--
// (c) 2005-2008 IP Cortex Ltd.
// All rights reserved.  Unauthorised copying is not permitted.
// 
// -->

// limit = 1 : Auto-Gen numbers only
// limit = 2 : Personal numbers only
// limit = 3 : Company numbers only
// limit = 4 : External numbers only
function get_addressbooks(mac, port, company, result, buttons, autobutton, limit) {
  var autobutton_park = DB.get_attrib("autobutton_park",1);
  var autobutton_orbit = DB.get_attrib("autobutton_orbit",1);
  var count = bcount = 0;
  var dedupe={};
  if((pgconn=DB.open())) {
//
// auto-generated phonebook
//
    var pgres=pgconn.exec("SELECT virt_exten.*, contact.*, inbound_nos.*, exten_contact.contact_id AS makescalls,"+
                    " virt_exten.name AS extname,"+
                    " CASE WHEN (ring_type = 'o' OR ring_type = 'O') THEN 1 ELSE 2 END AS rt_sort"+
                    " FROM virt_exten"+
                    " LEFT JOIN contact"+
                    "   ON contact.owned_extension = virt_exten.virt_exten"+
                    " LEFT JOIN exten_contact"+
                    "   ON exten_contact.virt_exten = virt_exten.virt_exten"+
                    " LEFT JOIN inbound_nos"+
                    "   ON inbound_nos.virt_exten = virt_exten.virt_exten"+
                    " WHERE ring_type IN ('A','H','O','o')"+
                    " ORDER BY rt_sort,virt_exten.virt_exten,contact.contact_id");
    if( pgres!=null && pgres.success ) {
      com = rb.contact.OUInfo(-1,"company-"+company);
      load_contacts();		// Assumes asterisk.js is included by "parent"
      var pos=1;
      var last_ext=null;
      var phone_owner=null;
      for( var r=0; r<pgres.numRows; r++ ) {
        var row=pgres.fetchRowObject(r);
        var user = contact_names[row.contact_id];
        if( phone_owner==null && row.owned_phone!=null && row.owned_phone==mac && row.owned_port==port)
          phone_owner = user;
        if( last_ext==row.virt_exten )
          continue;
        if( row.makescalls != null && (row.phonebook > 1 || (row.phonebook == 1 && row.company==company)) && (limit == null || limit == 1) ) {
          result[count]=new Object;
          if( user != null )
            result[count].name=user.name;
          else
            result[count].name=row.extname;
          result[count].exten=row.virt_exten;
          count++;
          last_ext=row.virt_exten;
        }
	if( limit == null ) {
          if( autobutton_park == 1 && row.ring_type == 'O' && row.company==company && dedupe[row.virt_exten] == null ) {
            buttons[bcount]=row.virt_exten+":__Park__";
            bcount++;
            dedupe[row.virt_exten] = 1;
          } else if( autobutton_orbit == 1 && row.ring_type == 'o' && row.company==company && dedupe[row.virt_exten] == null ) {
            buttons[bcount]=row.virt_exten+":__Pick__"+row.virt_exten;
            bcount++;
            dedupe[row.virt_exten] = 1;
          } else if( autobutton == 't' && row.makescalls != null && row.company==company && dedupe[row.virt_exten] == null ) {
            buttons[bcount]=row.virt_exten+":"+row.name;
            bcount++;
            dedupe[row.virt_exten] = 1;
          }
        }
      }

//
// company-local list of numbers
//
// If the phone's company has specified some numbers, include them.
      if( com !=null && com.customData != null && com.customData.pbook != null && (limit == null || limit == 3)) {
        for( var x in com.customData.pbook ) {
          var entry=com.customData.pbook[x];
          if( entry.na !=null && entry.nu !=null && entry.na.length>0 && entry.nu.length>0 ) {
            if( entry.bu != null && (entry.bu == "y" || entry.bu == "o") && dedupe[entry.nu] == null ) {
              buttons[bcount]=entry.nu+":"+entry.na;
              bcount++;
              dedupe[entry.nu] = 1;
            }
            if( entry.bu != null && entry.bu == "o" )
              continue;
            result[count]=new Object;
            result[count].name=entry.na;
            result[count].exten=entry.nu;
            count++;
          }
        }
      }

//
// phone owner's numbers
//
// If the phone's owner has specified some numbers, include them.
      if( phone_owner !=null && phone_owner.customData != null && phone_owner.customData.pbook != null && (limit == null || limit == 2)) {
        for( var x in phone_owner.customData.pbook ) {
          var entry=phone_owner.customData.pbook[x];
          if( entry.na !=null && entry.nu !=null && entry.na.length>0 && entry.nu.length>0 ) {
            if( entry.bu != null && (entry.bu == "y" || entry.bu == "o") && dedupe[entry.nu] == null ) {
              buttons[bcount]=entry.nu+":"+entry.na;
              bcount++;
              dedupe[entry.nu] = 1;
            }
            if( entry.bu != null && entry.bu == "o" )
              continue;
            result[count]=new Object;
            result[count].name=entry.na;
            result[count].exten=entry.nu;
            count++;
          }
        }
      }


//
// externally sourced numbers
//
// If we have some imported numbers, include them
      pgres = pgconn.exec("SELECT * FROM pbook_src JOIN pbook ON pbook_src.src_host=pbook.src_host ORDER BY name");
      if( pgres!=null && pgres.success ) {
        for( var r=0;r<pgres.numRows && (limit == null || limit == 4); r++ ) {
          var row = pgres.fetchRowObject(r);
          if( row.dial_pfx == null )
            row.dial_pfx="";
          result[count]=new Object;
          result[count].exten=row.dial_pfx+row.extension;
          if( row.company == null || row.company == "" )
            row.company = row.def_company;
          if( row.company == null || row.company == "" )
            result[count].name=row.name;
          else
            result[count].name=row.name+", "+row.company;
          count++;
        }
      }
    }
  }
  return {count:count, bcount:bcount};
}
