rb.debug.mode(false);
function charges_push(pval,cached) {
  if( formdata.inb != null || (sess!=null && pval.company != sess.company) )
    return;
  if( pval.mac == null )
    pval.mac="";
  if( pval.phone == null )
    pval.phone="";

  var dd = pval.calldate.split(/[^\d]/);
  var dz = pval.calldate.match(/^.*((?:\+|\-)\d+)$/);
  var d = new Date( dd[2]+" "+months[dd[1]-1]+" "+dd[0]+" "+dd[3]+":"+dd[4]+":"+dd[5]+" "+(dz!=null?" "+dz[1]+"00":"") )
  pval.calldate = d;
  if( cached != null ) {
    pval.cached=true;
    pval.info = cached;
    if( pval.mac != 'orphan0' && pval.mac.search(/^__EXTERNAL/) == -1 && logins[pval.mac] == null ) // Phone has gone away since data was cached
      pval.mac='orphan0';
    if( pval.mac != 'orphan0' && pval.mac.search(/^__EXTERNAL/) == -1 && logins[pval.mac] != null && logins_to_company[logins[pval.mac]] != null && logins_to_company[logins[pval.mac]] != pval.company ) // Phone has gone to other company since data was cached
      pval.mac='orphan0';
  } else if( pval.dn == null && pval.sn == null ) {
    // Missing userfield??? Try to improve our guess.
    // If dialled no. is a valid extension number, make it look internal.
    if( ext_to_company[pval.dst] != null ) 
      pval.sn = pval.dn = pval.dst;
  }
  if( charges[pval.mac] == null )
    charges[pval.mac] = [];
  charges[pval.mac].push(pval);
}

function inbound_push(pval) {
  if( formdata.inb == null || (sess!=null && pval.company != sess.company) )
    return;

  var dd = pval.calldate.split(/[^\d]/);
  var dz = pval.calldate.match(/^.*((?:\+|\-)\d+)$/);
  var d = new Date( dd[2]+" "+months[dd[1]-1]+" "+dd[0]+" "+dd[3]+":"+dd[4]+":"+dd[5]+" "+(dz!=null?" "+dz[1]+"00":"") )
  pval.calldate = d;
  if( pval.sn == null || pval.sn.length == 0 )
    pval.sn = pval.dst;
  inbound.push(pval);
}

if( ok ) {
  var charges=[]; // Store date, company, SIP-name, mac (or "orphan"), src, dst, dst_prefix, time
  var inbound=[]; // Store date, company, SIP-name, mac (or "orphan"), src, dst, dst_prefix, time
  var zerocost=[]; // Store a list of known zero-cost items.
  var ind_charges={};
  var inb_charges={};

  phone = [];
  companies = {};
  ext_to_phone = {};
  ext_to_company = {};
  ext_to_extname = {};
  logins = {};
  logins_lookup = {};
  logins_to_company = {};
  if ((pgconn=DB.open())) {
    rb.debug.write("DATABASE open OK<br>");
  // Get all logins, as we look them up a lot...
    var last = null;
    pgres=pgconn.exec("SELECT translate(lower(name),' _','') AS name,mac,port,company"+
  		' FROM phone'+
                ' WHERE mac != \'__EXTERNAL__\''+
  		' ORDER BY 1, 2, 3');
    if( pgres!=null && pgres.success && pgres.numRows>0 ) {
      for( var i=0; i<pgres.numRows; i++ ) {
        var row=pgres.fetchRowObject(i);
        companies[row.company]=1;
        if( row.name != last )
          seq=0;
        else
          seq++;
        last = row.name;
        if( seq == 0 && last == 'general' )
          seq++;
        if( seq == 0 ) {
          logins[row.mac+row.port]=row.name;
          logins_lookup[row.name]=row.mac+row.port;
          logins_to_company[row.name]=row.company;
        } else {
          logins[row.mac+row.port]=row.name+"."+(seq+1).toString();
          logins_lookup[row.name+"."+(seq+1).toString()]=row.mac+row.port;
          logins_to_company[row.name+"."+(seq+1).toString()]=row.company;
        }
      }
    }

  // Get list of extensions that are un-owned... Useful for orphan spotting.
    pgres = pgconn.exec('SELECT virt_exten,virt_exten.name,contact_id,company'+
  		' FROM virt_exten'+
  		' LEFT JOIN contact ON virt_exten = owned_extension'+
                ' ORDER BY virt_exten');
    if( pgres!=null && pgres.success && pgres.numRows>0 ) {
      for( var r=0;r<pgres.numRows; r++ ) {
        var row = pgres.fetchRowObject(r);
        companies[row.company]=1;
        ext_to_company[row.virt_exten] = row.company;
        ext_to_extname[row.virt_exten] = row.name;
      }
    }

  // Work out which phones to display...
    pgres = pgconn.exec('SELECT (mac = \'__EXTERNAL__\') AS ext,mac,port,phone.name,contact_id,owned_extension,company'+
  		' FROM phone'+
  		' LEFT JOIN contact ON mac = owned_phone'+
  		'                  AND port = owned_port'+
  		' ORDER BY ext, name');
    if( pgres!=null && pgres.success && pgres.numRows>0 ) {
      for( var r=0;r<pgres.numRows; r++ ) {
        var row = pgres.fetchRowObject(r);
        if( row.mac == '__EXTERNAL__' )
          row.name = "EXTERNAL: "+row.name;
  	if( formdata["mac-"+row.mac+row.port] != null && sess != null && row.company == sess.company) {
          phone.push({mac:row.mac, port:row.port, name:row.name, id:row.contact_id, ext:row.owned_extension});
        }
        if( row.owned_extension != null ) {
          ext_to_phone[row.owned_extension]=row.mac+row.port;
        }
      }
    }
  // In case a phone is un-owned
    pgres = pgconn.exec('SELECT phone.mac,phone.port,phone.name,contact.contact_id,owned_extension,company'+
                ' FROM phone'+
                ' JOIN contact_phone ON phone.mac = contact_phone.mac AND phone.port = contact_phone.port'+
                ' JOIN contact ON contact.contact_id = contact_phone.contact_id'+
                ' ORDER BY phone.name, contact.owned_extension');
    if( pgres!=null && pgres.success && pgres.numRows>0 ) {
      for( var r=0;r<pgres.numRows; r++ ) {
        var row = pgres.fetchRowObject(r);
        if( row.mac == '__EXTERNAL__' && ext_to_phone["V"+row.name] == null ) {
          ext_to_phone["V"+row.name]=row.mac+row.port;
        } else if( row.owned_extension != null && ext_to_phone[row.owned_extension] == null ) {
          ext_to_phone[row.owned_extension]=row.mac+row.port;
        }
      }
    }
  }
  if( formdata["orphan"] != null )
    phone.push({mac:"orphan",port:0,name:"Orphaned/Other",id:null});

  var sql = 'SELECT channel, dstchannel, dst, duration, billsec, userfield, disposition';
  sql += ' FROM cdr WHERE (channel LIKE \'Local/%\' OR dstchannel LIKE \'Local/%\') AND ';
  sql += 'calldate BETWEEN (TIMESTAMP '+$billfromdate+')-(interval \'1 hour\') AND (TIMESTAMP '+$billtodate+')+(interval \'1 hour\') ORDER BY calldate;';
  rb.debug.write(sql+"<br>\n");
  pgres = pgconn.exec(sql);
  if( pgres!=null && pgres.success && pgres.numRows>0 ) {
    for( var r=0;r<pgres.numRows; r++ ) {
      var row = pgres.fetchRowObject(r);
      if( row.dstchannel.search("^Local/") != -1 )
        ind_charges[row.dstchannel.slice(0,-2)]=row;
      if( row.channel.search("^Local/") != -1 )
        inb_charges[row.channel.slice(0,-2)]=row;
    }
    rb.debug.write(pgres.numRows + " Parent rows<br>\n");
  }

  // Work through all charges for the selected period...
  rb.debug.write("Timer before main DB query is at: "+(new Date() - timer)/1000+"s<br>\n");
  var sql = 'SELECT cdr.* FROM cdr WHERE ';
  if( $extralimit != null )
    sql += " "+$extralimit+" ";
  sql += 'cdr.calldate >= '+$billfromdate+' AND cdr.calldate < '+$billtodate+' ORDER BY cdr.calldate';

  pgres = pgconn.exec(sql);
  if( pgres!=null && pgres.success && pgres.numRows>0 ) {
  rb.debug.write("Got "+pgres.numRows+" rows from database to process<br>\n");
    for( var r=0;r<pgres.numRows; r++ ) {
      var row = pgres.fetchRowObject(r);

  // If our lastapp field is "ForkCDR" then is is a redundant record that can be ignored...
      if( row.lastapp.search(/^forkcdr$/i) != -1 )
        continue;

  //Sort out the date conversion
      var d = row.calldate;

  // Pull fields from UserField
      if( row.userfield == null )
        row.userfield="";
      row.userfield=row.userfield.replace(/\|/g,"^");
      var uf1 = row.userfield.split("^");
      row.uf={};
      for( var i=0; i<uf1.length; i++ ) {
        if( uf1[i] == null || uf1[i].length == 0 )
          continue;
        var uf2 = uf1[i].split("=");
        if( uf2.length != 2 || uf2[0] == null || uf2[0].length == 0 || uf2[1] == null || uf2[1].length == 0 )
          continue;
        row.uf[uf2[0]]=uf2[1];
      }
      var uf_tc = row.uf.tc;	// Target's Company
      var uf_com = row.uf.co;	// calling COmpany
      var uf_ex = row.uf.ex;	// Source EXtension
      var uf_sn = row.uf.sn;	// Short Number
      var uf_dn = row.uf.dn;	// Destination Number
      var uf_trunk = row.uf.ch;	// CHannel or trunk
      var uf_phone = row.uf.ph;	// PHone device (deprecated as row.channel has this info.)
      var uf_bt = row.uf.bt;	// Bill To
      var uf_cc = row.uf.cc;	// Cached Charge
rb.debug.write(row.calldate+" "+row.uf.toSource()+"<br>\n");

  //
  // If we have cached data, use it here unless we are being asked to regenerate it!
  //
      if( formdata.recalc_all == null && formdata.inb == null && uf_cc != null ) {
        var uf_cc_eval=null;
  	try {
          uf_cc_eval = eval(uf_cc);
        } catch(e) {
          uf_cc_eval=null;
        }
        if( uf_cc_eval != null ) {
          if( uf_cc_eval.sec != null && uf_cc_eval.sec > 0 )
            charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:uf_cc_eval.co, phone:uf_cc_eval.ph, mac:uf_cc_eval.mac, dst:uf_cc_eval.dst, dst_prefix:uf_cc_eval.pfx, duration:uf_cc_eval.dur, billsec:uf_cc_eval.sec, trunk:uf_trunk}, uf_cc_eval);
          continue;
        }
      }

  //
  // Local Zap devices (channelbank etc)
  //
      var zc_num = row.channel.match(/^Zap\/(\d+)-\d+$/);
      var zc_p;
      if( zc_num != null && zc_num[1] != null && (zc_p=zaptel_unmap(zc_num[1])) != null ) {
// rb.debug.write("Row: "+row.toSource()+"<br>\n");
// rb.debug.write("Zap local device = "+row.channel+" -> "+zc_p.toSource()+"<br>\n");
        var src_com = ext_to_company[row.dst];
        if( src_com == null && uf_sn != null )
          src_com = ext_to_company[uf_sn];
        if( src_com == null && uf_dn != null )
          src_com = ext_to_company[uf_dn];
        if( src_com != null || (row.dcontext.substr(0,4) == "ivr-" && row.dstchannel == "") ) {		// Internal call to internal extension or IVR...
          if( uf_dn == null )
            uf_dn = row.dst;
          if( uf_sn == null )
            uf_sn = row.dst;
          var ll = identify_login(zc_p.mac,zc_p.port);
          var com = logins_to_company[ll];
          if( com == null && uf_com != null && companies[uf_com] == 1)
            com = uf_com;
          if( uf_tc == null )
            uf_tc = src_com;
          inbound_push({calldate:d, company:uf_tc, src:row.src, dst:row.dst, duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, internal:(com!=null), disposition:row.disposition, action:row.lastapp, dstchannel:row.dstchannel, channel:row.channel});
        }

  // Skip zero duration items
        if( row.billsec <= 0 ) { // No billable time
          zerocost.push({acctid:row.acctid, userfield:row.userfield});
          continue;
        }

  // Get login, mac, company of phone making SIP call.
        if( uf_bt != null && uf_bt.length == 13 && logins[uf_bt] != null ) {
          ll = logins[uf_bt];
          mac = uf_bt;
          com = logins_to_company[ll];
          src_com = ext_to_company[row.src];
          pref_note="(PIN via "+row.channel.replace(/^SIP\/(.*?)(|_[0-9]+)-[^\-]*$/,"$1")+")";
        } else {
          ll = identify_login(zc_p.mac,zc_p.port);
          mac = zc_p.mac+""+zc_p.port;
          com = logins_to_company[ll];
          src_com = ext_to_company[row.src];
          pref_note="";
        }

  // The perfect call...
        if( mac != null ) {
          if( uf_com == null ) // Did not have extra data available...
            uf_com = com;
  //          if( com != src_com || com != uf_com || src_com != uf_com )
  //            rb.debug.write("WARNING: uf company = "+uf_com+", phone company = "+com+", src company = "+src_com+" for: "+row.toSource()+"<br>\n");
          charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:uf_com, phone:ll, mac:mac, src:row.src, dst:row.dst, dst_prefix:pref_note, duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
          continue;
        }
  // Orphan, but we know the company from the src exten.
  	if ( src_com != null || uf_com != null ) {
          if( uf_com == null ) // Did not have extra data available...
            uf_com = src_com;
          charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:uf_com, phone:ll, mac:'orphan0', src:row.src, dst:row.dst, dst_prefix:row.src+" --&gt;", duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
          continue;
        }
  // Orphan 100% - Drop into default.
        rb.debug.write("100% Orphaned: "+row.toSource()+"<br>\n");
        charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:'default', phone:ll, mac:'orphan0', src:row.src, dst:row.dst, dst_prefix:row.src+" --&gt;", duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
        continue;
      }

  //
  // Zap calls
  //
      if( row.channel.search("^Zap/") != -1 ) {
        var src_com = ext_to_company[row.dst];
        if( src_com == null && uf_sn != null )
          src_com = ext_to_company[uf_sn];
        if( src_com == null && uf_dn != null )
          src_com = ext_to_company[uf_dn];

        // Special case if call is diverted to voicemail using *0
        if( src_com == null && row.dst.substr(0,2) == "*0" ) {
          row.dst = row.dst.substr(2);
          if( uf_sn.substr(0,2) == "*0" )
            uf_sn = uf_sn.substr(2);
          if( uf_dn.substr(0,2) == "*0" )
            uf_dn = uf_dn.substr(2);
          src_com = ext_to_company[row.dst];
          if( src_com == null && uf_sn != null )
            src_com = ext_to_company[uf_sn];
          if( src_com == null && uf_dn != null )
            src_com = ext_to_company[uf_dn];
          row.lastapp="VoiceMail";
        }

        if( src_com != null || (row.dcontext.substr(0,4) == "ivr-" && row.dstchannel == "") ) {	// External (Zap) call to internal extension or IVR...
          if( uf_dn == null )
            uf_dn = row.dst;
          if( uf_sn == null )
            uf_sn = row.dst;
//          if( uf_dn != uf_sn || uf_sn != row.dst )
//            rb.debug.write("WARNING: uf dst = "+uf_dn+", uf short dst = "+uf_sn+", dst = "+row.dst+" for: "+row.toSource()+"<br>\n");
          if( uf_tc == null )
            uf_tc = src_com;
          inbound_push({calldate:d, company:uf_tc, src:row.src, dst:row.dst, duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, internal:false, disposition:row.disposition, action:row.lastapp, dstchannel:row.dstchannel, channel:row.channel});
          zerocost.push({acctid:row.acctid, userfield:row.userfield});
          continue;
        }

        if( row.billsec <= 0 ) { // No billable time
          zerocost.push({acctid:row.acctid, userfield:row.userfield});
          continue;
        }

  // Inbound call barring caused a redirect of a Zap Call to a local extension...
        if( row.dstchannel.search("^Local\/[0-9]+@extensions") != -1 ) {
  	  // rb.debug.write("Inbound barring redirect row ignored: "+row.toSource()+"<br>\n");
          zerocost.push({acctid:row.acctid, userfield:row.userfield});
          continue;
        }
        // rb.debug.write("Zap call to non local destination - Orphan to default: "+row.toSource()+"<br>\n");
        charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:'default', phone:"Trunk pass-thru via "+uf_sn, mac:'orphan0', src:row.src, dst:row.dst, dst_prefix:row.src+" --&gt;", duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
        continue;
      }

  //
  // IAX calls
  //
      if( row.channel.search("^IAX2/") != -1 ) {
        var src_com = ext_to_company[row.dst];
        if( src_com == null && uf_sn != null )
          src_com = ext_to_company[uf_sn];
        if( src_com == null && uf_dn != null )
          src_com = ext_to_company[uf_dn];
        if( src_com != null  || (row.dcontext.substr(0,4) == "ivr-" && row.dstchannel == "") ) {	// External (IAX) call to internal extension or IVR...
          if( uf_dn == null )
            uf_dn = row.dst;
          if( uf_sn == null )
            uf_sn = row.dst;
          if( uf_tc == null )
            uf_tc = src_com;
          inbound_push({calldate:d, company:uf_tc, src:row.src, dst:row.dst, duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, internal:false, disposition:row.disposition, action:row.lastapp, dstchannel:row.dstchannel, channel:row.channel});
          zerocost.push({acctid:row.acctid, userfield:row.userfield});
          continue;
        }

        if( row.billsec <= 0 ) { // No billable time
          zerocost.push({acctid:row.acctid, userfield:row.userfield});
          continue;
        }

  // Inbound call barring caused a redirect of an IAX Call to a local extension...
        if( row.dstchannel.search("^Local\/[0-9]+@extensions") != -1 ) {
  	  // rb.debug.write("Inbound barring redirect row ignored: "+row.toSource()+"<br>\n");
          zerocost.push({acctid:row.acctid, userfield:row.userfield});
          continue;
        }
  //        rb.debug.write("IAX2 call to non local destination - Orphan to default: "+row.toSource()+"<br>\n");
        charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:'default', phone:"IAX pass-thru via "+uf_sn, mac:'orphan0', src:row.src, dst:row.dst, dst_prefix:row.src+" --&gt;", duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
        continue;
      }

  //
  // SIP/ calls
  //
      if( row.channel.search("^SIP/") != -1 ) {
        var src_com = ext_to_company[row.dst];
        if( src_com == null && uf_sn != null )
          src_com = ext_to_company[uf_sn];
        if( src_com == null && uf_dn != null )
          src_com = ext_to_company[uf_dn];
        if( src_com != null || (row.dcontext.substr(0,4) == "ivr-" && row.dstchannel == "") )	{	// Internal or External (SIP) call to internal extension or IVR...
          if( uf_dn == null )
            uf_dn = row.dst;
          if( uf_sn == null )
            uf_sn = row.dst;
  //          if( uf_dn != uf_sn || uf_sn != row.dst )
  //            rb.debug.write("WARNING: uf dst = "+uf_dn+", uf short dst = "+uf_sn+", dst = "+row.dst+" for: "+row.toSource()+"<br>\n");
          var ll = row.channel.replace(/^SIP\/(.*?)(|_[0-9]+)-[^\-]*$/,"$1");
          var com = logins_to_company[ll];
          if( com == null && uf_com != null && companies[uf_com] == 1)
            com = uf_com;
          if( uf_tc == null )
            uf_tc = src_com;
          inbound_push({calldate:d, company:uf_tc, src:row.src, dst:row.dst, duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, internal:(com!=null), disposition:row.disposition, action:row.lastapp, dstchannel:row.dstchannel, channel:row.channel});
        }

  // Skip zero duration items
        if( row.billsec <= 0 ) { // No billable time
          zerocost.push({acctid:row.acctid, userfield:row.userfield});
          continue;
        }

  // Get login, mac, company of phone making SIP call.
        if( uf_bt != null && uf_bt.length == 13 && logins[uf_bt] != null ) {
          ll = logins[uf_bt];
          mac = uf_bt;
          com = logins_to_company[ll];
          src_com = ext_to_company[row.src];
          pref_note="(PIN via "+row.channel.replace(/^SIP\/(.*?)(|_[0-9]+)-[^\-]*$/,"$1")+")";
        } else {
          ll = row.channel.replace(/^SIP\/(.*?)(|_[0-9]+)-[^\-]*$/,"$1");
          mac = logins_lookup[ll];
          com = logins_to_company[ll];
          src_com = ext_to_company[row.src];
          pref_note="";
        }

  // The perfect call...
        if( mac != null ) {
          if( uf_com == null ) // Did not have extra data available...
            uf_com = com;
  //          if( com != src_com || com != uf_com || src_com != uf_com )
  //            rb.debug.write("WARNING: uf company = "+uf_com+", phone company = "+com+", src company = "+src_com+" for: "+row.toSource()+"<br>\n");
          charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:uf_com, phone:ll, mac:mac, src:row.src, dst:row.dst, dst_prefix:pref_note, duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
          continue;
        }
  // Orphan, but we know the company from the src exten.
  	if ( src_com != null || uf_com != null ) {
          if( uf_com == null ) // Did not have extra data available...
            uf_com = src_com;
  //          if( src_com != uf_com )
  //            rb.debug.write("WARNING: uf company = "+uf_com+", src company = "+src_com+" for: "+row.toSource()+"<br>\n");
  //          rb.debug.write("Orphaned to '"+uf_com+"': "+row.toSource()+"<br>\n");
          charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:uf_com, phone:ll, mac:'orphan0', src:row.src, dst:row.dst, dst_prefix:row.src+" --&gt;", duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
          continue;
        }
  // Orphan 100% - Drop into default.
        rb.debug.write("100% Orphaned: "+row.toSource()+"<br>\n");
        charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:'default', phone:ll, mac:'orphan0', src:row.src, dst:row.dst, dst_prefix:row.src+" --&gt;", duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
        continue;
      }

  //
  // Local/ calls
  //
      if( row.channel.search("^Local/") != -1 ) {
        // Find the immediate parent and then the topmost record if there is a 'chain'
        var local_par=ind_charges[row.channel.slice(0,-2)];
        if( local_par == null ) {
          // rb.debug.write("<br>WARNING: "+row.channel.slice(0,-2)+" has no parent in "+ind_charges.toSource().replace(/</g,"&lt;")+"<br>\n");
          local_par = {userfield:'',channel:null, billsec:0, duration:0};
        }
        row.found_billsec=row.billsec;
        var local_top=local_par;
        var unloop=0;
        while( local_top.channel != null && ind_charges[local_top.channel.slice(0,-2)] != null && unloop<10) {
          local_top=ind_charges[local_top.channel.slice(0,-2)];
          unloop++;
        }

        local_c = local_top;
        if( local_c.billsec > row.found_billsec )
          row.found_billsec = local_c.billsec;
        var unloop=0;
        while( local_c.dstchannel != null && inb_charges[local_c.dstchannel.slice(0,-2)] != null && unloop<10) {
          local_c = inb_charges[local_c.dstchannel.slice(0,-2)];
          if( local_c.billsec > row.found_billsec )
            row.found_billsec = local_c.billsec;
          unloop++;
        }

  // This row does not include billable seconds, so add them.
        if( row.billsec == 0 )
          row.duration += row.found_billsec;
        row.billsec = row.found_billsec;

        if( local_top == null )
          local_top={};

        var src_com = ext_to_company[row.dst];
        if( src_com == null && uf_sn != null )
          src_com = ext_to_company[uf_sn];
        if( src_com == null && uf_dn != null )
          src_com = ext_to_company[uf_dn];
  	var flag_as_inbound=false;
        if( src_com != null ) {	// Somehow Indirect/Redirected (Local) call to internal extension...
          if( uf_dn == null )
            uf_dn = row.dst;
          if( uf_sn == null )
            uf_sn = row.dst;
          if( local_par.channel != null ) {
            var ll = local_par.channel.replace(/^SIP\/(.*?)(|_[0-9]+)-[^\-]*$/,"$1");
            var com = logins_to_company[ll];
          } else
            com=null;
          if( uf_tc == null )
            uf_tc = src_com;
          if( row.dcontext == "pageme" && row.lastapp == "Dial" )
            row.lastapp = "pageme";
          inbound_push({calldate:d, company:uf_tc, src:row.src, dst:row.dst, duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, internal:(com!=null), disposition:row.disposition, action:row.lastapp, dstchannel:row.dstchannel, channel:row.channel})
          flag_as_inbound=true;
        }

  // Finally, if still not billable. Ditch.
        if( row.billsec <= 0 ) { // No billable time
          zerocost.push({acctid:row.acctid, userfield:row.userfield});
          continue;
        }
          
  // flag_as_inbound and looks like an internal redirect, so treat as inbound only
        if( flag_as_inbound && row.channel.search("^Local\/[0-9]+@extensions") != -1 ) {
          zerocost.push({acctid:row.acctid, userfield:row.userfield});
          continue;
        }

  // Pull fields from Parent UserField
        if( local_par.userfield == null )
          local_par.userfield="";
        local_par.userfield=local_par.userfield.replace(/\|/g,"^");
        var uf1 = local_par.userfield.split("^");
        local_par.uf={};
        for( var i=0; i<uf1.length; i++ ) {
          if( uf1[i] == null || uf1[i].length == 0 )
            continue;
          var uf2 = uf1[i].split("=");
          if( uf2.length != 2 || uf2[0] == null || uf2[0].length == 0 || uf2[1] == null || uf2[1].length == 0 )
            continue;
          local_par.uf[uf2[0]]=uf2[1];
        }

    // The company that caused the redirect from the parent record...
        var uf_com = local_par.uf.tc;

        var src_com = ext_to_company[local_par.dst];
        if( src_com == null && local_par.uf.sn != null )
          src_com = ext_to_company[local_par.uf.sn];
        if( src_com == null && local_par.uf.dn != null )
          src_com = ext_to_company[local_par.uf.dn];
  // Get phone from ext.
        var ext = local_par.dst;
        var mac = ext_to_phone[local_par.dst];
        var ll = (mac != null)?logins[mac]:null;

        if( uf_com == null ) // Did not have extra data available...
          uf_com = src_com;

  // We can determine the phone and company okay...
  	if ( mac != null && (src_com != null || uf_com != null) ) {
  //          if( src_com != uf_com )
  //            rb.debug.write("WARNING: uf company = "+uf_com+", src company = "+src_com+" for: "+row.toSource()+"<br>\n");
          charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:uf_com, phone:ll, mac:mac, src:local_par.src, dst:row.dst, dst_prefix:"(CFwd via "+local_par.dst+")", duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
          continue;
        }
  // We can determine the company okay, and can match a virtual phone device...
        var vmac = ext_to_phone["V"+row.dst];
  	if ( vmac != null && (src_com != null || uf_com != null) ) {
  //          if( src_com != uf_com )
  //            rb.debug.write("WARNING: uf company = "+uf_com+", src company = "+src_com+" for: "+row.toSource()+"<br>\n");
  //          rb.debug.write("Orphaned to '"+uf_com+"': "+row.toSource()+"<br>\n");
          charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:uf_com, phone:local_par.dst, mac:vmac, src:local_par.src, dst:row.dst, dst_prefix:"(CFwd via "+local_par.dst+")", duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
          continue;
        }

  // We can determine the company okay...
  	if ( (src_com != null || uf_com != null) ) {
  //          if( src_com != uf_com )
  //            rb.debug.write("WARNING: uf company = "+uf_com+", src company = "+src_com+" for: "+row.toSource()+"<br>\n");
  //          rb.debug.write("Orphaned to '"+uf_com+"': "+row.toSource()+"<br>\n");
          charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:uf_com, phone:'', mac:'orphan0', src:local_par.src, dst:row.dst, dst_prefix:"(CFwd via "+local_par.dst+")", duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
          continue;
        }

  // We're about to give up, but let's make a big effort using just the local record to see if we do any better
        if( ext == null && uf_com == null && ext_to_phone[row.src] != null && row.channel.substr(-2) == ",1" ) {
          src_com = ext_to_company[uf_ex];
          uf_com = src_com;
          ext = row.src;
          mac = ext_to_phone[ext];
          ll = (mac != null)?logins[mac]:null;
        }
  	if ( mac != null && (src_com != null || uf_com != null) ) {
          charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:uf_com, phone:ll, mac:mac, src:uf_ex, dst:row.dst, dst_prefix:"(CTD)", duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
          continue;
        }
          

  // Orphan 100% - Drop into default.
  //        rb.debug.write("100% Orphaned: "+row.toSource()+"<br>\n");
        charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:'default', phone:'', mac:'orphan0', src:local_par.src, dst:row.dst, dst_prefix:"(CFwd via "+local_par.dst+")", duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
        continue;
      }

  //
  // Catch-all...
  //
      rb.debug.write("UNKNOWN call to non local destination - Orphan to default: "+row.toSource()+"<br>\n");
      charges_push({userfield:row.userfield, acctid:row.acctid, calldate:d, company:'default', phone:"UNKNOWN/ERROR", mac:'orphan0', src:row.src, dst:row.dst, dst_prefix:row.src+" --&gt;", duration:row.duration, billsec:row.billsec, dn:uf_dn, sn:uf_sn, trunk:uf_trunk});
    }
  }
}
