// <!--
// (c) 2005-2008 IP Cortex Ltd.
// All rights reserved.  Unauthorised copying is not permitted.
// -->

function DB() {
  DB.pgconn=false;
}

var _attrib_cache={};

DB.open = function() {
  if( DB.pgconn && DB.pgconn.connected )
    return DB.pgconn;

  var connectDesc = {
    dbname:'asterisk',
    user:'asterisk',
    host:'localhost'
  }
  DB.pgconn = new PgsqlConnection;
  if(DB.pgconn.connect(connectDesc))
    return DB.pgconn;
  else
    return false;
} 

DB.get_attrib = function(attrib,def,no_recurse) {
  var pgconn;
  if( _attrib_cache[attrib] != null )
    return _attrib_cache[attrib];
  if(!(pgconn=DB.open())) {
    return null;
  }
  var pgres=pgconn.exec("SELECT attrib,value FROM settings");
  if( pgres!=null && pgres.success && pgres.numRows>0 ) {
    for( var r=0; r<pgres.numRows; r++ ) {
      var row = pgres.fetchRowObject(r);
      _attrib_cache[row.attrib]=row.value;
    }
  }
  if( _attrib_cache[attrib] != null )
    return _attrib_cache[attrib];
  if( def != null )
    return DB.set_attrib(attrib,def,no_recurse);
  return null;
}

DB.set_attrib = function(attrib,value,no_recurse) {
  var pgconn;
  if(!(pgconn=DB.open())) {
    return false;
  }
  var pgres;
  var current = DB.get_attrib(attrib);
  if(current!=null && current == value)
    return value;
  if(current!=null && current != value) {
    pgres=pgconn.exec("UPDATE settings SET value='"+
                      PgsqlConnection.escape(value)+"' WHERE attrib='"+
                      PgsqlConnection.escape(attrib)+"'");
    if( pgres!=null && pgres.success ) {
      _attrib_cache[attrib]=value;
      if( no_recurse == null )
        DB.flag_change();
      return value;
    }
    return false;
  }
  if(current==null) {
    pgres=pgconn.exec("INSERT INTO settings(attrib,value) VALUES('"+
                      PgsqlConnection.escape(attrib)+"','"+
                      PgsqlConnection.escape(value)+"')");
    if( pgres!=null && pgres.success ) {
      _attrib_cache[attrib]=value;
      if( no_recurse == null )
        DB.flag_change();
      return value;
    }
    return false;
  }
}

DB.flag_change = function() {
  var d = new Date();
  var res=DB.set_attrib("flag_change_date",d.valueOf(),true);
  var req = new HttpRequest;
  req.host = "127.0.0.1";
  req.path = "/cgi-bin/upd_ast.pl";
  req.method = "GET";
  res = req.doRequest();
  return res;
}

DB.flag_updated = function(ms) {
  if( ms == null )
    ms = DB.get_attrib("flag_change_date",0,true);
  return DB.set_attrib("flag_updated_date",ms,true);
}

DB.is_changed = function() {
  if ( DB.get_attrib("flag_change_date",0,true) != DB.get_attrib("flag_updated_date",0,true) )
    return DB.get_attrib("flag_change_date",null,true);
  return 0;
}
