<!--
(c) 2005-2008 IP Cortex Ltd.
All rights reserved.  Unauthorised copying is not permitted.

Portions (c) 2005 Yellowhawk Ltd.
All rights reserved.  Unauthorised copying is not permitted.

Portions (c) 2005 Redbourne Ltd.
All rights reserved.  Unauthorised copying is not permitted.
-->
<rb:script>
  // Check SSL configuration. By default if an 'ssl' attribute appears in the 
  // 'rbm:extauth' tag then we must we would insist on an SSL connection for
  // authentication. If Config.
  var SysData;
  var Access;
  var Config={feature:{authfail:'leave'}, enableSSL:false};
  var enableSSL = ( Config==null || Config.enableSSL==null || Config.enableSSL==true );
  var _rb$extauth_array, _rb$extauth_cache, extauth;
  var _rb$extauth_check;

  if (SysData==null)
    SysData={};

  // If our stack of extauth objects needs initialising,
  // do it at the global level.
	if (!(_rb$extauth_array instanceof Array ))
		_rb$extauth_array=[];

  // A place to cache individualInfo and memberOf results.
	if (!(_rb$extauth_cache instanceof Object ))
		_rb$extauth_cache={ii:{}, ni:{}, mo:{}};

  // The extauth object holds the current state of affairs.
	if (!(extauth instanceof Object)) {
		extauth = {sessionData:rb.page.session.read()};

    // Recover the last-used community if it exists.
		if( extauth.sessionData._rb$login != null && extauth.sessionData._rb$login.lastCommunity!=null)
			extauth.sessionComm = extauth.sessionData._rb$login.lastCommunity;
	}

  // Utility functions
  extauth.uriHost = function(secure){
    var host = rb.page.getHeader("Host");
    var method = ( (rb.page.env.ServerPort() != 0 && rb.page.env.ServerPort() != 80) || secure ) ? 'https' : 'http';
    if( host == null )
        host = rb.page.env.ServerName();
    return(method+'://'+host);
  }
  extauth.httpRedirect = function(uriStr,secure){
    var uri = new String(uriStr);

    var resp = 303;
    var brws = rb.page.env.UserAgent();
    if( brws.match(/^Mozilla\/4\./) != null )
    resp = 302;

    if(uri != null && uri != ""){
        if(uri.match(/^https*:\/\//i) == null)
            uri = extauth.uriHost(secure)+rb.page.abspath(uri);
        rb.page.HTTPreturn(resp, "See Also "+uri);
        rb.page.writeheader("Location", uri);
    }
  }
  extauth.isIn = function(commList) {
    if (commList=='')
      // Really don't care!
      return true;
      
    if (commList=='^*')
      return !extauth.sessionAuth;

    return (extauth.sessionAuth && (commList=='*' || (_rb$extauth_isin(extauth.sessionUser, commList)!=null)));
  }
	function _rb$extauth_notnull(val) { return ( val != null ? val : "" ) }

  // A tagtree regenerator and displayer that is recursion safe.
  // ("tag" is local, so regenrate can't destroy it...)
	function _rb$extauth_saferegen(tag) {
		   rb.page.write(tag.execute().bodytext());
	}

  // Return the individualInfo data for the currently logged in user (if any). This is preferable to using
  // the name and looking up in the contact template because generally the extauth module caches information
  // it has already used.
  extauth.userInfo = function(name) {
  var userInfo;
    if (name==null)
      name = extauth.sessionUser;
    if (extauth.sessionAuth) {
		  if( _rb$extauth_cache.ii[name] == null ) {
			  userInfo=rb.contact.individualInfo(-1,name);
			  _rb$extauth_cache.ii[name] = userInfo;
		  }
      else
			  userInfo = _rb$extauth_cache.ii[name];
    }
    return userInfo;
  }

  extauth.flushMemberOf = function() {
    var sessData = rb.page.session.read();
    extauth.sessionData = sessData;

    delete sessData._rb$memberOf;
    rb.page.session.write(extauth.sessionData);
  }

  extauth.memberOf = function(userId) {
    var sessData = rb.page.session.read();
    extauth.sessionData = sessData;

    if (sessData._rb$memberOf==null || sessData._rb$memberOf.ID!=userId) {
      // Not cached - so read from contact and update the session data.
      var membOf = [];

      // Use the iterator interface from the new contact template to build this list now.
      var it = rb.contact.get([],{searchOU:1,searchIndividual:1,searchCommunity:1,memberOf:userId,allData:2});
      while (it.getNextRow())
        membOf.push({ID:it.ID, uName:it.uName});

      // rb.contact.memberOf(userId);
      sessData._rb$memberOf = {ID:userId, data:membOf};

      rb.page.session.write(sessData);

      return sessData._rb$memberOf.data;
    }
    // OK - have it in the session cache so return now.
    return sessData._rb$memberOf.data;
  }
  // Check if an individual is in a community or OU
	function _rb$extauth_isin(user,comm) {

    comm = new String(comm);
    var commlist = comm.split(',');

    var needOut={};
    var checkOut = false;

    // If the first character of the name is '^' then they must *not* be in that 
    // community! If they are in that community then doesn't matter what else 
    // is true - they fail the test. If the item is a number then check the ID field.
    var newCommList=[];

    for (var c=0;c<commlist.length;c++) {
      if (commlist[c][0]=='^') {
        checkOut=true;
        needOut[commlist[c].substr(1)]=1;
      }
      else
        newCommList.push(commlist[c]);
    }

    if (checkOut)
      commlist=newCommList;

    comm=commlist.join(',');

    // To do a 'memberOf' I need the ID, not the name!
    var userId=extauth.uNameToId(user);

		if (userId<0)
			// user record vanished!
			return null;
		else {
      if( _rb$extauth_cache.mo[user] != null ) {
				_rb$extauth_member_arr=_rb$extauth_cache.mo[user];
      } else {
        // Not in the user cache - check the sessiondata cache.
        _rb$extauth_member_arr = extauth.memberOf(userId);
				_rb$extauth_cache.mo[user]=_rb$extauth_member_arr;
			} 

      // Check the banned list first.
      if (checkOut) {
				for (var y=0; y<_rb$extauth_member_arr.length; y++) {
					if (needOut[_rb$extauth_member_arr[y].uName]==1) {
						return null;
          }
				}
      }
			if (comm=="*")
			  return user;

      // OK - not banned - check inclusive list.

      for (var y=0; y<_rb$extauth_member_arr.length; y++) {
        for (var x in commlist) {
          if (!isNaN(parseInt(commlist[x]))) {
					  if (_rb$extauth_member_arr[y].ID == commlist[x])
						  return commlist[x];
          }
          else {
					  if (_rb$extauth_member_arr[y].uName == commlist[x])
						  return commlist[x];
          }
				}
			}
		}
    return null;
	}
  function extlogout(action) {
    // Ensure the basic required objects exist.
	  extauth.sessionData = rb.page.session.read();
	  if( !extauth.sessionData._rb$login )
		  extauth.sessionData._rb$login = {};

    extauth.sessionData._rb$userCache = {};

    // Read any session data to discover if we're already logged in.
	  extauth.sessionUser   = _rb$extauth_notnull(extauth.sessionData._rb$login.User);
	  extauth.sessionUserId = extauth.sessionData._rb$login.UserId;
	  extauth.sessionParent = extauth.sessionData._rb$login.Parent;
	  extauth.sessionAuth   = extauth.sessionData._rb$login.Auth;
	  extauth.sessionTime   = extauth.sessionData._rb$login.Time;
	  extauth.sessionExp    = parseInt(extauth.sessionData._rb$login.Exp);

    // Log out of the currect user/community
    // and display the contents of the tag.
	  extauth.sessionData._rb$login = {};
	  extauth.sessionData._rb$login.lastCommunity = "default";

    delete extauth.sessionData._rb$memberOf;
    delete extauth.sessionData._rb$userCache; // Place to store data specific to current user while their session lasts.

	  rb.page.session.write(extauth.sessionData);

	  if( typeof(action) == "string" && action == "do_regenerate" ) {
		  // Logged out, now display stuff from within login tag.
		  _rb$extauth_saferegen(rb.xml.thisTag());
	  }
	  extauth.sessionPass=void 0;
	  extauth.sessionAuth=false;
	  extauth.sessionUser="";

    // Finally - if cookie login is allowed, delete the cookie.
    rb.page.cookie['delete']('whitebeamCL');
  }
  extauth.userCache = function(useOld) {
    if (useOld && extauth.sessionData!=null && extauth.sessionData._rb$userCache!=null)
      return extauth.sessionData._rb$userCache;

    extauth.sessionData = rb.page.session.read();

    if (extauth.sessionData._rb$userCache==null)
      extauth.sessionData._rb$userCache = {};
    return extauth.sessionData._rb$userCache;
  }
  extauth.writeUserCache = function(data) {
    extauth.sessionData = rb.page.session.read();
    extauth.sessionData._rb$userCache = data;
    rb.page.session.write(extauth.sessionData);
  }
  extauth.flushCache = function() {
    extauth.sessionData = rb.page.session.read();
    delete extauth.sessionData._rb$userCache;
    delete extauth.sessionData._rb$memberOf;
    rb.page.session.write(extauth.sessionData);
  }
</rb:script>

<rb:macrotag name="rbm:extauth">
  _rb$extauth_array.push(extauth.toSource());

  // Get the parameters passed into the tag.
  extauth.attribs = rb.page.attributes();

  var foundReq=false;

  if (extauth.attribs.proj!=null && extauth.attribs.task!=null) {
    // Attempt to use project information for this task. Specified?
    if (Access!=null && Access.grant!=null && Access.grant[extauth.attribs.proj]!=null) {
      foundReq=true;
      extauth.sessionComm = Access.getcomm(extauth.attribs.proj,extauth.attribs.task);
    }
  }
  if (!foundReq) {
    if (extauth.attribs.community==null) {
      // MUST have Access defined for this module.
      rb.debug.error("Must have access table for module '"+extauth.attribs.proj+"'");
    }
    else {
      // Fall back to community auth.
      extauth.sessionComm = extauth.attribs.community == null ? "default" : extauth.attribs.community;
    }
  }

  extauth.sessionMand= extauth.attribs.mandatory == null ? "yes" : extauth.attribs.mandatory;
  if (extauth.sessionComm=='') {
    // If extauth specifies an empty community then login cannot be mandatory
    extauth.sessionMand='no';
  }
    
  // Ugh, this deep fudge only works because we know how the RB
  // data-centre handles SSL sites. Will NOT work anywhere else
  // where non https sites are on port != 80
  // What we really need is to have rb.page.env give us access to
  // mod_ssl variables!
  var isSSL = (rb.page.env.ServerPort() != 80 && rb.page.env.ServerPort() != 0);

  if (extauth.attribs.ssl!=null) {
    extauth.sessionSSL = false;
  
    if ( extauth.attribs.ssl.match(/^yes$/i))
      extauth.sessionSSL = true;
  }

  extauth.authfail   = _rb$extauth_notnull(extauth.attribs.authfail);
  extauth.replaceonfail= _rb$extauth_notnull(extauth.attribs.replaceonfail);

  extauth.postMethod = (isSSL || (extauth.sessionSSL == true && enableSSL))?'https://':'http://';

  if (extauth.replaceonfail != "" )
    extauth.authfail = extauth.replaceonfail;

  // Ensure the basic required objects exist.
  extauth.sessionData= rb.page.session.read();

  if (extauth.sessionData._rb$login==null) {
    extauth.sessionData._rb$login = {};
    delete extauth.sessionData._rb$memberOf;
    rb.page.session.write(extauth.sessionData);
  }

  // Read any session data to discover if we're already logged in.
  extauth.sessionUser   = _rb$extauth_notnull(extauth.sessionData._rb$login.User);
  extauth.sessionUserId = extauth.sessionData._rb$login.UserId;
	extauth.sessionParent = extauth.sessionData._rb$login.Parent;
  extauth.sessionAuth   = extauth.sessionData._rb$login.Auth;
  extauth.sessionTime   = extauth.sessionData._rb$login.Time;
  extauth.sessionExp    = parseInt(extauth.sessionData._rb$login.Exp);

  // If we're being asked to check for a different community, we need to check
  // that the user in in that community!
  if (extauth.sessionUser.length>0) {
    _rb$extauth_cache.ni[extauth.sessionUser]=extauth.sessionUserId;
    _rb$extauth_check = _rb$extauth_isin(extauth.sessionUser,extauth.sessionComm);
  }
  else
    _rb$extauth_check = null;

  if( _rb$extauth_check == null && extauth.sessionComm)
    extauth.sessionAuth = false;
  else
    extauth.sessionComm = _rb$extauth_check;

  // If login has expired, zap the authorisation so that we fail.
  var _rb$extauth_now = (new Date().getTime())/1000;
  if (extauth.sessionExp > 0 && _rb$extauth_now-(extauth.sessionExp * 60) > extauth.sessionTime )
    extauth.sessionAuth = false;

  // Test for login values OK, or mandatory == "no"
    if( (!extauth.sessionAuth || (extauth.sessionSSL && !isSSL && enableSSL)) && extauth.sessionMand.toLowerCase() != "no" ) {
    // FAIL: Not authenticated, and mandatory == "yes"
    // So we remove any session data to be sure we have clean data.
    if( extauth.authfail != "ignore" ) {
      // There are two options in the case where auth fails. The old way was to effectively log the user out. New
      // behaviour allows the user to remain logged into the system - which works for those sites that simply want
      // to show a failure message.
      if (Config==null || Config.feature.authfail!='leave') {
        // Old behaviour. Logout.
        extauth.sessionData= rb.page.session.read();
        extauth.sessionData._rb$login = {lastCommunity:extauth.sessionComm};
        rb.page.session.write(extauth.sessionData);
        delete extauth.sessionUser;
        delete extauth.sessionData;
      }    
      if (extauth.replaceonfail.length > 0 ) {
        extauth.calldata = rb.page.formdata();
        extauth.calldata.sessionComm = extauth.sessionComm;
        if (_rb$extauth_do_login_from_params() ) {
          _rb$extauth_saferegen(rb.xml.thisTag());
        } else {
          _rb$extauth_if=rb.xml.root.findId("rbm_extinclude")[0];
          rb.page.write(_rb$extauth_if.execute().bodytext());
        }
      } else if( extauth.authfail.length > 0 ) {
        extauth.httpRedirect(extauth.authfail);
      } else {
        rb.page.write("<h1>Authorisation failed!</h1>");
      }
    } else {
      // authfail="ignore" acts a bit like a login-OK...
      extauth.sessionData = rb.page.session.read();
      extauth.sessionData._rb$login.Time=_rb$extauth_now;
      extauth.sessionData._rb$login.lastCommunity=extauth.sessionComm;
      rb.page.session.write(extauth.sessionData);
    }
  } 
  else {
    // Authenticated OK or mandatory="no".
    // So update timeout, store last-used CommunityName and output the body.
    if( extauth.sessionAuth == null || extauth.sessionAuth == "" )
      extauth.sessionAuth = false;
    
    extauth.sessionData = rb.page.session.read();
    extauth.sessionData._rb$login = 
      { User:extauth.sessionUser,
        UserId:extauth.sessionUserId,
        Parent:extauth.sessionParent,
        Auth:extauth.sessionAuth, 
        Time:_rb$extauth_now, 
        lastCommunity:extauth.sessionComm
      };
    rb.page.session.write(extauth.sessionData);
    extauth.sessionData = null;
  
    _rb$extauth_saferegen(rb.xml.thisTag());
  }
  extauth=eval(_rb$extauth_array.pop());
</rb:macrotag>

<rb:script>
extauth.uNameToId = function(name) {
  // May know this translation already.
  var id=_rb$extauth_cache.ni[name];
  if (id!=null)
    return id;

  var contact=_rb$extauth_cache.ii[name];
  if (_rb$extauth_cache.ii[name] == null ) {
    contact=rb.contact.individualInfo(-1,name);
    if (contact!=null) {
      _rb$extauth_cache.ii[name]=contact;
      _rb$extauth_cache.ni[name]=contact.ID;
    }
  }
  return contact==null?-1:contact.ID;
}
extauth.doLogin = function(user,comm,expire,saveCookie) {
	extauth.sessionUser = user;
	extauth.sessionComm =(comm == null) ? "default" : comm;

  // Validated the user, and they're in one of the listed
  // communities, or OUs.
  // ie. Logged in OK, so display stuff from within authok page
	extauth.sessionComm = _rb$extauth_check;

  // Write this back to session... (So go and get the session!)
	extauth.sessionData= rb.page.session.read();

  delete extauth.sessionData._rb$userCache;

	if (extauth.sessionData._rb$login==null)
		extauth.sessionData._rb$login = {};

	extauth.sessionPass=void 0;
	extauth.sessionAuth=true;
	extauth.sessionData._rb$login.lastCommunity=extauth.sessionComm;
	extauth.sessionData._rb$login.User=extauth.sessionUser;
	extauth.sessionData._rb$login.Exp =parseInt(expire);
	extauth.sessionData._rb$login.Auth=true;
  extauth.sessionData._rb$login.Time =(new Date().getTime())/1000;
  extauth.sessionUserId =
	extauth.sessionData._rb$login.UserId=extauth.uNameToId(extauth.sessionUser);

  // Update login stats.
  var user = extauth.userInfo(extauth.sessionUser);
	extauth.sessionData._rb$login.Parent=user.parent;

  rb.page.session.write(extauth.sessionData);
	extauth.sessionData=void 0;

  if (user.customData==null)
    user.customData = {};

  extauth.sessionParent = user.parent;

  // Deal with cookie information.
  if (saveCookie && Config.feature!=null && Config.feature.cookielogin==true) {
    if (user.customData.rb$keyData==null)
      user.customData.rb$keyData=[rb.page.session.id()];
    else 
      user.customData.rb$keyData.unshift(rb.page.session.id());

    var dt=new Date(2030,12,31);
    rb.page.cookie.write('whitebeamCL',rb.page.session.id()+'/'+user.uName,'/',null,dt.toGMTString());
    if (user.customData.rb$keyData.length>4)
      user.customData.rb$keyData.length=4;
  }

  user.customData.rb$lastLogin = user.customData.rb$thisLogin;
  user.customData.rb$thisLogin = new Date;

  if (user.customData.stats==null || user.customData.stats.ms==null)
    user.customData.stats = {logins:0,wk:[],ms:'',m:[]};

  var stats = user.customData.stats;

  stats.logins++;
  
  // Monthly stats.
  var thisy = (user.customData.rb$thisLogin.getFullYear())-2000;
  var thism = (user.customData.rb$thisLogin.getMonth()+1);

  // Now - need to find the stats record for this month.
  mnth = stats.m;

  if (mnth.length>0 && stats.ms!='') {
    d=stats.ms.split('/');
    m=parseInt(d[1]);
    y=parseInt(d[0]);

    while (y<thisy && m<thism) {
      m++;
      if (m>12) {
        m=1;y++;
      }
      mnth.unshift(0);
    }
    if (mnth.length>12)
      mnth.length=12;
    mnth[0]++;
    stats.ms=(''+thisy+'/'+thism);
  }
  else {
    stats.ms=(''+thisy+'/'+thism);
    mnth[0] = 1;
  }
  rb.contact.modifyIndividual(user);

  // Finally - are we meant to be tracking latest logins?
  if (Config!=null && Config.feature.loginlist!=null && Config.feature.loginlist>0 && SysData.loginRecord!=null) {
    var it = rb.catalogue.item.get({ID:SysData.loginRecord, idMkr:'I',allLevels:0,nextLevel:0});
    if (it.getNextRow()) {
      // If this user is already in the list - delete their entry.
      for (var u=0;u<it.itemData.users.length;u++) {
        if (it.itemData.users[u].ID==user.ID) {
          it.itemData.users.splice(u,1);
          break;
        }
      }
      // Add data for this user.
      var rec={ID:user.ID, uName:user.uName,t:new Date};
      if (user.name!=null && user.name!='')
        rec.name=user.name;
      it.itemData.users.unshift(rec);
      if (it.itemData.users.length>Config.feature.loginlist)
        it.itemData.users.length = Config.feature.loginlist;
      rb.catalogue.item.modify(it);
    }
  }
}

function extlogin(user,pass,comm,expire,ssl,saveCookie,fromCookie) {
  // Flush cache when we attempt to login to make sure we're not storing old data.
  extauth.flushCache();

  extauth.sessionUser = user;
  extauth.sessionPass = pass;
  extauth.sessionComm = comm == null ? "default" : comm;
  extauth.sessionAuth = false;
  extauth.sessionCook = fromCookie;

	// Ugh, this deep fudge only works because we know how the RB
	// data-centre handles SSL sites. Will NOT work anywhere else
	// where non https sites are on port != 80
	// What we really need is to have rb.page.env give us access to
	// mod_ssl variables!
	var isSSL = (rb.page.env.ServerPort() != 0 && rb.page.env.ServerPort() != 80);

  // Test for login values OK.
	if ( fromCookie!=null || 
        (extauth.sessionPass != null && extauth.sessionUser.length > 0 && 
        rb.contact.validate(extauth.sessionUser, extauth.sessionPass, extauth.sessionUser) == 1 &&
	      (_rb$extauth_check=_rb$extauth_isin(extauth.sessionUser, extauth.sessionComm)) != null &&
	      (ssl == null || !enableSSL || isSSL == ssl))) {
    if (Config==null || Config.accountLock==null || !_rb$extauth_isin(extauth.sessionUser,Config.accountLock.comm))
      extauth.doLogin(user,comm,expire,saveCookie);
    else {
      // Member exists, but is part of the lockout community. If 'Config' tells us what 
      // to do with them then redirect to that page.
      if (Config.accountLock.fail!=null)
        extauth.httpRedirect(Config.accountLock.fail+'?uName='+user);
    }
		return true;
	} 
	return false;
}

// Check to see whether cookie login is allowed, and if so whether we have the data we need.
function extLoginFromCookie() {
  if (Config.feature!=null && Config.feature.cookielogin==true) {
    // Cookie login *is* allowed. Do we have a cookie?
    cookie=rb.page.cookie.read()['whitebeamCL'];

    if (cookie!=null) {
      // value of cookie is 'key/usrname'
      var obj=cookie.split('/');
      if (obj.length==2) {
        // Need the userdata.
        if (extauth.uNameToId(obj[1])>0) {
          // Username is OK
          var usrData = _rb$extauth_cache.ii[obj[1]];
          // Check stored key data.
          if (usrData!=null && usrData.customData!=null && usrData.customData.rb$keyData!=null) {
            var keyData=usrData.customData.rb$keyData;
            for (var c=0;c<keyData.length;c++) {
              if (keyData[c]==obj[0]) {
                // OK - log in from this cookie. Before doing this, update the cookie info so it's
                // correctly saved during login.
                usrData.customData.rb$keyData=keyData.splice(c,1);
                usrData.customData.rb$keyData.unshift(rb.page.session.id());

                // Plant the cookie.
                var dt=new Date(2030,12,31);
                rb.page.cookie.write('whitebeamCL',rb.page.session.id()+'/'+usrData.uName,'/',null,dt.toGMTString());
              
                //log this individual into the system and write a new cookie value.
                extlogin(usrData.uName, null, '*', null, null, null, true);
                break;
              }
            }
          }
        }
      }
    }
  }
}


function _rb$extauth_do_login_from_params() {
  // Ensure the basic required objects exist.
  extauth.sessionData= rb.page.session.read();
  if (!extauth.sessionData._rb$login)
    extauth.sessionData._rb$login = {};
  
  // Get the parameters passed into the tag.
  // and establish defaults where possible.
  extauth.attribs=rb.page.attributes();
  extauth.sessionComm = extauth.attribs.community == null ? "default" : extauth.attribs.community;
  extauth.sessionUser= extauth.attribs.user != null ? extauth.attribs.user :
  _rb$extauth_notnull(extauth.sessionData._rb$login.User);
  extauth.sessionPass= extauth.attribs.password;

  if(extauth.attribs.ssl != null){
    extauth.sessionSSL = false;
    
    if(extauth.attribs.ssl.match(/^yes$/i))
      extauth.sessionSSL = true;
  }
  var isSSL = (rb.page.env.ServerPort() != 80 && rb.page.env.ServerPort() != 0);
  if(isSSL || (extauth.sessionSSL == true && enableSSL))
    extauth.postMethod = 'https://';
  else
    extauth.postMethod = 'http://';
  
  extauth.authok     = _rb$extauth_notnull(extauth.attribs.authok);
  extauth.sessionData._rb$login.Exp = parseInt(extauth.attribs.expiry);
  extauth.sessionAuth = false;
  
  // Get formdata if supplied
  if( extauth.calldata.sessionUser != null && extauth.calldata.sessionUser.length > 0 ) {
    extauth.sessionUser = extauth.calldata.sessionUser;
    extauth.sessionPass = _rb$extauth_notnull(extauth.calldata.sessionPass);
  }
  if( extauth.calldata.sessionComm != null && extauth.calldata.sessionComm.length > 0 ) {
    extauth.sessionComm = _rb$extauth_notnull(extauth.calldata.sessionComm);
  }
  if( extauth.calldata.sessionExp != null ) {
    extauth.sessionData._rb$login.Exp = parseInt(extauth.calldata.sessionExp);
  }
  extauth.sessionData._rb$login.Time =(new Date().getTime())/1000;
  extauth.calldata = void 0;
  
  return extlogin(extauth.sessionUser,extauth.sessionPass,extauth.sessionComm,extauth.sessionData._rb$login.Exp,extauth.sessionSSL);
}
</rb:script>

<rb:macrotag name="rbm:extlogin">
	_rb$extauth_array.push(extauth.toSource());

  // Test for login values OK.
	extauth.calldata = rb.page.formdata();
	if (_rb$extauth_do_login_from_params()) {
		if (extauth.authok.length > 0) {
			if (extauth.authok != "ignore")
				extauth.httpRedirect(extauth.authok);
		} 
    else
			rb.page.write("<h1>Logged in OK.</h1>");
	} 
  else {
    // Not-yet logged in, or login failed, so present the body of the tag
    // which should collect login data.
		_rb$extauth_saferegen(rb.xml.thisTag());
	}

	extauth=eval(_rb$extauth_array.pop());
</rb:macrotag>

<rb:macrotag name="rbm:extlogout">
	extlogout("do_regenerate");
</rb:macrotag>

<rb:block rb:id="rbm_extinclude">
	<rb:include rb:eval="src#extauth.replaceonfail"/>
</rb:block>
