
function update_all_sysfiles() {
   sys_data={};
   sys_data.adminmail=DB.get_attrib("adminmail");
   sys_data.hostname=DB.get_attrib("hostname");
   sys_data.domain_name=DB.get_attrib("domain_name");
   sys_data.dns_ip1=DB.get_attrib("dns_ip1");
   sys_data.dns_ip2=DB.get_attrib("dns_ip2");
   sys_data.ntp_server=DB.get_attrib("ntp_server");

   snom_config_rewrite(DB.get_attrib("hostname","pabx.phone.voipcortex.co.uk"));
   sendmail_config_rewrite(DB.get_attrib("mailserver",""),DB.get_attrib("domain_name","phone.voipcortex.co.uk"));
   sendmail_config_rewrite(DB.get_attrib("mailserver",""),DB.get_attrib("domain_name",""));
   zaptel_config_rewrite(DB.get_attrib("isdn30_lines","8"),DB.get_attrib("isdn30_linesB","8"),DB.get_attrib("isdn30_linesC","8"),DB.get_attrib("isdn30_linesD","8"));
   sys_config_rewrite();
}

function sendmail_config_rewrite(hostname,domainname) {
    var smconf=new Binary();
    var prefix="/config/configs/";
    if( !smconf.open(prefix+"sendmail_ds.txt",smconf.modeWrite) ) {
      rb.debug.write("Cannot open "+prefix+"sendmail_ds.txt for writing!<br>\n");
      return;
    }
    var output="DS"+hostname;
    if( domainname != null && domainname.length > 0 ) {
      output += "\nDM"+domainname;
    }
    smconf.write(output);
    smconf.close;
}

function dhcpd_config_rewrite(fqhn,ip,netmask,dns1,dns2,start,end,defgw) {
    rb.debug.write("In dhcpd_config_rewrite<br>\n");
    var ddconf=new Binary();
    var output_d = new Binary();
    var prefix="/config/configs/";
    var subdir='/config/basefiles';

    fqhn_parts=fqhn.split(/\./);
    if( fqhn_parts.length < 2 ) {
      rb.debug.write("Hostname is not fully qualified!<br>\n");
      return;
    }
    var hostname=fqhn_parts.shift();
    var domainname=fqhn_parts.join(".");

    if( dns1 == null || dns1 == "" || dns1 == "127.0.0.1" ) dns1=ip;
    if( dns2 == "127.0.0.1" ) dns2=ip;
    if( dns2 == null || dns2 == "" )
      bind = dns1;
    else
      bind = dns1+", "+dns2;

    var nm_bits = netmask.split(/\./);
    var ip_bits = ip.split(/\./);
    var ip_bits_s = start.split(/\./);
    var ip_bits_e = end.split(/\./);
    ip_net=[0,0,0,0];
    ip_net_s=[0,0,0,0];
    ip_net_e=[0,0,0,0];
    for( var i=0; i<4; i++ ) {
      ip_net[i] = ip_bits[i] & nm_bits[i];
      ip_net_s[i] = ip_bits_s[i] & nm_bits[i];
      ip_net_e[i] = ip_bits_e[i] & nm_bits[i];
    }
    if( ip_net.join(".") != ip_net_s.join(".") ) {
      rb.debug.write("DHCP Start address is in wrong network!<br>\n");
      return;
    }
    if( ip_net.join(".") != ip_net_e.join(".") ) {
      rb.debug.write("DHCP End address is in wrong network!<br>\n");
      return;
    }

    if( !ddconf.open(prefix+"dhcpd_conf",ddconf.modeWrite) ) {
      rb.debug.write("Cannot open "+prefix+"dhcpd_conf for writing!<br>\n");
      return;
    }
    if( !output_d.load(subdir+'/dhcpd_conf') ) {
      rb.debug.write("Cannot open "+subdir+"/dhcpd_conf for reading!<br>\n");
      ddconf.close();
      return;
    }

    ddconf.write(output_d.toString().replace(/DOMAIN_NAME/g,domainname).replace(/BIND_SERVERS/g,bind).replace(/NTP_SERVERS/g,ip).replace(/HOST_NAME/g,hostname+"."+domainname).replace(/SUB_NET/g,ip_net.join(".")).replace(/NET_MASK/g,netmask).replace(/DEF_GATE/g,defgw).replace(/DHCP_RANGE/g,start+" "+end));
    ddconf.close();
}

function named_config_rewrite(fqhn,ip,dns1,dns2) {
    rb.debug.write("In named_config_rewrite<br>\n");
    var ndconf=new Binary();
    var ndzone=new Binary();
    var output_c = new Binary();
    var output_z = new Binary();
    var prefix="/config/configs/";
    var subdir='/config/basefiles';

    fqhn_parts=fqhn.split(/\./);
    if( fqhn_parts.length < 2 ) {
      rb.debug.write("Hostname is not fully qualified!<br>\n");
      return;
    }
    var hostname=fqhn_parts.shift();
    var domainname=fqhn_parts.join(".");

    if( dns1 == ip ) dns1="127.0.0.1";
    if( dns2 == ip ) dns2="127.0.0.1";

    var forwarders = "forwarders { "+(dns1!=""&&dns1!="127.0.0.1"?(dns1+"; "):"")+(dns2!=""&&dns2!="127.0.0.1"?(dns2+"; "):"")+"};";
    if( forwarders == "forwarders { };" )
      forwarders = "";
    else
      forwarders += "\n\tforward only;";

    if( !ndconf.open(prefix+"named_conf",ndconf.modeWrite) ) {
      rb.debug.write("Cannot open "+prefix+"named_conf for writing!<br>\n");
      return;
    }
    if( !ndzone.open(prefix+"named_zone",ndzone.modeWrite) ) {
      rb.debug.write("Cannot open "+prefix+"named_zone for writing!<br>\n");
      ndconf.close();
      return;
    }
    if( !output_c.load(subdir+'/named_conf') ) {
      rb.debug.write("Cannot open "+subdir+"/named_conf for reading!<br>\n");
      ndconf.close();
      ndzone.close();
      return;
    }
    if( !output_z.load(subdir+'/named_zone') ) {
      rb.debug.write("Cannot open "+subdir+"/named_zone for reading!<br>\n");
      ndconf.close();
      ndzone.close();
      return;
    }
    var d=new Date()
    var serial=Math.floor(d.valueOf()/1000);
    ndconf.write(output_c.toString().replace(/DOMAIN_SUBST/g,domainname).replace(/FORWARDER_SUBST/g,forwarders));
    ndzone.write(output_z.toString().replace(/DOMAIN_SUBST/g,domainname).replace(/HOSTNAME_SUBST/g,hostname).replace(/SERIAL_SUBST/g,serial).replace(/IP_SUBST/g,ip));
    ndconf.close;
    ndzone.close;
}

function snom_config_rewrite(hostname) {
    rb.debug.write("In snom_config_rewrite<br>\n");
    var files=[ 'snom190.htm','snom300.htm','snom320.htm','snom360.htm','snom370.htm',
                'tftp_spa2000.cfg','tftp_spa942.cfg',
    		'tftp_spa921.cfg','tftp_spa922.cfg','tftp_spa1001.cfg','tftp_spa8000.cfg',
                'tftp_spa2002.cfg','tftp_spa2102.cfg','tftp_spa841.cfg','tftp_spa901.cfg',
		'tftp_spa941.cfg','tftp_aastra.cfg','tftp_init.cfg','tftp_spa962.cfg'
	      ]; 
    for( var x=0; x<files.length; x++ ) {
      var snomconf=new Binary();
      var subdir='/config/basefiles';
      var filecontents = new Binary();
      if( !filecontents.load(subdir+'/'+files[x]) ) {
        rb.debug.write("Cannot open "+subdir+"/"+files[x]+" for reading!<br>\n");
        continue;
      } else
        rb.debug.write("Opened "+subdir+"/"+files[x]+"<br>\n");
      var prefix="/";
      if( files[x].search(/^tftp/) != -1 )
        prefix="/config/configs/";
      if( !snomconf.open(""+prefix+files[x],snomconf.modeWrite) ) {
        rb.debug.write("Cannot open "+prefix+files[x]+" for writing!<br>\n");
        continue;
      }
      var base = filecontents.toString();
      snomconf.writeln(base.replace(/HOSTNAME/m,hostname));
      snomconf.close();
      rb.debug.write("Wrote "+prefix+files[x]+"<br>\n");
    }
}

function sys_config_rewrite() {
    rb.debug.write("In sys_config_rewrite<br>\n");
    var subdir='/config/configs';
    var basedir='/config/basefiles';

    ip = DB.get_attrib("my_ip","10.0.0.1");
    netmask = DB.get_attrib("my_mask","255.255.255.0");

// Work out what netmask and broadcast should be in case they are not defined.
    var ip_bits = ip.split(/\./);
    var nm_bits = netmask.split(/\./);
    def_net=[0,0,0,0];
    def_bcast=[0,0,0,0];
    for( var i=0; i<4; i++ ) {
      def_net[i] = ip_bits[i] & nm_bits[i];
      def_bcast[i] = ip_bits[i] | (255-nm_bits[i]);
    }

    my_net = DB.get_attrib("my_net",def_net.join('.'));
    my_bcast = DB.get_attrib("my_bcast",def_bcast.join('.'));

// Write file /etc/alaises
    rb.debug.write("/etc/aliases<br>\n");
    var conffile=new Binary();
    rb.debug.write("Opening "+subdir+"/aliases<br>\n");
    if( !conffile.open(subdir+'/etc_aliases',conffile.modeWrite) )
      rb.debug.write("Cannot open "+subdir+"/aliases for writing!<br>\n");
    else {
      rb.debug.write("Opened "+subdir+"/aliases<br>\n");
      var filecontents=new Binary();
      if( filecontents.load(basedir+'/etc_aliases') ) {
        conffile.writeln(filecontents.toString());
        if( sys_data.adminmail != null && sys_data.adminmail.length )
          conffile.writeln("root:\t\t"+sys_data.adminmail);
        else
          conffile.writeln("#root:\t\t"+sys_data.adminmail);
        conffile.close();
      }
    }

// Write file /etc/hosts
    rb.debug.write("/etc/hosts<br>\n");
    var conffile=new Binary();
    if( !conffile.open(subdir+'/etc_hosts',conffile.modeWrite) )
      rb.debug.write("Cannot open "+subdir+"/hosts for writing!<br>\n");
    else {
      conffile.writeln("127.0.0.1\tlocalhost.localdomain localhost");
      conffile.writeln(ip+"\t"+sys_data.hostname+" "+sys_data.hostname.replace(/^([^\.]+)\..*$/,"$1"));
      conffile.close();
    }

// Write file /etc/hostname
    rb.debug.write("/etc/hostname<br>\n");
    conffile=new Binary();
    if( !conffile.open(subdir+'/etc_hostname',conffile.modeWrite) )
      rb.debug.write("Cannot open "+subdir+"/etc_hostname for writing!<br>\n");
    else {
      conffile.writeln(sys_data.hostname);
      conffile.close();
    }

// If not using pro hardware, ensure vlan and 2nd NIC is all "off"
    if( ! _rb$mode.nic ) {
      DB.set_attrib("sec_ip","");
      DB.set_attrib("sec_mask","");
      DB.set_attrib("sec_vlan","");
      DB.set_attrib("my_vlan","");
    }

// Write file /etc/default/dhcp
    rb.debug.write("/etc/default/dhcp<br>\n");
    conffile=new Binary();
    if( !conffile.open(subdir+'/etc_default_dhcp',conffile.modeWrite) )
      rb.debug.write("Cannot open "+subdir+"/etc_default_dhcp for writing!<br>\n");
    else {
      var v1 = DB.get_attrib("my_vlan","");
      conffile.writeln('INTERFACES="eth0'+(v1!=""?'.'+v1:'')+'"');
      conffile.close();
    }

// Write file /etc/network/interfaces
    rb.debug.write("/etc/network/interfaces<br>\n");
    conffile=new Binary();
    if( !conffile.open(subdir+'/etc_network_interfaces',conffile.modeWrite) )
      rb.debug.write("Cannot open "+subdir+"/etc_network_interfaces for writing!<br>\n");
    else {
      var gw1 = DB.get_attrib("my_gw","10.0.0.254");
      var gw_net1 = DB.get_attrib("my_mask","255.255.255.0");
      var gw_net2 = DB.get_attrib("sec_mask","255.255.255.0");
      var gw_bits = gw1.split(/\./);
      var nm1_bits = gw_net1.split(/\./);
      var nm2_bits = gw_net2.split(/\./);
      gwn1=[0,0,0,0];
      gwn2=[0,0,0,0];
      for( var i=0; i<4; i++ ) {
        gwn1[i] = gw_bits[i] & nm1_bits[i];
        gwn2[i] = gw_bits[i] & nm2_bits[i];
      }
      gw_net1 = gwn1.join(".");
      gw_net2 = gwn2.join(".");

      var v1 = DB.get_attrib("my_vlan","");
      var v2 = DB.get_attrib("sec_vlan","");
      var i2 = DB.get_attrib("sec_ip","");
      var interfaces = "eth0";
      conffile.writeln("# Auto-generated. do not edit");
      if( v1 != "" )
        interfaces += " eth0."+v1;
      if( i2 != "" && v2 != "" )
        interfaces += " eth0."+v2;
      conffile.writeln("auto lo "+interfaces+"\n");
      conffile.writeln("iface lo inet loopback\n");
      conffile.writeln("# The primary network interface");
      if( v1 == "" )
        conffile.writeln("iface eth0 inet static");
      else { // v1 != ""
        if( i2 == "" || (i2 != "" && v2 != "" ) )
          conffile.writeln("iface eth0 inet manual\n");
        conffile.writeln("iface eth0."+v1+" inet static");
      }
      conffile.writeln("\taddress "+DB.get_attrib("my_ip","10.0.0.1"));
      conffile.writeln("\tnetmask "+DB.get_attrib("my_mask","255.255.255.0"));
      conffile.writeln("\tnetwork "+DB.get_attrib("my_net","10.0.0.0"));
      conffile.writeln("\tbroadcast "+DB.get_attrib("my_bcast","10.0.0.255"));
      if( i2 == "" || DB.get_attrib("my_net") == gw_net1 )
        conffile.writeln("\tgateway "+DB.get_attrib("my_gw","10.0.0.254"));

      if( i2 != "" ) {
        if( v2 == "" )
          conffile.writeln("\niface eth0 inet static");
        else {
          conffile.writeln("\niface eth0."+v2+" inet static");
        }
        conffile.writeln("\taddress "+DB.get_attrib("sec_ip"));
        conffile.writeln("\tnetmask "+DB.get_attrib("sec_mask"));
        conffile.writeln("\tnetwork "+DB.get_attrib("sec_net"));
        conffile.writeln("\tbroadcast "+DB.get_attrib("sec_bcast"));
        if( DB.get_attrib("sec_net") == gw_net2 )
          conffile.writeln("\tgateway "+DB.get_attrib("my_gw"));
      }
      conffile.close();
    }

// Write file /etc/resolv.conf
    rb.debug.write("/etc/resolv.conf<br>\n");
    conffile=new Binary();
    if( !conffile.open(subdir+'/etc_resolv.conf',conffile.modeWrite) )
      rb.debug.write("Cannot open "+subdir+"/resolv.conf for writing!<br>\n");
    else {
      if( sys_data.domain_name != null && sys_data.domain_name.length )
        conffile.writeln("search "+sys_data.domain_name);
      if( sys_data.dns_ip1 != null && sys_data.dns_ip1.length )
        conffile.writeln("nameserver "+sys_data.dns_ip1);
      if( sys_data.dns_ip2 != null && sys_data.dns_ip2.length )
        conffile.writeln("nameserver "+sys_data.dns_ip2);
      conffile.close();
    }

// Write file /etc/ntp.conf
    rb.debug.write("/etc/ntp.conf<br>\n");
    conffile=new Binary();
    if( !conffile.open(subdir+'/etc_ntp.conf',conffile.modeWrite) )
      rb.debug.write("Cannot open "+subdir+"/ntp.conf for writing!<br>\n");
    else {
      conffile.writeln("restrict default nomodify notrap noquery");
      conffile.writeln("restrict 127.0.0.1");
      conffile.writeln("fudge	127.127.1.0 stratum 10	");
      conffile.writeln("driftfile /var/lib/ntp/ntp.drift");
      conffile.writeln("broadcastdelay	0.008");
      conffile.writeln("#");
      conffile.writeln("server "+sys_data.ntp_server);
      conffile.writeln("server 127.127.1.0");
      conffile.close();
    }

    named_config_rewrite(DB.get_attrib("hostname"),ip,sys_data.dns_ip1,sys_data.dns_ip2);
    dhcpd_config_rewrite(DB.get_attrib("hostname"),ip,netmask,DB.get_attrib("dhcp_dns1",ip),DB.get_attrib("dhcp_dns2",""),DB.get_attrib("dhcp_start","10.0.0.100"),DB.get_attrib("dhcp_end","10.0.0.200"),DB.get_attrib("dhcp_gw","10.0.0.1"))
}

function zaptel_config_rewrite(isdn30,isdn30b,isdn30c,isdn30d) {
    rb.debug.write("In zaptel_config_rewrite<br>\n");
    var subdir='/config/configs';
    var basefiles='/config/basefiles/zaptel';

    var zap_sig = DB.get_attrib("bri_signalling","bri_cpe");
    var zap_rxg = DB.get_attrib("zaptel_rxgain","0.0");
    var zap_txg = DB.get_attrib("zaptel_txgain","0.0");

    var zapata_append="";
    var at_chan=DB.get_attrib("channelbank_start") - 0;
    var isdn_type=DB.get_attrib("isdn_type");

    var pgconn;
    if ((pgconn=DB.open())) {
      rb.debug.write("DATABASE open OK<br>");
      var pgres = pgconn.exec('SELECT num_ports, aux_ports FROM phone JOIN phone_type ON phone.phone_type = phone_type.phone_type WHERE is_zap=true AND port = 0 ORDER by mac');
      if( pgres!=null && pgres.success && pgres.numRows>0 ) {
        zapata_append="\n\
echocancel=no\n\
echocancelwhenbridged=no\n\
echotraining=no\n\
threewaycalling=yes\n\
transfer=yes\n\
rxgain=0.0\n\
txgain=0.0\n\
switchtype=national\n\
signalling=fxo_ks\n\
context=zap-local\n\
group=10\n\
";
        for( var r=0; r<pgres.numRows; r++) {
          var row = pgres.fetchRowObject(r);
          zapata_append += "immediate=no\nchannel => "+at_chan+"-"+(at_chan+row.num_ports-1)+"\n";
          zapata_append += "immediate=yes\nchannel => "+(at_chan+row.num_ports)+"-"+(at_chan+row.num_ports+row.aux_ports-1)+"\n";
          at_chan += row.num_ports + row.aux_ports;
        }
      }
    }

    if( isdn30 == 1 ) channels="channel => 1";
    else if( isdn30 <= 15 ) channels="channel => 1-"+isdn30;
    else if( isdn30 ==16 ) channels="channel => 1-15\nchannel => 17";
    else if( isdn30 >16 ) channels="channel => 1-15\nchannel => 17-"+(isdn30-0+1);
    if( isdn30 > 30 ) channels="channel => 1-15\nchannel => 17-31";
    channelsqz="";
    channelsA200="";
    channelsA2002="";
    channels4d=channels+"\n";
    channels4dB="";
    channels4dC="";
    channels4dD="";
    if( isdn30b == 1 ) channels4dB+="channel => 32";
    else if( isdn30b <= 15 ) channels4dB+="channel => 32-"+(isdn30b-0+31);
    else if( isdn30b ==16 ) channels4dB+="channel => 32-46\nchannel => 48";
    else if( isdn30b >16 ) channels4dB+="channel => 32-46\nchannel => 48-"+(isdn30b-0+32);
    channels4dB+="\n";
    if( isdn30c == 1 ) channels4dC+="channel => 63";
    else if( isdn30c <= 15 ) channels4dC+="channel => 63-"+(isdn30c-0+62);
    else if( isdn30c ==16 ) channels4dC+="channel => 63-77\nchannel => 79";
    else if( isdn30c >16 ) channels4dC+="channel => 63-77\nchannel => 79-"+(isdn30c-0+63);
    channels4dC+="\n";
    if( isdn30d == 1 ) channels4dD+="channel => 94";
    else if( isdn30d <= 15 ) channels4dD+="channel => 94-"+(isdn30d-0+93);
    else if( isdn30d ==16 ) channels4dD+="channel => 94-108\nchannel => 110";
    else if( isdn30d >16 ) channels4dD+="channel => 94-108\nchannel => 110-"+(isdn30d-0+94);
    channels4dD+="\n";

    grpB=DB.get_attrib("isdn30_groupB",1);
    grpC=DB.get_attrib("isdn30_groupC",1);
    grpD=DB.get_attrib("isdn30_groupD",1);

    linA=DB.get_attrib("isdn_line1",1);
    linB=DB.get_attrib("isdn_line2",1);
    linC=DB.get_attrib("isdn_line3",1);
    linD=DB.get_attrib("isdn_line4",1);

    channelsA200 += (linA==1?"channel => 1\n":"");
    channelsA2002 += (linA==1?"channel => 1\n":"");
    channels2d = channels4d;
    if( grpB == 1 && linB == 1 ) { channels4d += channels4dB; channelsqz += "channel => 4-5\n"; channelsA200 += "channel => 2\n"; channelsA2002 += "channel => 2\n"; channels2d += channels4dB; }
    if( grpC == 1 && linC == 1 ) { channels4d += channels4dC; channelsqz += "channel => 7-8\n"; channelsA200 += "channel => 3\n"; }
    if( grpD == 1 && linD == 1 ) { channels4d += channels4dD; channelsqz += "channel => 10-11\n"; channelsA200 += "channel => 4\n"; }
    if( grpB == 2 || grpC == 2 || grpD == 2 ) { channels4d += "group=2\n"; channelsqz += "group=2\n"; channelsA200 += "group=2\n"; channelsA2002 += "group=2\n"; channels2d += "group=2\n"; }
    if( grpB == 2 && linB == 1 ) { channels4d += channels4dB; channelsqz += "channel => 4-5\n"; channelsA200 += "channel => 2\n"; channelsA2002 += "channel => 2\n"; channels2d += channels4dB; }
    if( grpC == 2 && linC == 1 ) { channels4d += channels4dC; channelsqz += "channel => 7-8\n"; channelsA200 += "channel => 3\n"; }
    if( grpD == 2 && linD == 1 ) { channels4d += channels4dD; channelsqz += "channel => 10-11\n"; channelsA200 += "channel => 4\n"; }
    if( grpB == 3 || grpC == 3 || grpD == 3 ) { channels4d += "group=3\n"; channelsqz += "group=3\n"; channelsA200 += "group=3\n"; channelsA2002 += "group=3\n";}
    if( grpB == 3 && linB == 1 ) { channels4d += channels4dB; channelsqz += "channel => 4-5\n"; channelsA200 += "channel => 2\n"; channelsA2002 += "channel => 2\n"; }
    if( grpC == 3 && linC == 1 ) { channels4d += channels4dC; channelsqz += "channel => 7-8\n"; channelsA200 += "channel => 3\n"; }
    if( grpD == 3 && linD == 1 ) { channels4d += channels4dD; channelsqz += "channel => 10-11\n"; channelsA200 += "channel => 4\n"; }
    if( grpB == 4 || grpC == 4 || grpD == 4 ) { channels4d += "group=4\n"; channelsqz += "group=4\n"; channelsA200 += "group=4\n"; channelsA2002 += "group=4\n"; }
    if( grpB == 4 && linB == 1 ) { channels4d += channels4dB; channelsqz += "channel => 4-5\n"; channelsA200 += "channel => 2\n"; channelsA2002 += "channel => 2\n"; }
    if( grpC == 4 && linC == 1 ) { channels4d += channels4dC; channelsqz += "channel => 7-8\n"; channelsA200 += "channel => 3\n"; }
    if( grpD == 4 && linD == 1 ) { channels4d += channels4dD; channelsqz += "channel => 10-11\n"; channelsA200 += "channel => 4\n"; }

    var conffile=new Binary();
    var filecontents = new Binary();
    if( !conffile.open(subdir+'/zapata.conf',conffile.modeWrite) )
      rb.debug.write("Cannot open "+subdir+"/zapata.conf for writing!<br>\n");
    else {
      if( filecontents.load(basefiles+'/zapata_'+isdn_type+'.conf') )
        conffile.writeln(filecontents.toString().replace(/BRI_SIGNAL/g,zap_sig).replace(/RXGAIN/g,zap_rxg).replace(/TXGAIN/g,zap_txg));
      if( isdn_type == 'sangoma' || isdn_type == 'sangoma1d' )
        conffile.writeln(channels);
      if( isdn_type == 'sangoma2d' )
        conffile.writeln(channels2d);
      if( isdn_type == 'sangoma4d' )
        conffile.writeln(channels4d);
      if( isdn_type == 'sangomaA200' )
        conffile.writeln(channelsA200);
      if( isdn_type == 'qozap' )
        conffile.writeln(channelsqz);
      conffile.writeln(zapata_append);
      conffile.close();
    }
}
