<!--
(c) 2005-2008 IP Cortex Ltd.
All rights reserved.  Unauthorised copying is not permitted.

Portions (c) 2005 Yellowhawk Ltd.
All rights reserved.  Unauthorised copying is not permitted.
-->
<rb:script>
  var extauth;
  
  if (extauth==null) {
    // Prime incase we're not using 'extauth' for this file.
    extauth = {sessionUser:'', sessionAuth:'no'};
    extauth.isIn = function(str) {return false;}
  }

  function Menu(name) {
    // One of these per menu declared. Each menu has a name. Can have multiple menu blocks with 
    // the same name - in which case they are concatenated.
    this.selectItem = null;
    this.topItems   = [];
    this.keyedItems = {}
    this.name       = name;
    this.selItem    = item;

    Menu.namedMenus[name] = this;
  }
  Menu.namedMenus    = {};
  Menu.renderEngines = {};

  Menu.addEngine = function (engine) {
    Menu.renderEngines[engine.name] = engine;
  }

  Menu.render = function (menuName, engineName, data) {
    // Find the menu.
    var menu = Menu.namedMenus[menuName];
    if (menu==null) {
      return;
    }
    // Do we have a render engine with this name?
    var eng = Menu.renderEngines[engineName];
    if (eng)
      return eng.render(menu, data);
    else
      rb.debug.error("Can't find menu rendering engine called '"+engineName+"'");
  }

  Menu.getMenuByName = function (name) {
    var thisMenu = Menu.namedMenus[name];
    if (thisMenu == null) {
      // Declare a new menu.
      thisMenu = new Menu(name);
    }
    return thisMenu;
  }

  Menu.thisURL  = (typeof _rb$fakePath == "string")?_rb$fakePath:rb.page.env.Path();
  if (rb.page.env.QueryString())
    Menu.thisURL += '?'+rb.page.env.QueryString();

  Menu.setThisURL = function (url) {
    Menu.thisURL = url;
  }


  Menu.prototype.initItem = function(item) {
    // If there is an href - compare against the current href. If count then set the selected flag and the path flag on all ancestors.
    if (item.href) {
      // Normalise the href we use internally.
      if (item.href[0]=='?')
        item.href = rb.page.env.Path()+item.href;
      else if (item.href.indexOf('http:')!=0 || item.href.indexOf('https:')!=0)
        item.href = rb.page.abspath(item.href);

      // Compare against the current URL.
      item.selected = (Menu.thisURL.substr(0,item.href.length)==item.href)

      var recitem = item;

      if (item.selected) {
        this.selItem  = item;

        // If it is selected then mark as selected in all parent nodes.
        do {
          var recitem = recitem.parent;
          if (recitem)
            recitem.pathSelect = true;
        } while (recitem);
      } else if(item.expand) {
	// If it is marked for expansion, then do so.
        do {
          if (recitem)
            recitem.pathSelect = true;
          var recitem = recitem.parent;
        } while (recitem);
      }
    }
  }
  
  Menu.prototype.buildItems = function(itemTag, level, parent) {
    // Check for access restrictions. Apply as necessary.
    //dumpObj(extauth, "EXTAUTH");
    //rb.debug.write("itemtag - "+itemTag.toSource());
    if( itemTag.attributes==null) return;
    if (itemTag.attributes.access==null && itemTag.attributes.dynaccess!=null) {
      itemTag.attributes.access=eval(itemTag.attributes.dynaccess);
    }
    if (itemTag.attributes.access!=null) {
      //rb.debug.write("<h4>'access' attribute specified = 'itemTag.attributes.access' "+itemTag.attributes.access+"</h4>");
      if (!extauth.sessionAuth) {
	if(itemTag.attributes.access!="!")
          return null;
      }
      if (extauth.sessionAuth) {
	if(itemTag.attributes.access=="!")
          return null;
        if (itemTag.attributes.access!='*' && !extauth.isIn('admin,'+itemTag.attributes.access)) {
          // Access denied.
          return null;
        }
      }
    }
    // Build me.
    var item;
    if (itemTag.attributes.parent!=null) {
      // Defined parent - *must* be top level.
      // Refining definition of an existing item - MUST already exist.
      if (level!=1) {
        return;
      }
      item = this.keyedItems[itemTag.attributes.parent];
      if (item==null) {
        rb.debug.write(this.keyedItems.toSource()+"<br>");
        rb.debug.error("rbm:item: item referenced by name - not previously defined. Must define before use.");
        return null;
      }
      level = item.level;
    }
    else if (itemTag.name!=null) {
      // Defining a new top level item.
      item = new Array;
      item.disabled = itemTag.attributes.disabled;
      item.name    = itemTag.attributes.name;
      item.icon    = itemTag.attributes.icon;
      item.key     = itemTag.attributes.key==null ? item.name : itemTag.attributes.key;
      item.href    = itemTag.attributes.href!=null ? itemTag.attributes.href : '';
      item.blockId = itemTag.blockId ? itemTag.blockId : '';
      item.parent  = parent;
      item.attribs = itemTag.attributes;
      item.expand  = itemTag.attributes.expand;
      item.bodyText = "";

      for(i = 0; i < itemTag.length; i++){
	      if(itemTag[i].name != "rbm:item"){
	      	      if(itemTag[i].type == "text")
			      item.bodyText += itemTag[i].text.replace(/\s+/g, " ");
		      else
			      item.bodyText += itemTag[i].text().replace(/\s+/g, " ");

	      }

      }

      // Do some prep work on this item.
      this.initItem(item);

      if (this.keyedItems[item.key]!=null) {
        rb.debug.error("Named item '"+item.key+"' appears more than once in menu definition.");
        return null;
      }
      this.keyedItems[item.key] = item;
      item.level = level;

      // If it's a top level element then add it to the menu top level array.
      if (level==1)
        this.topItems.push(item);
    }
    // Have build this item. Now recursively build all children.
    if(itemTag.select)
	    var children = itemTag.select("rbm:item");
    else
	    var children = [];

    level++;
    for (var i=0 ; i<children.length ; i++) {
      // Have an item. Must have either a 'name' or a 'parent'.
      var child = this.buildItems(children[i], level, item);
      if (child)
        item.push(child);
    }
    return item;
  }

  Menu.dumpMenus =  function (indent) {
    for (var m in Menu.namedMenus) {
      rb.page.write("<h4>"+indent+m+"</h4>\n");
      dumpObj(Menu.namedMenus[m], 'aMenu');
    }
  }
</rb:script>

<rb:macrotag name="rbm:item">
  var tag     = rb.xml.thisTag();
  var attribs = tag.attributes;
  var item = tag;
  if (attribs.menu==null)
    attribs.menu = 'default';

  var thisMenu = Menu.getMenuByName(attribs.menu)
  var item = thisMenu.buildItems(tag,1)
</rb:macrotag>

<rb:macrotag name="rbm:setmenu">
  var tag = rb.xml.thisTag();

  if (tag.attributes.href!=null) {
    Menu.setThisURL(tag.attributes.href);
  }
</rb:macrotag>

