function create_user(rb$params) {
  var result=false;
  rb$params.uName     = rb$params.uName.replace(/[^a-zA-Z0-9\-_@]/g,'');
  rb$params.name      = rb$params.name.replace(/[^a-zA-Z0-9\.\s\-_]/g,'');
  rb$params.owned_extension = rb$params.owned_extension.replace(/[^a-zA-Z0-9\-_\.]/g,'');

  rb$params.vacation  = rb$params.vacation.replace(/[^0-9]/g,'');
  if( rb$params.vacation == null || rb$params.vacation.length < 3 ) {
    rb$params.vacation_mode = "off";
    rb$params.vacation = "";
  }
  if( rb$params.vacation_mode.search(/^(off|all|myext|owned)$/) == -1 )
    rb$params.vacation_mode = "off";

  rb$message = null;
  if( rb$params.pass1 == null )
    rb$params.pass1="";
  if( rb$params.pass2 == null )
    rb$params.pass2="";
  if( rb$params.owned_phone == null )
    rb$params.owned_phone="";
  if( rb$params.vmpin == null )
    rb$params.vmpin="";
  rb$params.vmpin=rb$params.vmpin.slice(0,8);
  if( rb$params.userpin == null )
    rb$params.userpin="";
  rb$params.userpin=rb$params.userpin.slice(0,8);
  if( rb$params.confpin == null )
    rb$params.confpin="";
  rb$params.confpin=rb$params.confpin.slice(0,8);

  if( rb$params.email.length > 0 && rb$params.email.search(/^[^@!"%]+@([a-zA-Z0-9-]+\.)+[a-zA-Z0-9-]+$/) == -1 ) {
    rb$message ='Please enter a valid email address, or leave blank.';
    rb$command ='create';
  } else if( rb$params.vmpin.length > 0 && rb$params.vmpin.search(/^[0-9]*$/) == -1 ) {
    rb$message ='Please enter a valid (numeric) Voicemail PIN number, or leave blank.';
    rb$command ='create';
  } else if( rb$params.userpin.length > 0 && rb$params.userpin.search(/^[0-9]*$/) == -1 ) {
    rb$message ='Please enter a valid (numeric) PIN number, or leave blank.';
    rb$command ='create';
  } else if( rb$params.confpin.length > 0 && rb$params.confpin.search(/^[0-9]*$/) == -1 ) {
    rb$message ='Please enter a valid (numeric) Conference PIN number, or leave blank.';
    rb$command ='create';
  } else if( (rb$params.pass1.length > 0 || rb$params.pass2.length > 0) && rb$params.pass1 != rb$params.pass2 ) {
    rb$message ='Passwords entered do not match.';
    rb$command ='create';
  } else if ((pgconn=DB.open())) {
    rb.debug.write("DATABASE open OK<br>");
    if( rb$params.owned_extension.length > 0 ) {
      var already_owned=0;
      var extn_exists=0;
      pgres = pgconn.exec('SELECT COUNT(*) FROM contact WHERE owned_extension = \''+PgsqlConnection.escape(rb$params.owned_extension)+'\'');
      if( pgres!=null && pgres.success && pgres.numRows>0 )
        already_owned = pgres.fetchRowArray(0)[0];

      pgres = pgconn.exec('SELECT company FROM virt_exten WHERE virt_exten = \''+PgsqlConnection.escape(rb$params.owned_extension)+'\'');
      if( pgres!=null && pgres.success && pgres.numRows>0 ) {
        extn_exists = pgres.numRows
        extn_company= pgres.fetchRowArray(0)[0];
      }

      if( already_owned != 0 ) {
        rb$message ='That home extension is already in use!';
        rb$command ='create';
      } else if( extn_exists == 0 ) {
        rb$message ='That home extension doesn\'t exist!';
        rb$command ='create';
      } else if( extn_company !=sess.company ) {
        rb$message ='That home extension does not belong to this company!';
        rb$command ='create';
      }
    }
    if( rb$params.owned_phone.length > 0 ) {
      var palready_owned=0;
      var phone_exists=0;
      pgres = pgconn.exec('SELECT COUNT(*) FROM contact WHERE owned_phone = \''+PgsqlConnection.escape(rb$params.owned_phone)+'\' AND owned_port = '+PgsqlConnection.escape(rb$params.owned_port));
      if( pgres!=null && pgres.success && pgres.numRows>0 )
        palready_owned = pgres.fetchRowArray(0)[0];

      pgres = pgconn.exec('SELECT company FROM phone WHERE mac = \''+PgsqlConnection.escape(rb$params.owned_phone)+'\' AND port=0 AND mac!=\'__EXTERNAL__\'');
      if( pgres!=null && pgres.success && pgres.numRows>0 ) {
        phone_exists = pgres.numRows
        phone_company= pgres.fetchRowArray(0)[0];
      }

      if( palready_owned != 0 ) {
        rb$message ='That phone is already in use!';
        rb$command ='create';
      } else if( phone_exists == 0 ) {
        rb$message ='That Phone doesn\'t exist!';
        rb$command ='create';
      } else if( phone_company !=sess.company ) {
        rb$message ='That phone does not belong to this company!';
        rb$command ='create';
      }
    }
    if( rb$message == null ) {
      user = new Object;
      user.uName     = rb$params.uName;
      user.name      = rb$params.name;
      user.email     = rb$params.email;
      newUser = rb.contact.createIndividual(user);

      if( newUser > 0 && (user.uName.length < 1 || user.name.length < 1) ) {
        rb.contact.remove(newUser);
        rb$message ='The Unique ID or the name is not valid!';
        rb$command ='create';
      } else if (newUser <= 0) {
        // Name is invalid! 
        rb$message ='The Unique ID (or one like it) is already in use!';
        rb$command ='create';
      } else {
    // Create asterisk DB object
        all_ok=false;
        user_comm=rb.contact.communityInfo(-1,"user");
        if( (pgres=pgconn.exec("START TRANSACTION")) && pgres.success )
          if( (pgres=pgconn.exec("INSERT INTO contact(contact_id,owned_extension,owned_phone,owned_port,can_forward,can_hotdesk,email_vm,email_vm_att,email_vm_del,email_mon,email_mon_del,passwd,userpin,confpin,vmpin,vacation,vacation_mode)"+
                    " VALUES("+newUser+",'"+
                    PgsqlConnection.escape(rb$params.owned_extension)+"','"+
                    PgsqlConnection.escape(rb$params.owned_phone)+"',"+
                    PgsqlConnection.escape(rb$params.owned_port)+","+
                    (rb$params.forward!=null?"TRUE":"FALSE")+","+
                    (rb$params.hotdesk!=null?"TRUE":"FALSE")+","+
                    (rb$params.email_vm!=null?"TRUE":"FALSE")+","+
                    (rb$params.email_vm_att!=null?"TRUE":"FALSE")+","+
                    (rb$params.email_vm_del!=null?"TRUE":"FALSE")+","+
                    (rb$params.email_mon!=null?"TRUE":"FALSE")+","+
                    (rb$params.email_mon_del!=null?"TRUE":"FALSE")+",'"+
                    PgsqlConnection.escape(rb$params.pass1)+"','"+
                    rb$params.userpin+"','"+
                    rb$params.confpin+"','"+
                    rb$params.vmpin+"','"+
                    PgsqlConnection.escape(rb$params.vacation)+"','"+
                    PgsqlConnection.escape(rb$params.vacation_mode)+"')"))
                                                 && pgres.success )
            if( rb$params.attach == null || rb$params.owned_extension.length < 3 ||
                    (pgres=pgconn.exec("INSERT INTO exten_contact(contact_id,virt_exten,ordered) VALUES("+newUser+",'"+
                    PgsqlConnection.escape(rb$params.owned_extension)+"',0)"))
                                                 && pgres.success )
              if( rb$params.rename == null || rb$params.owned_extension.length < 3 ||
                      (pgres=pgconn.exec("UPDATE virt_exten SET name='"+
                      PgsqlConnection.escape(user.name)+"' WHERE virt_exten='"+
                      PgsqlConnection.escape(rb$params.owned_extension)+"'"))
                                                 && pgres.success )
                if( rb$params.pattach == null || rb$params.owned_phone.length < 12 ||
                        (pgres=pgconn.exec("DELETE FROM contact_phone"+
        		" WHERE is_forward=0 AND mac='"+
                        PgsqlConnection.escape(rb$params.owned_phone)+
                        "' AND port="+
                        PgsqlConnection.escape(rb$params.owned_port)))
                                                 && pgres.success )
                  if( rb$params.pattach == null || rb$params.owned_phone.length < 12 ||
                          (pgres=pgconn.exec("INSERT INTO contact_phone"+
        		  "(contact_id,mac,port,is_forward) VALUES("+newUser+",'"+
                          PgsqlConnection.escape(rb$params.owned_phone)+"',"+
                          PgsqlConnection.escape(rb$params.owned_port)+",0)"))
                                                 && pgres.success )
                    if( rb$params.prename == null || rb$params.owned_phone.length < 12 ||
                            (pgres=pgconn.exec("UPDATE phone SET name='"+
                            PgsqlConnection.escape(user.name)+"' WHERE mac ='"+
                            PgsqlConnection.escape(rb$params.owned_phone)+
                            "' AND port="+
                            PgsqlConnection.escape(rb$params.owned_port)))
                                                 && pgres.success )
                      if(rb.contact.link(newUser,com.ID) == com.ID)
                        if(rb.contact.link(newUser,user_comm.ID) == user_comm.ID)
                          if(rb$params.pass1.length == 0 || rb.contact.setPassword(newUser,rb$params.pass1) == newUser)
                            all_ok=true;
        if( all_ok ) {
          pgres=pgconn.exec("COMMIT");
          var num_admin=0;
          admin_company = rb$params.admin_company;
          if( admin_company != null && extauth.sessionUser == "admin" && _rb$mode.company>0) {
            if( typeof(admin_company) != 'object' )
              admin_company=[admin_company];
            while( admin_company.length > 0 ) {
              acom_id=admin_company.shift();
              rb.debug.write("Linking to admin group "+acom_id+"<br>\n");
              acom=rb.contact.communityInfo(acom_id);
              rb.debug.write(acom.toSource()+"<br>");
              if( acom==null || acom.ID != acom_id || acom.uName.substr(0,6) != "admin-" )
        	continue;
              if(rb.contact.link(newUser,acom.ID)==acom.ID)
        	num_admin++;
            }
          } else if( admin_company != null && extauth.sessionUser == "admin" && _rb$mode.company == 0) {
            acom=rb.contact.communityInfo(-1,"admin-default");
            acom_id=acom.ID;
            rb.debug.write("Linking to admin group "+acom_id+"<br>\n");
            rb.debug.write(acom.toSource()+"<br>");
            if(rb.contact.link(newUser,acom.ID)==acom.ID)
              num_admin++;
          }
          DB.flag_change();
          rb$message = "User "+rb$params.name+" created.";
          selected_user=user.uName;
          selected_userid=newUser;
          rb$command = 'default';
	  result=true;
        } else {
          pgres=pgconn.exec("ROLLBACK");
          rb.contact.remove(newUser);
          rb$message = "Error adding user to database. NOT Created!";
          rb$command = 'create';
        }
      }
    }
  } else {
    rb.debug.write("DATABASE open FAILED<br>");
    rb$message = "Error connecting to Asterisk database. NOT Created";
    rb$command = 'create';
  }
  return result;
}
