// <!--
// (c) 2005-2008 IP Cortex Ltd.
// All rights reserved.  Unauthorised copying is not permitted.
//
// Portions (c) 2004 Redbourne Ltd
// All rights reserved.  Unauthorised copying is not permitted.
// -->
//
// Some common js functions used on Redbourne websites,
// encapsulated in a Util class
//
//

function Util(){
    var revision = "$Revision: 1.9 $";
    return revision.replace(/\$Revsion: (.*)\$/, "$1");
}

//
// doXmp -- escapes a chunk of XML, used as a replacement for unreliable
//          browser <XMP> tag
//
Util.doXmp = function(xmp_str, nbsp){
    with(rb.page) {
	var xmp_tab = [
	    ["&", "&amp;"],
   	    ["<", "&lt;"],
	    [">", "&gt;"],
	    ["\"", "&quot;"],
	    ["\n", "<br/>"]
	    ];
	
	if(nbsp == null || nbsp == true){
	    xmp_tab.push([" ", "&nbsp;"]);
	}

	var tmpStr = new String(xmp_str);
	
	for (var seq in xmp_tab){
	    var r = new RegExp(xmp_tab[seq][0], "gi");
	    tmpStr = tmpStr.replace(r, xmp_tab[seq][1]);
	}
	return(tmpStr);
    }
}

Util.browser = function() {
    var res = {vers:-1, Microsoft:false, Netscape:true};
    
    
    var brws = rb.page.env.UserAgent();
    res.Microsoft = (brws!=null &&  brws.indexOf("MSIE") != -1);
    res.Netscape  = (brws!=null &&  brws.indexOf("Netscape")  != -1);
    return res;
}

Util.uriHost = function(secure){
    var host = rb.page.getHeader("Host");
    var port = rb.page.env.ServerPort();
    if( port == 0 )
      port=80;
    var method=( port != 80 || secure ) ? 'https' : 'http';
    if( host == null )
	host = rb.page.env.ServerName();
    return(method+'://'+host);
}


//
// httpRedirect -- Redirect using an HTTP 303 response to an alternate location
//
// Netscape 4.x does not support 303 redirections, so try sending 302
// instead.
//
// If we can get a Host: header, then use the value we find there as the server
// name to redirect to.
//
Util.httpRedirect = function(uriStr,secure){
    var uri = new String(uriStr);

    var resp = 303;
    var brws = rb.page.env.UserAgent();
    if( brws.match(/^Mozilla\/4\./) != null )
    resp = 302;

    if(uri != null && uri != ""){
	if(uri.match(/^https*:\/\//i) == null)
	    uri = Util.uriHost(secure)+rb.page.abspath(uri);
	rb.page.HTTPreturn(resp, "See Also "+uri);
	rb.page.writeheader("Location", uri);
    }
}
Util.securePage = function() {
    if( rb.page.env.ServerPort() != 0 && rb.page.env.ServerPort() != 80 )
      return;
    Util.httpRedirect(Util.buildThisURL(), true);
}


Util.buildThisURL = function(supressdata) {
    var url = rb.page.env.Path();
    var tmp;
    
    tmp = rb.page.env.PathInfo();
    if (tmp)
    url += ('/'+tmp);
    
    if(!supressdata){
	    tmp = rb.page.env.QueryString();
	    if (tmp)
		    url += ('?'+tmp);
	    else
		    url += '?returnURL=true';
    }
    return url;
}


Util.parseDate = function(strparam,locale){
    var months={JAN:1, FEB:2, MAR:3, APR:4, MAY:5, JUN:6, JUL:7,
		AUG:8, SEP:9, SEPT:9, OCT:10, NOV:11, DEC:12,
		JANUARY:1, FEBRUARY:2, MARCH:3, APRIL:4, JUNE:6,
		JULY:7, AUGUST:8, SEPTEMBER:9, OCTOBER:10,
		NOVEMBER:11, DECEMBER:12};
    var Mth=0;
    var D=0;
    var Y=0;
    var H=0;
    var Min=0;
    
    var str = new String(strparam);
    if( !locale || locale == null )
    var locale = rb.page.getHeader("Accept-Language");
    else
    locale = null;
   
    var fmt = str.match(/([a-zA-Z0-9]*)\/([a-zA-Z0-9]*)\/([a-zA-Z0-9]*)\s*(.*)/);
   
    if(fmt == null || fmt.length < 3)
    fmt = str.match(/([a-zA-Z0-9]*)[\s,\.\-]+([a-zA-Z0-9]*)[\s,\.\-]+([a-zA-Z0-9]*)\s*(.*)/);
   
    if(fmt == null)
    return(null);
   
    if(fmt.length == 3)
    fmt[3] = (new Date()).getUTCFullYear();
   
    if(fmt.length < 4)
    return null;
   
    var n = 1;
    if( fmt[n].match(/^[a-zA-Z]*$/) || fmt[++n].match(/^[a-zA-Z]*$/) ){
	var ind = months[fmt[n].toUpperCase()];
	if(ind != null){
	    Mth=ind-1;
	    D=Number(fmt[n^3]);
	}
	else
	    return null;
    }
    else {
	if(locale != null && locale.match(/^en-us/i)){
	    Mth=Number(fmt[1])-1;
	    D=Number(fmt[2]);
	}
	else{
	    D=Number(fmt[1]);
	    Mth=Number(fmt[2])-1;
	}
    }
    var Y = parseInt(fmt[3]);
   
    if(Y < 100)
    Y += (Y < 37)? 2000 : 1900;
   
    if(fmt.length >= 5){
	var time = fmt[4].match(/\s*([0-9]*):([0-9]*).*/);
      
	if(time != null && time.length == 3){
	    H=Number(time[1]);
	    Min=Number(time[2]);
	}
    }
   
    if( isNaN(Y+Mth+D+H+Min) )
    return null;
    
    var res = new Date(Y, Mth, D, H, Min);
    rb.debug.write("parseDate: %s %s %s %s %s : %s", Y, Mth, D, H, Min, res);
    return res;
}

Util.fmtShortDate = function(date,locale){
    var months=['Jan', 'Feb', 'Mar', 'Apr', 'May', 'June', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
    
    if( !locale || locale == null )
    var locale = rb.page.getHeader("Accept-Language");
    var ret = "";
    
    if(date == null || typeof date != "object" || date.constructor != Date){
	return null;
    }
    
    // This is pretty basic: US gets mm/dd/yyyy, ROW gets dd/mm/yyyy   
    
    if(locale != null && locale.match(/^en-us/i))
    ret = (months[date.getMonth()])+', '+
    date.getDate()+' '+
    date.getFullYear();
    else
    ret = date.getDate()+' '+
    (months[date.getMonth()])+' '+
    date.getFullYear();
    return(ret);
}
	
Util.fmtShortDateTime = function(date,locale){
    if(date == null || typeof date != "object" || date.constructor != Date){
	return('');
    }
    var ret = Util.fmtShortDate(date,locale);
  
    ret += ' '+date.getHours()+':';
    if(date.getMinutes() <10)
    ret += "0";
    ret += date.getMinutes();
    return(ret);
}

Util.nonnull = function(str){
    return((str != null)?str:'');
}

Util.csvwrite = function (data){
    rb.page.writeraw(Util.csvMakeLine(data));
}

Util.csvinit = function (){
    Util._csv_data="";
}

Util.csvadd = function (data){
    Util._csv_data+=Util.csvMakeLine(data);

    // Flush every 32767 bytes...
    if( Util._csv_data.length > 32767 )
    Util.csvsend();
}

Util.csvsend = function (){
    if( Util._csv_data.length )
    rb.page.writeraw( Util._csv_data );
    Util._csv_data="";
}

Util.csvMakeLine =function(data){
    // rb.debug.write("CSV: called to write: "+data.toSource()+"<BR>\n");
    var buf="";
    for(var f = 0; f < data.length; f++){
	var field;
	if(data[f] == null )
	    data[f] = "";
	if(typeof data[f] != "string")
	    data[f] = data[f].toString();
	if(data[f].match(/[a-z0-9A-Z#\r\n,]/))
	    field = '"'+data[f].replace(/"/g, '\\"')+'"'; //" for emacs!
	else
	field = data[f];
	if(field == null)
	field = "";
	if(f < (data.length - 1))
	field += ',';
	buf+=field;
    }
    return (buf+'\r\n');
}


Util.copyProp = function(propTable, From, To) {
   for (var p=0;p<propTable.length;p++) {
      if (From[propTable[p]]!=null)
         To[propTable[p]] = From[propTable[p]];
   }
}

Util.CheckClass = function(obj, testClass) {
	if (!(obj instanceof testClass)) {
		dumpObj(obj, "ErrorObject", 4);
      return false;
	}
   return true;
}


//
//
Util.fileGet = function(name, owner){
    var it;
    var data = null;
    if(name != null && owner != null){
       var sr = {keyword:[name], searchInName:true};
       var it = rb.file.get(sr);
       while(it.getNextRow()){
	   if(it.owner == owner && it.fileDef != null ) 
	   return(it.fileDef.toObj());
       }
    }
    
    return(data);
    
    
}

Util.fileSave = function(name, owner, description, data){
    var it;
    if(name && owner){
       var sr = {keyword:[name], searchInName:true};
       if((it = rb.file.get(sr)) && it.getNextRow()){
	    it.description=description;
	    if(it.fileDef == null)
		it.fileDef = new Binary();
	    it.fileDef.fromObj(data);
	    rb.file.modify(it);
	}
	else{
	    var fd = {name:name, owner:owner, description:description, fileDef:(new Binary())};
	    fd.fileDef.fromObj(data);
	    rb.file.create(fd);
	}
    }
}
    
Util.fileRemove = function(name, owner){
    if(name && owner){
	var sr = {keyword:[name], searchInName:true};
	var fd = {name:name, owner:owner};
	var files = [];
	var it = rb.file.get(sr);
	while(it.getNextRow()){
	    if(it.owner == owner)
		files.push(it.fileID);
	}
	for(var f in files)
	rb.file.remove(files[f]);
    }
    
}

Util.getIconName = function(image, size){
	if(image == null || image.length <1){
		return('');
	}
	if(size == null){
		size="24";
	}
	return('/icons/'+size+'/'+image);
}


Util.getIcon = function(image, size, alt, clickable, href, data, data2){
	if(image == null || image.length <1){
		return('');
	}
	if(alt != null)
	     alt = 'alt="'+alt+'" '+'title="'+alt+'" ';
	else
	     alt = ""
	if(data2)
	for(p in data2)
	data[p]=data2[p];
	tag = '<img align="middle" src="'+this.getIconName(image, size)+'" '+alt+' border="0"/>';
	if(clickable){
		if(href == null)
			href = Util.buildThisURL(true);
		var queryStr = "";
		for(var d in data)
			queryStr += ((queryStr.length)?'&':'?')+(d+'='+escape(data[d]));
		href += queryStr;
		return('<a href="'+href+'" '+alt+'>'+tag+'</a>');
	}
	else{
		return(tag);
	}
}

Util.getIconButton = function(image, size, attributes){
	if(image == null || image.length <1 || attributes.name == null){
		return('');
	}
	if(size == null)
	    size="24";
	ret = "";
	// Tooltip help is essential for a graphical button
	// different versions of IE/NS use ALT/TITLE for this purpose so if we dont have
	// these attributes we will manufacture them from anything we have...
	if(attributes.alt == null)
		attributes.alt = attributes.value;
	if(attributes.title == null)
		attributes.title = attributes.alt;
	ret = '<input type="image" align="middle" src="'+this.getIconName(image, size)+'" border="0"';
	for(var p in attributes)
	if(p != "image" && p != "size")
		ret += ' '+p+'="'+attributes[p]+'"';
	ret += '/>';
	return(ret);
}
