SET client_encoding = 'SQL_ASCII';
SET check_function_bodies = false;

SET SESSION AUTHORIZATION 'asterisk';

SET search_path = public, pg_catalog;

ALTER TABLE contact ADD COLUMN email_vm bool;
ALTER TABLE contact ADD COLUMN email_vm_att bool;
ALTER TABLE contact ADD COLUMN email_vm_del bool;
ALTER TABLE contact ADD COLUMN email_mon bool;
ALTER TABLE contact ADD COLUMN email_mon_del bool;
ALTER TABLE contact ADD COLUMN userpin VARCHAR(8);
ALTER TABLE contact ADD COLUMN systempin VARCHAR(8);
ALTER TABLE contact ADD COLUMN vmpin VARCHAR(8);
ALTER TABLE contact ADD COLUMN hotpin VARCHAR(8);
ALTER TABLE contact ADD COLUMN confpin VARCHAR(8);
ALTER TABLE contact ADD COLUMN vacation VARCHAR(32);
ALTER TABLE contact ADD COLUMN vacation_mode VARCHAR(8);
UPDATE contact SET email_vm=false WHERE email_vm IS NULL;
UPDATE contact SET email_vm_att=false WHERE email_vm_att IS NULL;
UPDATE contact SET email_vm_del=false WHERE email_vm_del IS NULL;
UPDATE contact SET email_mon=false WHERE email_mon IS NULL;
UPDATE contact SET email_mon_del=false WHERE email_mon_del IS NULL;
UPDATE contact SET userpin='' WHERE userpin IS NULL;
UPDATE contact SET systempin='' WHERE systempin IS NULL;
UPDATE contact SET vmpin=(SELECT passcode FROM virt_exten WHERE virt_exten = contact.owned_extension) WHERE vmpin IS NULL;
UPDATE contact SET vmpin='' WHERE vmpin IS NULL;
UPDATE contact SET hotpin='' WHERE hotpin IS NULL;
UPDATE contact SET confpin='' WHERE confpin IS NULL;
UPDATE contact SET vacation='' WHERE vacation IS NULL;
UPDATE contact SET vacation_mode='off' WHERE vacation_mode IS NULL;
ALTER TABLE contact ALTER COLUMN email_vm SET NOT NULL;
ALTER TABLE contact ALTER COLUMN email_vm SET DEFAULT false;
ALTER TABLE contact ALTER COLUMN email_vm_att SET NOT NULL;
ALTER TABLE contact ALTER COLUMN email_vm_att SET DEFAULT false;
ALTER TABLE contact ALTER COLUMN email_vm_del SET NOT NULL;
ALTER TABLE contact ALTER COLUMN email_vm_del SET DEFAULT false;
ALTER TABLE contact ALTER COLUMN email_mon SET NOT NULL;
ALTER TABLE contact ALTER COLUMN email_mon SET DEFAULT false;
ALTER TABLE contact ALTER COLUMN email_mon_del SET NOT NULL;
ALTER TABLE contact ALTER COLUMN email_mon_del SET DEFAULT false;
ALTER TABLE contact ALTER COLUMN userpin SET NOT NULL;
ALTER TABLE contact ALTER COLUMN userpin SET DEFAULT '';
ALTER TABLE contact ALTER COLUMN systempin SET NOT NULL;
ALTER TABLE contact ALTER COLUMN systempin SET DEFAULT '';
ALTER TABLE contact ALTER COLUMN vmpin SET NOT NULL;
ALTER TABLE contact ALTER COLUMN vmpin SET DEFAULT '';
ALTER TABLE contact ALTER COLUMN hotpin SET NOT NULL;
ALTER TABLE contact ALTER COLUMN hotpin SET DEFAULT '';
ALTER TABLE contact ALTER COLUMN confpin SET NOT NULL;
ALTER TABLE contact ALTER COLUMN confpin SET DEFAULT '';
ALTER TABLE contact ALTER COLUMN vacation SET NOT NULL;
ALTER TABLE contact ALTER COLUMN vacation SET DEFAULT '';
ALTER TABLE contact ALTER COLUMN vacation_mode SET NOT NULL;
ALTER TABLE contact ALTER COLUMN vacation_mode SET DEFAULT 'off';

ALTER TABLE virt_exten ADD COLUMN ivr_menu VARCHAR(32);
ALTER TABLE virt_exten ADD COLUMN nightmode_ex bool;
ALTER TABLE virt_exten ADD COLUMN voicemail_mon integer;
ALTER TABLE virt_exten ADD COLUMN vm_jump_star varchar(32);
ALTER TABLE virt_exten ADD COLUMN vm_jump_zero varchar(32);
ALTER TABLE virt_exten ADD COLUMN no_vm_jump varchar(32);
ALTER TABLE virt_exten ADD COLUMN no_vm_jump_night varchar(32);
UPDATE virt_exten SET nightmode_ex=false WHERE nightmode_ex IS NULL;
ALTER TABLE virt_exten ALTER COLUMN nightmode_ex SET NOT NULL;
ALTER TABLE virt_exten ALTER COLUMN nightmode_ex SET DEFAULT false;
UPDATE virt_exten SET voicemail_mon=1 WHERE voicemail_mon IS NULL;
ALTER TABLE virt_exten ALTER COLUMN voicemail_mon SET NOT NULL;
ALTER TABLE virt_exten ALTER COLUMN voicemail_mon SET DEFAULT 1;
ALTER TABLE virt_exten DROP COLUMN user_opt_out;
ALTER TABLE virt_exten ADD COLUMN intro_day smallint;
ALTER TABLE virt_exten ADD COLUMN intro_night smallint;
ALTER TABLE virt_exten ADD COLUMN busy_retry smallint;
ALTER TABLE virt_exten ADD COLUMN rec_override smallint;
ALTER TABLE virt_exten ADD COLUMN moh_in smallint;
ALTER TABLE virt_exten ADD COLUMN moh_out smallint;
ALTER TABLE virt_exten ADD COLUMN subtype varchar(32);
UPDATE virt_exten SET moh_in=0, moh_out=0 WHERE moh_in IS NULL;
ALTER TABLE virt_exten ALTER COLUMN moh_in SET NOT NULL;
ALTER TABLE virt_exten ALTER COLUMN moh_in SET DEFAULT 0;
ALTER TABLE virt_exten ALTER COLUMN moh_out SET NOT NULL;
ALTER TABLE virt_exten ALTER COLUMN moh_out SET DEFAULT 0;

CREATE TABLE barred (
    prefix character varying(32) NOT NULL,
    inbound bool NOT NULL DEFAULT false,
    company character varying(32) NOT NULL DEFAULT 'default',
 PRIMARY KEY (prefix, inbound, company)
);
ALTER TABLE barred ADD COLUMN passcode VARCHAR(32);

CREATE TABLE provider (
    provider character varying(32) NOT NULL,
    inbound bool NOT NULL DEFAULT false,
    conn_type character varying(8) NOT NULL DEFAULT 'IAX',
    context character varying(16) NOT NULL DEFAULT 'external',
    hostname character varying(64) NOT NULL,
    username character varying(32),
    auth_type character varying(8) NOT NULL DEFAULT 'plain',
    auth_key text,
    register bool NOT NULL DEFAULT false,
    dial_digits smallint,
    cid_prefix character varying(8) NOT NULL DEFAULT '',
 PRIMARY KEY (provider, inbound)
);
CREATE INDEX provider_idx ON provider(provider);
ALTER TABLE provider ADD COLUMN max_chans SMALLINT;
ALTER TABLE provider ADD COLUMN low_band BOOLEAN;
ALTER TABLE provider ADD COLUMN sip_as_phone BOOLEAN;
UPDATE provider SET low_band=false WHERE low_band IS NULL;
ALTER TABLE provider ALTER COLUMN low_band SET NOT NULL;
ALTER TABLE provider ALTER COLUMN low_band SET DEFAULT false;
UPDATE provider SET sip_as_phone=false WHERE sip_as_phone IS NULL;
ALTER TABLE provider ALTER COLUMN sip_as_phone SET NOT NULL;
ALTER TABLE provider ALTER COLUMN sip_as_phone SET DEFAULT false;

CREATE TABLE routing (
    ordered smallint NOT NULL,
    name character varying(32) NOT NULL,
    provider character varying(32),
    provider2 character varying(32),
    provider3 character varying(32),
    prefixes text,
 PRIMARY KEY (name)
);
CREATE INDEX routing_idx ON routing(ordered, name);
ALTER TABLE routing ADD COLUMN dialpref VARCHAR(16);
ALTER TABLE routing ADD COLUMN dialpref2 VARCHAR(16);
ALTER TABLE routing ADD COLUMN dialpref3 VARCHAR(16);

CREATE TABLE ivr (
    name character varying(32) NOT NULL DEFAULT '',
    number smallint NOT NULL,
    company character varying(32) NOT NULL DEFAULT 'default',
 PRIMARY KEY (number, company)
);

ALTER TABLE inbound_nos ADD COLUMN provider VARCHAR(32);

CREATE TABLE ivr_menu (
    menu character varying(32) NOT NULL DEFAULT '',
    company character varying(32) NOT NULL DEFAULT 'default',
    say character varying(128) NOT NULL DEFAULT '',
    say_repeat smallint NOT NULL DEFAULT 1,
    say_pause smallint NOT NULL DEFAULT 10,
    press_0 character varying(32),
    press_1 character varying(32),
    press_2 character varying(32),
    press_3 character varying(32),
    press_4 character varying(32),
    press_5 character varying(32),
    press_6 character varying(32),
    press_7 character varying(32),
    press_8 character varying(32),
    press_9 character varying(32),
    press_star character varying(32),
    press_hash character varying(32),
    timeout smallint,
    timeout_to character varying(32),
 PRIMARY KEY (menu,company)
);

ALTER TABLE cdr ADD COLUMN acctid bigint;
CREATE SEQUENCE cdr_acctid_seq;
ALTER TABLE cdr ALTER COLUMN acctid SET DEFAULT NEXTVAL('cdr_acctid_seq');
UPDATE CDR SET acctid=NEXTVAL('cdr_acctid_seq') WHERE acctid IS NULL;
ALTER TABLE cdr ALTER COLUMN acctid SET NOT NULL;
ALTER TABLE cdr ADD PRIMARY KEY (acctid);
DROP INDEX cdr_channel_idx;
DROP INDEX cdr_dchannel_idx;

DELETE FROM settings WHERE attrib='reserve_last_line_limit';
DELETE FROM settings WHERE attrib='base_password';

ALTER TABLE phone DROP COLUMN res_fkeys;
ALTER TABLE phone ADD COLUMN pass VARCHAR(32);
ALTER TABLE phone ADD COLUMN access VARCHAR(32);
ALTER TABLE phone ADD COLUMN vlan SMALLINT;
ALTER TABLE phone ADD COLUMN nat_mode BOOLEAN;
ALTER TABLE phone ADD COLUMN codec_list VARCHAR(32);
ALTER TABLE phone ADD COLUMN qualify VARCHAR(4);
ALTER TABLE phone ADD COLUMN ringer SMALLINT;
ALTER TABLE phone ADD COLUMN lcd_mode SMALLINT;
ALTER TABLE phone ADD COLUMN auto_exten BOOLEAN;
ALTER TABLE phone ADD COLUMN headset BOOLEAN;
UPDATE phone set nat_mode=FALSE WHERE nat_mode IS NULL;
ALTER TABLE phone ALTER COLUMN nat_mode SET NOT NULL;
ALTER TABLE phone ALTER COLUMN nat_mode SET DEFAULT false;
UPDATE phone SET qualify='' WHERE qualify IS NULL;
ALTER TABLE phone ALTER COLUMN qualify SET NOT NULL;
ALTER TABLE phone ALTER COLUMN qualify SET DEFAULT '';
UPDATE phone SET lcd_mode=0 WHERE lcd_mode IS NULL;
ALTER TABLE phone ALTER COLUMN lcd_mode SET NOT NULL;
ALTER TABLE phone ALTER COLUMN lcd_mode SET DEFAULT 0;
UPDATE phone SET auto_exten=FALSE WHERE auto_exten IS NULL;
ALTER TABLE phone ALTER COLUMN auto_exten SET NOT NULL;
ALTER TABLE phone ALTER COLUMN auto_exten SET DEFAULT false;
UPDATE phone SET headset=FALSE WHERE headset IS NULL;
ALTER TABLE phone ALTER COLUMN headset SET NOT NULL;
ALTER TABLE phone ALTER COLUMN headset SET DEFAULT false;

DROP TABLE vm_redir;

ALTER TABLE phone_type ADD COLUMN res_lines smallint;
ALTER TABLE phone_type ADD COLUMN sip_extra VARCHAR(255);
ALTER TABLE phone_type ADD COLUMN is_zap BOOL;
ALTER TABLE phone_type ADD COLUMN aux_ports smallint;
ALTER TABLE phone_type ADD COLUMN pgroup VARCHAR(32);
ALTER TABLE phone_type ADD COLUMN sidecar BOOL;
UPDATE phone_type SET res_lines=0 WHERE res_lines IS NULL;
UPDATE phone_type SET sip_extra='' WHERE sip_extra IS NULL;
UPDATE phone_type SET is_zap=FALSE WHERE is_zap IS NULL;
UPDATE phone_type SET aux_ports=0 WHERE aux_ports IS NULL;
UPDATE phone_type SET pgroup='' WHERE sip_extra IS NULL;
UPDATE phone_type SET sidecar=FALSE WHERE sidecar IS NULL;
ALTER TABLE phone_type ALTER COLUMN res_lines SET NOT NULL;
ALTER TABLE phone_type ALTER COLUMN res_lines SET DEFAULT 0;
ALTER TABLE phone_type ALTER COLUMN sip_extra SET NOT NULL;
ALTER TABLE phone_type ALTER COLUMN sip_extra SET DEFAULT '';
ALTER TABLE phone_type ALTER COLUMN is_zap SET NOT NULL;
ALTER TABLE phone_type ALTER COLUMN is_zap SET DEFAULT FALSE;
ALTER TABLE phone_type ALTER COLUMN aux_ports SET NOT NULL;
ALTER TABLE phone_type ALTER COLUMN aux_ports SET DEFAULT 0;
ALTER TABLE phone_type ALTER COLUMN pgroup SET NOT NULL;
ALTER TABLE phone_type ALTER COLUMN pgroup SET DEFAULT '';
ALTER TABLE phone_type ALTER COLUMN sidecar SET NOT NULL;
ALTER TABLE phone_type ALTER COLUMN sidecar SET DEFAULT FALSE;

CREATE TABLE pbook_src (
    src_host character varying(64) NOT NULL,
    description character varying(64) NOT NULL DEFAULT '',
    def_company character varying(64) NOT NULL DEFAULT '',
    dial_pfx character varying(16) NOT NULL DEFAULT '',
 PRIMARY KEY (src_host)
);

CREATE TABLE pbook (
    src_host character varying(64) NOT NULL,
    name character varying(64) NOT NULL DEFAULT '',
    company character varying(64) NOT NULL DEFAULT '',
    extension character varying(16) NOT NULL DEFAULT '',
    ddi character varying(32) NOT NULL DEFAULT ''
);
CREATE INDEX pbook_name_idx ON pbook(name,company);
CREATE INDEX pbook_num_idx ON pbook(extension);
ALTER TABLE ONLY pbook
    ADD CONSTRAINT pbook_src_fk FOREIGN KEY (src_host) REFERENCES pbook_src(src_host) MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;

DELETE FROM contact_group WHERE group_id > 31;
DELETE FROM call_group WHERE group_id > 31;
UPDATE PHONE SET call_group=NULL where call_group > 31;

CREATE TABLE rate_res (
    company character varying(32) NOT NULL DEFAULT 'default',
    provider character varying(32) NOT NULL DEFAULT 'default',
    rate_name character varying(32) NOT NULL,
 PRIMARY KEY (company,provider,rate_name)
);

CREATE TABLE rate(
    name character varying(32) NOT NULL,
    peakdef character varying(128) NOT NULL DEFAULT 'default',
    fromdate timestamp with time zone NOT NULL DEFAULT NOW(),
    todate timestamp with time zone NOT NULL DEFAULT '2099-01-01 00:00:00',
 PRIMARY KEY (name)
);
CREATE INDEX rate_date_idx ON rate(fromdate,todate);

CREATE TABLE rate_pfx (
    name character varying(32) NOT NULL,
    prefix character varying(32) NOT NULL,
    description character varying(64) NOT NULL,
    rate character(1) NOT NULL DEFAULT 'O',
    qualifier character(1) NOT NULL DEFAULT 'F',
    startcost  numeric NOT NULL DEFAULT 0,
    includedsecs bigint NOT NULL DEFAULT 0,
    costpermin numeric NOT NULL DEFAULT 0,
    mincost numeric NOT NULL DEFAULT 0,
 PRIMARY KEY (name, prefix, qualifier, rate)
);
CREATE INDEX rates_name_idx ON rate_pfx(name);

ALTER TABLE ONLY rate_pfx
    ADD CONSTRAINT rate_fk FOREIGN KEY (name) REFERENCES rate(name) MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE ONLY rate_res
    ADD CONSTRAINT rate_res_fk FOREIGN KEY (rate_name) REFERENCES rate(name) MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;

DROP TABLE charges;

CREATE TABLE xlate (
    company character varying(64) NOT NULL,
    number character varying(32) NOT NULL,
    name character varying(32) NOT NULL,
    shortcode character varying(16),
 PRIMARY KEY (company,number)
);

-- Ensure that all necessary extensions exist for referenced voicemail boxes
INSERT INTO virt_exten(virt_exten, passcode, company) (SELECT virt_exten.voicemail_box, virt_exten.passcode, virt_exten.company FROM virt_exten LEFT JOIN virt_exten AS v ON virt_exten.voicemail_box = v.virt_exten WHERE v.virt_exten IS NULL AND virt_exten.voicemail_box IS NOT NULL AND virt_exten.voicemail_box != '');

VACUUM ANALYZE;
