--
-- PostgreSQL database dump
--

SET client_encoding = 'SQL_ASCII';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

--
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: postgres
--

COMMENT ON SCHEMA public IS 'Standard public schema';


SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = true;

--
-- Name: barred; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE barred (
    prefix character varying(32) NOT NULL,
    inbound boolean DEFAULT false NOT NULL,
    company character varying(32) DEFAULT 'default'::character varying NOT NULL,
    passcode character varying(32)
);


ALTER TABLE public.barred OWNER TO asterisk;

SET default_with_oids = false;

--
-- Name: call_group; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE call_group (
    group_id smallint NOT NULL,
    group_name character varying(32) DEFAULT ''::character varying NOT NULL,
    company character varying(32) DEFAULT 'default'::character varying NOT NULL
);


ALTER TABLE public.call_group OWNER TO asterisk;

--
-- Name: cdr_acctid_seq; Type: SEQUENCE; Schema: public; Owner: asterisk
--

CREATE SEQUENCE cdr_acctid_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.cdr_acctid_seq OWNER TO asterisk;

SET default_with_oids = true;

--
-- Name: cdr; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE cdr (
    calldate timestamp with time zone DEFAULT now() NOT NULL,
    clid character varying(80) DEFAULT ''::character varying NOT NULL,
    src character varying(80) DEFAULT ''::character varying NOT NULL,
    dst character varying(80) DEFAULT ''::character varying NOT NULL,
    dcontext character varying(80) DEFAULT ''::character varying NOT NULL,
    channel character varying(80) DEFAULT ''::character varying NOT NULL,
    dstchannel character varying(80) DEFAULT ''::character varying NOT NULL,
    lastapp character varying(80) DEFAULT ''::character varying NOT NULL,
    lastdata character varying(80) DEFAULT ''::character varying NOT NULL,
    duration bigint DEFAULT (0)::bigint NOT NULL,
    billsec bigint DEFAULT (0)::bigint NOT NULL,
    disposition character varying(45) DEFAULT ''::character varying NOT NULL,
    amaflags bigint DEFAULT (0)::bigint NOT NULL,
    accountcode character varying(20) DEFAULT ''::character varying NOT NULL,
    uniqueid character varying(32) DEFAULT ''::character varying NOT NULL,
    userfield character varying(255) DEFAULT ''::character varying NOT NULL,
    acctid bigint DEFAULT nextval('cdr_acctid_seq'::regclass) NOT NULL
);


ALTER TABLE public.cdr OWNER TO asterisk;

--
-- Name: contact; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE contact (
    contact_id bigint NOT NULL,
    owned_extension character varying(32),
    can_forward boolean DEFAULT false NOT NULL,
    can_hotdesk boolean DEFAULT false NOT NULL,
    owned_phone character(12),
    owned_port smallint,
    passwd character varying(128),
    email_vm boolean DEFAULT false NOT NULL,
    email_vm_att boolean DEFAULT false NOT NULL,
    userpin character varying(8) DEFAULT ''::character varying NOT NULL,
    systempin character varying(8) DEFAULT ''::character varying NOT NULL,
    vmpin character varying(8) DEFAULT ''::character varying NOT NULL,
    hotpin character varying(8) DEFAULT ''::character varying NOT NULL,
    confpin character varying(8) DEFAULT ''::character varying NOT NULL,
    email_vm_del boolean DEFAULT false NOT NULL,
    vacation character varying(32) DEFAULT ''::character varying NOT NULL,
    vacation_mode character varying(8) DEFAULT 'off'::character varying NOT NULL,
    email_mon boolean DEFAULT false NOT NULL,
    email_mon_del boolean DEFAULT false NOT NULL
);


ALTER TABLE public.contact OWNER TO asterisk;

SET default_with_oids = false;

--
-- Name: contact_group; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE contact_group (
    contact_id bigint NOT NULL,
    group_id smallint NOT NULL
);


ALTER TABLE public.contact_group OWNER TO asterisk;

SET default_with_oids = true;

--
-- Name: contact_phone; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE contact_phone (
    contact_id bigint NOT NULL,
    mac character(12) NOT NULL,
    port smallint DEFAULT 0 NOT NULL,
    is_forward smallint DEFAULT 0 NOT NULL
);


ALTER TABLE public.contact_phone OWNER TO asterisk;

--
-- Name: exten_contact; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE exten_contact (
    virt_exten character varying(32) NOT NULL,
    contact_id bigint NOT NULL,
    ordered integer
);


ALTER TABLE public.exten_contact OWNER TO asterisk;

--
-- Name: inbound_nos; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE inbound_nos (
    dialcode character varying(16) NOT NULL,
    number character varying(16) NOT NULL,
    virt_exten character varying(32) NOT NULL,
    provider character varying(32)
);


ALTER TABLE public.inbound_nos OWNER TO asterisk;

--
-- Name: ivr; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE ivr (
    name character varying(32) DEFAULT ''::character varying NOT NULL,
    number smallint NOT NULL,
    company character varying(32) DEFAULT 'default'::character varying NOT NULL
);


ALTER TABLE public.ivr OWNER TO asterisk;

--
-- Name: ivr_menu; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE ivr_menu (
    menu character varying(32) DEFAULT ''::character varying NOT NULL,
    company character varying(32) DEFAULT 'default'::character varying NOT NULL,
    say character varying(128) DEFAULT ''::character varying NOT NULL,
    say_repeat smallint DEFAULT 1 NOT NULL,
    say_pause smallint DEFAULT 10 NOT NULL,
    press_0 character varying(32),
    press_1 character varying(32),
    press_2 character varying(32),
    press_3 character varying(32),
    press_4 character varying(32),
    press_5 character varying(32),
    press_6 character varying(32),
    press_7 character varying(32),
    press_8 character varying(32),
    press_9 character varying(32),
    press_star character varying(32),
    press_hash character varying(32),
    timeout smallint,
    timeout_to character varying(32)
);


ALTER TABLE public.ivr_menu OWNER TO asterisk;

--
-- Name: pbook; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE pbook (
    src_host character varying(64) NOT NULL,
    name character varying(64) DEFAULT ''::character varying NOT NULL,
    company character varying(64) DEFAULT ''::character varying NOT NULL,
    extension character varying(16) DEFAULT ''::character varying NOT NULL,
    ddi character varying(32) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE public.pbook OWNER TO asterisk;

--
-- Name: pbook_src; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE pbook_src (
    src_host character varying(64) NOT NULL,
    description character varying(64) DEFAULT ''::character varying NOT NULL,
    def_company character varying(64) DEFAULT ''::character varying NOT NULL,
    dial_pfx character varying(16) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE public.pbook_src OWNER TO asterisk;

--
-- Name: phone; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE phone (
    mac character(12) NOT NULL,
    port smallint DEFAULT 0 NOT NULL,
    name character varying(32) NOT NULL,
    description character varying(128),
    company character varying(32) DEFAULT 'default'::character varying NOT NULL,
    can_hotdesk boolean DEFAULT false NOT NULL,
    can_forward boolean DEFAULT false NOT NULL,
    phone_type character varying(16),
    ip_addr inet,
    ip_dns1 inet,
    ip_dns2 inet,
    ip_gateway inet,
    ip_domain character varying(128),
    call_group smallint,
    pass character varying(32),
    "access" character varying(32),
    vlan smallint,
    nat_mode boolean DEFAULT false NOT NULL,
    codec_list character varying(32),
    qualify character varying(4) DEFAULT ''::character varying NOT NULL,
    ringer smallint,
    lcd_mode smallint DEFAULT 0 NOT NULL,
    ldap_mode smallint DEFAULT 0 NOT NULL,
    auto_exten boolean DEFAULT false NOT NULL,
    headset boolean DEFAULT false NOT NULL
);


ALTER TABLE public.phone OWNER TO asterisk;

SET default_with_oids = false;

--
-- Name: phone_type; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE phone_type (
    phone_type character varying(16) NOT NULL,
    num_lines integer NOT NULL,
    num_fkeys integer NOT NULL,
    num_ports integer DEFAULT 1 NOT NULL,
    description character varying(32) NOT NULL,
    res_lines smallint DEFAULT 0 NOT NULL,
    sip_extra character varying(255) DEFAULT ''::character varying NOT NULL,
    is_zap boolean DEFAULT false NOT NULL,
    aux_ports smallint DEFAULT 0 NOT NULL,
    pgroup character varying(32) DEFAULT ''::character varying NOT NULL,
    sidecar boolean DEFAULT false NOT NULL
);


ALTER TABLE public.phone_type OWNER TO asterisk;

SET default_with_oids = true;

--
-- Name: provider; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE provider (
    provider character varying(32) NOT NULL,
    inbound boolean DEFAULT false NOT NULL,
    conn_type character varying(8) DEFAULT 'IAX'::character varying NOT NULL,
    context character varying(16) DEFAULT 'external'::character varying NOT NULL,
    hostname character varying(64) NOT NULL,
    username character varying(32),
    auth_type character varying(8) DEFAULT 'plain'::character varying NOT NULL,
    auth_key text,
    register boolean DEFAULT false NOT NULL,
    dial_digits smallint,
    cid_prefix character varying(20) DEFAULT ''::character varying NOT NULL,
    max_chans smallint,
    low_band boolean DEFAULT false NOT NULL,
    sip_as_phone boolean DEFAULT false NOT NULL,
    sip_as_extern boolean DEFAULT false NOT NULL
);


ALTER TABLE public.provider OWNER TO asterisk;

--
-- Name: rate; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE rate (
    name character varying(32) NOT NULL,
    peakdef character varying(128) DEFAULT 'default'::character varying NOT NULL,
    fromdate timestamp with time zone DEFAULT now() NOT NULL,
    todate timestamp with time zone DEFAULT '2099-01-01 00:00:00+00'::timestamp with time zone NOT NULL
);


ALTER TABLE public.rate OWNER TO asterisk;

--
-- Name: rate_pfx; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE rate_pfx (
    name character varying(32) NOT NULL,
    prefix character varying(32) NOT NULL,
    description character varying(64) NOT NULL,
    rate character(1) DEFAULT 'O'::bpchar NOT NULL,
    qualifier character(1) DEFAULT 'F'::bpchar NOT NULL,
    startcost numeric DEFAULT 0 NOT NULL,
    includedsecs bigint DEFAULT 0 NOT NULL,
    costpermin numeric DEFAULT 0 NOT NULL,
    mincost numeric DEFAULT 0 NOT NULL
);


ALTER TABLE public.rate_pfx OWNER TO asterisk;

--
-- Name: rate_res; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE rate_res (
    company character varying(32) DEFAULT 'default'::character varying NOT NULL,
    provider character varying(32) DEFAULT 'default'::character varying NOT NULL,
    rate_name character varying(32) NOT NULL
);


ALTER TABLE public.rate_res OWNER TO asterisk;

--
-- Name: routing; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE routing (
    ordered smallint NOT NULL,
    name character varying(32) NOT NULL,
    provider character varying(32),
    provider2 character varying(32),
    provider3 character varying(32),
    prefixes text,
    dialpref character varying(16),
    dialpref2 character varying(16),
    dialpref3 character varying(16)
);


ALTER TABLE public.routing OWNER TO asterisk;

--
-- Name: settings; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE settings (
    attrib character varying(32) NOT NULL,
    value character varying(255) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE public.settings OWNER TO asterisk;

--
-- Name: virt_exten; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE virt_exten (
    virt_exten character varying(32) NOT NULL,
    name character varying(32) DEFAULT ''::character varying NOT NULL,
    voicemail_box character varying(32),
    voicemail_mon integer DEFAULT 1 NOT NULL,
    priority integer DEFAULT 1,
    ring_type character(1) DEFAULT 'A'::bpchar NOT NULL,
    company character varying(32) DEFAULT 'default'::character varying NOT NULL,
    phonebook bigint DEFAULT 3 NOT NULL,
    callerid character varying(32),
    ring_time integer,
    nightmode_ex boolean DEFAULT false NOT NULL,
    passcode character varying(8),
    ivr_menu character varying(32),
    vm_jump_star character varying(32),
    vm_jump_zero character varying(32),
    no_vm_jump character varying(32),
    intro_day smallint,
    intro_night smallint,
    no_vm_jump_night character varying(32),
    busy_retry smallint,
    rec_override smallint,
    moh_in smallint DEFAULT 0 NOT NULL,
    moh_out smallint DEFAULT 0 NOT NULL,
    subtype character varying(32)
);


ALTER TABLE public.virt_exten OWNER TO asterisk;

SET default_with_oids = false;

--
-- Name: xlate; Type: TABLE; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE TABLE xlate (
    company character varying(64) NOT NULL,
    number character varying(32) NOT NULL,
    name character varying(32) NOT NULL,
    shortcode character varying(16)
);


ALTER TABLE public.xlate OWNER TO asterisk;

--
-- Name: barred_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY barred
    ADD CONSTRAINT barred_pkey PRIMARY KEY (prefix, inbound, company);


--
-- Name: call_group_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY call_group
    ADD CONSTRAINT call_group_pkey PRIMARY KEY (group_id);


--
-- Name: cdr_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY cdr
    ADD CONSTRAINT cdr_pkey PRIMARY KEY (acctid);


--
-- Name: contact_group_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY contact_group
    ADD CONSTRAINT contact_group_pkey PRIMARY KEY (contact_id, group_id);


--
-- Name: contact_phone_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY contact_phone
    ADD CONSTRAINT contact_phone_pkey PRIMARY KEY (contact_id, mac, port);


--
-- Name: contact_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY contact
    ADD CONSTRAINT contact_pkey PRIMARY KEY (contact_id);


--
-- Name: exten_contact_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY exten_contact
    ADD CONSTRAINT exten_contact_pkey PRIMARY KEY (virt_exten, contact_id);


--
-- Name: inbound_nos_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY inbound_nos
    ADD CONSTRAINT inbound_nos_pkey PRIMARY KEY (dialcode, number);


--
-- Name: ivr_menu_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY ivr_menu
    ADD CONSTRAINT ivr_menu_pkey PRIMARY KEY (menu, company);


--
-- Name: ivr_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY ivr
    ADD CONSTRAINT ivr_pkey PRIMARY KEY (number, company);


--
-- Name: pbook_src_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY pbook_src
    ADD CONSTRAINT pbook_src_pkey PRIMARY KEY (src_host);


--
-- Name: phone_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY phone
    ADD CONSTRAINT phone_pkey PRIMARY KEY (mac, port);


--
-- Name: phone_type_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY phone_type
    ADD CONSTRAINT phone_type_pkey PRIMARY KEY (phone_type);


--
-- Name: provider_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY provider
    ADD CONSTRAINT provider_pkey PRIMARY KEY (provider, inbound);


--
-- Name: rate_pfx_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY rate_pfx
    ADD CONSTRAINT rate_pfx_pkey PRIMARY KEY (name, prefix, qualifier, rate);


--
-- Name: rate_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY rate
    ADD CONSTRAINT rate_pkey PRIMARY KEY (name);


--
-- Name: rate_res_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY rate_res
    ADD CONSTRAINT rate_res_pkey PRIMARY KEY (company, provider, rate_name);


--
-- Name: routing_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY routing
    ADD CONSTRAINT routing_pkey PRIMARY KEY (name);


--
-- Name: settings_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY settings
    ADD CONSTRAINT settings_pkey PRIMARY KEY (attrib);


--
-- Name: virt_exten_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY virt_exten
    ADD CONSTRAINT virt_exten_pkey PRIMARY KEY (virt_exten);


--
-- Name: xlate_pkey; Type: CONSTRAINT; Schema: public; Owner: asterisk; Tablespace: 
--

ALTER TABLE ONLY xlate
    ADD CONSTRAINT xlate_pkey PRIMARY KEY (company, number);


--
-- Name: cdr_calldate_key; Type: INDEX; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE INDEX cdr_calldate_key ON cdr USING btree (calldate);


--
-- Name: pbook_name_idx; Type: INDEX; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE INDEX pbook_name_idx ON pbook USING btree (name, company);


--
-- Name: pbook_num_idx; Type: INDEX; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE INDEX pbook_num_idx ON pbook USING btree (extension);


--
-- Name: provider_idx; Type: INDEX; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE INDEX provider_idx ON provider USING btree (provider);


--
-- Name: rate_date_idx; Type: INDEX; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE INDEX rate_date_idx ON rate USING btree (fromdate, todate);


--
-- Name: rates_name_idx; Type: INDEX; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE INDEX rates_name_idx ON rate_pfx USING btree (name);


--
-- Name: routing_idx; Type: INDEX; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE INDEX routing_idx ON routing USING btree (ordered, name);


--
-- Name: ve_company_index; Type: INDEX; Schema: public; Owner: asterisk; Tablespace: 
--

CREATE UNIQUE INDEX ve_company_index ON virt_exten USING btree (virt_exten, company);


--
-- Name: cg_call_group_fk; Type: FK CONSTRAINT; Schema: public; Owner: asterisk
--

ALTER TABLE ONLY contact_group
    ADD CONSTRAINT cg_call_group_fk FOREIGN KEY (group_id) REFERENCES call_group(group_id);


--
-- Name: cg_contact_fk; Type: FK CONSTRAINT; Schema: public; Owner: asterisk
--

ALTER TABLE ONLY contact_group
    ADD CONSTRAINT cg_contact_fk FOREIGN KEY (contact_id) REFERENCES contact(contact_id);


--
-- Name: cp_contact_fk; Type: FK CONSTRAINT; Schema: public; Owner: asterisk
--

ALTER TABLE ONLY contact_phone
    ADD CONSTRAINT cp_contact_fk FOREIGN KEY (contact_id) REFERENCES contact(contact_id) MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: cp_phone_fk; Type: FK CONSTRAINT; Schema: public; Owner: asterisk
--

ALTER TABLE ONLY contact_phone
    ADD CONSTRAINT cp_phone_fk FOREIGN KEY (mac, port) REFERENCES phone(mac, port) MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: ec_contact_fk; Type: FK CONSTRAINT; Schema: public; Owner: asterisk
--

ALTER TABLE ONLY exten_contact
    ADD CONSTRAINT ec_contact_fk FOREIGN KEY (contact_id) REFERENCES contact(contact_id) MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: ec_exten_fk; Type: FK CONSTRAINT; Schema: public; Owner: asterisk
--

ALTER TABLE ONLY exten_contact
    ADD CONSTRAINT ec_exten_fk FOREIGN KEY (virt_exten) REFERENCES virt_exten(virt_exten) MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: in_exten_fk; Type: FK CONSTRAINT; Schema: public; Owner: asterisk
--

ALTER TABLE ONLY inbound_nos
    ADD CONSTRAINT in_exten_fk FOREIGN KEY (virt_exten) REFERENCES virt_exten(virt_exten) MATCH FULL ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- Name: pbook_src_fk; Type: FK CONSTRAINT; Schema: public; Owner: asterisk
--

ALTER TABLE ONLY pbook
    ADD CONSTRAINT pbook_src_fk FOREIGN KEY (src_host) REFERENCES pbook_src(src_host) MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: rate_fk; Type: FK CONSTRAINT; Schema: public; Owner: asterisk
--

ALTER TABLE ONLY rate_pfx
    ADD CONSTRAINT rate_fk FOREIGN KEY (name) REFERENCES rate(name) MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: rate_res_fk; Type: FK CONSTRAINT; Schema: public; Owner: asterisk
--

ALTER TABLE ONLY rate_res
    ADD CONSTRAINT rate_res_fk FOREIGN KEY (rate_name) REFERENCES rate(name) MATCH FULL ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- PostgreSQL database dump complete
--


CREATE AGGREGATE concat (
    BASETYPE = text,
    SFUNC = textcat,
    STYPE = text,
    INITCOND = ''
);
